/**
 * Created by cb on 2016/8/9.
 */
angular.module('tmjia.controllers.ask', [])

    .controller('AskIndexCtrl', function ($scope, $state, $rootScope, $timeout, $ionicModal,ModalFactory,Utile,$ionicScrollDelegate, url, AskIndexFactory) {
    	$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
        $scope.showloading = true;
        $scope.jlgwList = [];
        $scope.boxStyle = { width: '100%' };
        $scope.hasNextPage = true;

        $scope.cateid = 0; // 热门id原先是5 现在改为0
        Utile.doRefresh($scope);
        //列表更新广播事件抓取
        $scope.$on('asklist.updated', function () {
            $scope.list = AskIndexFactory.getList();
            $scope.hasNextPage = AskIndexFactory.hasNextPage();
            $scope.showloading = false;
        });
        $scope.$on('ask.jlgwlist.updated', function () {
            $scope.jlgwList = AskIndexFactory.getJlgwList();
            $scope.boxStyle = { width: $scope.jlgwList.length * 205 + 'px' };
        });
        $scope.$on('$ionicView.beforeLeave', function (event, viewData) {
        		$scope.closeJzModal();
        });
        //上拉加载
        $scope.loadMore = function() {
            AskIndexFactory.loadList();
        };

        //是否存在下一页判断
        $scope.hasNextPage = function() {
            return AskIndexFactory.hasNextPage();
        };
        var param = {
            page : 1,
            catetype : $scope.cateid
        };

        $ionicModal.fromTemplateUrl('templates/modal/loginModal.html', {
            scope: $scope,
            animation: 'slide-in-up',
            controller: 'loginCtrl'
        }).then(function(modal) {
            $scope.loginmodal = modal;
        });
        $scope.openLoginModal = function() {
            $scope.loginmodal.show();
        };
        $scope.closeLoginModal = function() {
            $scope.loginmodal.hide();
        };

        $scope.gotoAsk = function() {
            if ($rootScope.islogin) {
                $state.go('ask_ask');
            } else {
                $scope.openLoginModal();
            }
        };
        $scope.gotoMyask = function() {
            if ($rootScope.islogin) {
                $state.go('ask_myask');
            } else {
                $scope.openLoginModal();
            }
        };
        $scope.gotokeyword = function () {
			$state.go('ask_keyword');
		};
		//拖动下拉条顶部变颜色
		$scope.scrolltop = 0;
		$scope.onDrag2 = function ($event) {
			$scope.scrolltop = $ionicScrollDelegate.$getByHandle('mainScroll').getScrollPosition().top;
		};
        AskIndexFactory.reloadList(param);
        AskIndexFactory.loadJlgwList();
        ModalFactory.loadJzModal($scope);
    })
    .controller('AskListCtrl', function ($scope, $state, $rootScope, AskListFactory) {
    	init();
		function init() {
			initParams();
			addListeners();
			addMethods();
		}
		function initParams() {
			$scope.catetype = 0;
			$scope.params = [{
				page: 1,
				hotflag: true,
				keywords: '',
				isback: 1,
				catetype: 2
			}, {
				page: 1,
				hotflag: true,
				keywords: '',
				isback: 1,
				catetype: 3
			}];
			$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
			$scope.result = [{ list: [], isover: false }, { list: [], isover: false }];
			$scope.keyword = '';
			$scope.issearched = false;
		}
		function addMethods() {
			//上拉加载
			$scope.loadMore = function () {
				var bc = 'ask.list.list.' + $scope.catetype;
				AskListFactory.getList($scope.params[$scope.catetype], bc).then(function(result) {
					$scope.result[$scope.catetype] = result;
					$scope.issearched = true;
					$rootScope.$broadcast('scroll.infiniteScrollComplete');
				}).catch(function() {
					$rootScope.$broadcast('scroll.infiniteScrollComplete');
				});
			};
			//是否存在下一页判断
			$scope.hasNextPage = function () {
				return !$scope.result[$scope.catetype].isover;
			};

			$scope.changecatetype = function (catetype) {
				if ($scope.catetype != catetype) {
					$scope.catetype = catetype;
					if ($scope.result[$scope.catetype].list.length == 0) {
						$scope.result[$scope.catetype].isover = true;
						$scope.loadMore();
					}
				}
			}
			$scope.gotokeyword = function () {
				$state.go('ask_keyword');
			};
		}
		function addListeners() {
			//返回按钮
			$scope.$on('$ionicView.beforeEnter', function (event, viewData) {
				viewData.enableBack = true;
			});

			$scope.$on('$ionicView.enter', function (event, viewData) {
				if ($rootScope.ask_keyword_search) {
					$scope.params[$scope.catetype].keywords = $rootScope.ask_keyword;
					$rootScope.ask_keyword = '';
					$scope.result[$scope.catetype].isover = true;
					$scope.result[$scope.catetype].list = [];
					$scope.params[$scope.catetype].page = 1;
					$scope.loadMore();
					$rootScope.ask_keyword_search = false;
				}
			});
		}
	})
    .controller('AskKeywordCtrl', function ($scope, $rootScope, $timeout, $state, $sce, ModalFactory, AskKeywordFactory) {
    	init();
    	function init() {
    		initParams();
    		addListeners();
    		addMethods();
    		// 广告位延迟0.5秒显示,避免ios上面焦点问题
    		$timeout(function () {
    			$scope.showdelay = false;
    		}, 500);
    		loadhistory();
    		loadSearchAdvInfo();
    		addModals();
    	}
    	function initParams() {
    		$scope.keyword = { value: '' };
    		$scope.adList = [];
    		$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
    		$scope.showdelay = true;
    	}
    	function addListeners() {
    		$scope.$on('$ionicView.enter', function (event, viewData) {
    			if ($rootScope.ask_keyword && $scope.keyword.value != $rootScope.ask_keyword) {
    				$scope.keyword.value = $rootScope.ask_keyword;
    				$scope.keywordsearch();//重新进入搜索页时，搜索关键字缓存在页面上时，执行搜索操作
    			}
    		});
    	}
    	function addMethods() {
    		// 点击历史搜索词条
    		$scope.goSearchlist = function (keywords) {
    			$state.go('ask_keywordlist', {
    				keywords: keywords
    			});
    		};
    		// 输入框输入时搜索
    		$scope.keywordsearch = function (input) {
    			$timeout(setinput, 200);
    		}
    		$scope.loadlist = function () {
    			if ($scope.keyword.value) {
    				AskKeywordFactory.searchList($scope.keyword.value).then(function (result) {
    					var list = AskKeywordFactory.handleSearchList(result, $scope.keyword.value).list;
    					$scope.list = list.slice(0, 6);
    				});
    			}
    		};
    		$scope.gotoask = function () {
    			AskKeywordFactory.goToAsk($scope);
    		};
    	}
    	function addModals() {
    		AskKeywordFactory.addLoginModal($scope);
    	}
		function setinput() {
			$scope.input = $scope.keyword.value;
			if ($scope.input == $scope.keyword.value) {
				$rootScope.ask_keyword = $scope.keyword.value;
				sethistory();
				$scope.loadlist();
			}
			if (!$scope.keyword.value) {//当搜索关键字被清空后，显示历史搜索
				loadhistory();
			}
		}
		function loadhistory() {
			$scope.historylist = AskKeywordFactory.getHistory();
		}
		function sethistory() {
			AskKeywordFactory.setHistory($scope.historylist);
		}
		$scope.clearhistory = function () {
			AskKeywordFactory.clearHistory();
			$scope.historylist = [];
		}
		// 广告位加载
		function loadSearchAdvInfo() {
			AskKeywordFactory.getAdvs().then(function(result) {
				$scope.adList = result;
			});
		}
	})
    .controller('AskSearchListCtrl', function ($scope, $rootScope, $state, $stateParams, $sce, AskKeywordFactory, ModalFactory) {
    	init();
    	function init() {
    		initParams();
    		addMethods();
    		loadhistory();
    		addModals();
    	}
    	function initParams() {
    		$scope.params = {
				page: 1,
				titlekeywords: $stateParams.keywords || ''
			}
			$scope.keywords = $stateParams.keywords;
			$scope.result = { list: [], isover: false };
			$scope.issearched = false;
    	}
    	function addMethods() {
    		//上拉加载
    		$scope.loadMore = function () {
    			AskKeywordFactory.searchList($scope.params).then(function (result) {
    				$scope.result = AskKeywordFactory.handleSearchList(result, $scope.keywords);
    				$rootScope.$broadcast('scroll.infiniteScrollComplete');
    			});
    		};
    		//是否存在下一页判断
    		$scope.hasNextPage = function () {
    			return !$scope.result.isover;
    		};
    	}

		function loadhistory() {
			$scope.historylist = AskKeywordFactory.getHistory();
		}
		function sethistory() {
			AskKeywordFactory.setHistory($scope.historylist);
		}
		$scope.gotokeyword = function () {
			$state.go('ask_keyword');
		};
		$scope.gotoask = function () {
			AskKeywordFactory.goToAsk($scope);
		};
		function addModals() {
			AskKeywordFactory.addLoginModal($scope);
		}
	})
	.controller('AskDetailCtrl', function ($scope, $rootScope, $state, AdFactory, Utile, $timeout, $ionicModal, $stateParams, ModalFactory, $ionicActionSheet, url, AskDetailFactory) {
    	//返回按钮
        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            viewData.enableBack = true;
        });
        $scope.showaskad = false;
        //广告位
        AdFactory.loadAd(99914);
        Utile.doRefresh($scope);
        $scope.$on('ad.updated', function () {
        	if(!$scope.ask_ad) {
        		$scope.ask_ad = AdFactory.getAd();
        	}
            if($scope.ask_ad.length > 0) {
            	$scope.showaskad = true;
            }
        });

        $scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
        $scope.showloading = true;

        $scope.$on('$ionicView.beforeLeave', function (event, viewData) {
        	$scope.closeJzModal();
         });
        //广播事件抓取
        $scope.$on('askdetail.updated', function () {
            $scope.content = AskDetailFactory.getInfo();
            $scope.showloading = false;
        });

        AskDetailFactory.loadInfo($stateParams.cateid);
        // 分享按钮弹出
        $scope.shareshow = function() {
            $rootScope.shareobj(5,$stateParams.cateid);
        };
        var wxurl = 'ionic/#/ask/detail/' + $stateParams.cateid;
        var wxtitle = '购房帮帮团-专家来帮忙';
        var wxdesc = '专业权威的专家团为你提供买房卖房提供参谋...';
        $rootScope.isWeiXin(wxurl, wxtitle, wxdesc);
        $scope.gotokeyword = function() {
        	$state.go('ask_keyword');
        };
        $scope.gotochat = function () {
			// 跳转前要先判断用户是否已经登录
			if ($rootScope.islogin) {
				$state.go('message_aiquestion');
			} else {
				$scope.openLoginModal();
			}
		}
        ModalFactory.loadJzModal($scope);
    })
    .controller('MyAskListCtrl', function ($scope, $rootScope, $stateParams, MyAskListFactory) {
    	init();
    	function init() {
    		initParams();
    		addListeners();
    		getList();
    	}
    	function initParams() {
            $scope.result = { list: [], isover: false };
            $scope.params = { page: 1 };
    	}
        function addListeners() {
        	//返回按钮
            $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
                 viewData.enableBack = true;

            });
        }
        function getList() {
        	MyAskListFactory.getList($scope.params).then(function(result) {
				$scope.result = result;
			});
        }
    })
    .controller('SubAskCtrl', function ($scope, $rootScope, $ionicModal, $stateParams, $state, url, SubAskFactory) {
    	//返回按钮
        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
             viewData.enableBack = true;
        });
        var msg;
        $scope.info = {
            webDjginfo_catecontent:''
        };
        $scope.count = 150;
        $scope.countchar = function(){
            $scope.count = 150 - $scope.info.webDjginfo_catecontent.length;
        }
        //列表更新广播事件抓取
        $scope.$on('AskInfo.submitted', function () {
            msg = SubAskFactory.getMsg();
            if (!msg.flag) {
                $rootScope.alert(msg.msg);
            } else {
            	$scope.info.webDjginfo_catecontent = '';
                $rootScope.alert('提交成功，将尽快给您答复！');
            }
        });

        $scope.submit = function() {
            if ($scope.info.webDjginfo_catecontent == '') {
                $rootScope.alert('请先输入要咨询的内容！');
            } else {
                SubAskFactory.submit($scope.info);
            }
        }
    })
    .directive('askMylistHatch', function ($rootScope, $state, ModalFactory) {
		return {
			restrict: 'E',
			transclude: true,
			scope: {},
			template: '<a class="button button-clear relativeP" style="margin-right:10px;" ng-click="gotomylist();">'
				+ '<i class="icon" ng-class="{true: \'iconfont24 f_white\', false: \'iconfont20 f_gray2\'}[isindex]">&#xe778;</i>'
				+ '</a>',
			link: function (scope, element, attrs) {
				scope.isindex = attrs.isindex == 'true';
				//加载弹出层
				ModalFactory.loadLoginModal(scope);//关联会员登陆弹出层
				scope.gotomylist = function () {
					if ($rootScope.islogin) {
						$state.go('ask_mylist');
					} else {
						// 登录
						scope.openLoginModal();
					}
				};
			}
		};
	})
	.directive('askHatch', function ($rootScope, $state, ModalFactory) {
		return {
			restrict: 'E',
			transclude: true,
			scope: {},
			template: '<div class="order text-center " ng-click="gotoask()">'
				+ '<div class="ask-line18 margin-top3">'
				+ '<i class="iconfont18 f_white">&#xe77c;</i>'
				+ '</div>'
				+ '<div class="ask-line16 f12 light">'
				+ '提问'
				+ '</div>'
				+ '</div>',
			link: function (scope, element, attrs) {
				//加载弹出层
				ModalFactory.loadLoginModal(scope);//关联会员登陆弹出层
				scope.gotoask = function () {
					if ($rootScope.islogin) {
						$state.go('ask_ask');
					} else {
						// 登录
						scope.openLoginModal();
					}
				};
			}
		};
	})
;
