angular.module('tmjia.controllers.broker', [])
    .controller('brokerIndexCtrl', function ($scope, $state, $rootScope, url, UDIP) {
        init();
        function init() {
        	initParams();
        	addMethods();
        }
        function initParams() {
        	$scope.list = { list: [1], isover: false };
        	$scope.params = {
        		page: 1,
        		distance: '',
        		areaid: '',
        		pp: '',
        		xydj: ''
        	};
        }
        var qylisturl = url.jjjg.qylist;
        $scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
        function addMethods() {
    		//上拉加载
    		$scope.loadMore = function() {
    			UDIP.loadobject(qylisturl, $scope.params, 'broker.list.list').then(function (result) {
    				$scope.list = result;
    				$scope.$broadcast('scroll.infiniteScrollComplete');
    				$scope.$broadcast('scroll.refreshComplete');
    			}).catch(function() {
    				$rootScope.alert('加载失败!');
    				$scope.list.isover = true;
    				$scope.$broadcast('scroll.infiniteScrollComplete');
    				$scope.$broadcast('scroll.refreshComplete');
    			});
    		};
    		//是否存在下一页判断
    		$scope.hasNextPage = function() {
    			return !$scope.list.isover;
    		};
    		$scope.doRefresh = function() {
				$scope.params.page = 1;
				$scope.list.isover = true;
				$scope.loadMore();
    		};
    	}
    })
    .controller('brokerSearchCtrl', function($scope, $state, $rootScope, $timeout, url, UDIP) {
    	var KEY = '_broker_search_list_';
    	init();
        function init() {
        	initParams();
        	addMethods();
        	addListeners();
        }
        function initParams() {
        	$scope.keyword = { value: '' };
        	$scope.historyList = [];
        	$scope.list = [];
        	$scope.id = $scope.$id;
        }
        function addMethods() {
    		$scope.search = (function() {
    			var timer;
    			return function(input) {
    				var keyword = input.keyword.value;
    				if (angular.isUndefined(keyword)) {
    					return;
    				}
    				timer && $timeout.cancel(timer);
    				$scope.list = [];
    				timer = $timeout(function() {
    					doSearch(keyword);
    				}, 300);
    			}
    		})();
    		$scope.clearHistory = function() {
    			clearHistory();
    			$scope.historyList = [];
    		};
    		$scope.goDetail = function(item) {
    			saveHistory(item);
    			$state.go('broker_detail', { brokerageid: item.brokerageid });
    		};
    		$scope.handleHisClick = function(item) {
    			$scope.keyword.value = item.name;
    			saveHistory(item);
    			doSearch($scope.keyword);
    		}
    	}
        function addListeners() {
        	$scope.$on('$ionicView.enter', function (event, viewData) {
    			$scope.historyList = loadHistory();
    			document.getElementById('searchkeyword_' + $scope.id).focus();
    			$timeout(function () {
    				document.getElementById('searchkeyword_' + $scope.id).focus();
    			}, 1000);
    			if (typeof (cordova) != 'undefined') {
    				cordova.plugins.Keyboard.show();
    			}
    		});
        }
        function doSearch(keyword) {
        	UDIP.loadobject(url.jjjg.qylist, {
        		keyword: keyword,
        		rp: 20,
        		page: 1
        	}, 'broker.search.list').then(function(result) {
        		if (keyword == $scope.keyword.value) {
        			var list = [];
        			for (var i = 0; i < result.list.length; i++) {
        				temp = result.list[i].brokeragename.split(keyword);
        				// 判断是否找到匹配
    					if (temp.length > 1) {
    						str = '';
							for (j in temp) {
								str += (j != 0 ? '<i class="tm-orange">' + keyword + '</i>' : '') + temp[j];
							}
    						list.push({
    							str: str,
    							name: result.list[i].brokeragename,
    							brokerageid: result.list[i].brokerageid
    						});
    					}
        			}
        			$scope.list = list;
        		}
        	});
        }
        function loadHistory() {
        	var history = localStorage.getItem(KEY);
        	return history ? JSON.parse(history) : [];
        }
        function saveHistory(info) {
        	var idx = -1;
        	var historyList = loadHistory();
        	angular.forEach(historyList, function(item, i) {
        		if (item.brokerageid == info.brokerageid) {
        			idx = i;
        		}
        	});
        	if (i != -1) {
        		historyList.splice(i, 1);
        		historyList.unshift(info);
        	} else {
        		historyList.push(info);
        	}
        	$scope.historyList = historyList;
        	localStorage.setItem(KEY, JSON.stringify(historyList));
        }
        function clearHistory() {
        	localStorage.removeItem(KEY);
        }
    })
    // 企业详情
    .controller('brokerDetailCtrl', function ($scope, $stateParams, $state, $rootScope, $ionicActionSheet, url, UDIP, BrokerDetailFactory) {
        init();
        function init() {
        	initParams();
        	addMethods();
        	getDetail();
        	getMdList();
        	getJlgwList();
        	getCsList();
        	getCzList();
        }
        function initParams() {
        	$scope.detail = {};
        	brokerageid = $stateParams.brokerageid;
        	$scope.tab = '0';
        	$scope.mdList = [0];
        	$scope.jlgwList = [1];
        	$scope.csList = { list: [], isover: false };
        	$scope.czList = { list: [], isover: false };
        	$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
        }
        function addMethods() {
    		$scope.changeTab = function(tab) {
    			$scope.tab = tab;
    			if (tab == '0' && !$scope.csList.length) {
    				getCsList();
    			} else if (tab == '1' && !$scope.czList.length) {
    				getCzList();
    			}
    		};
    		$scope.share = function() {
    			$rootScope.shareobj(4, $scope.detail);
    		};
    	}
        function getDetail() {
        	BrokerDetailFactory.getDetail({ brokerageid: $stateParams.brokerageid, rp: 4 }).then(function (result) {
        		$scope.result = result;
        		$scope.detail = result.qydetail;
			});
        }
        // 门店
        function getMdList() {
        	BrokerDetailFactory.getMdList({ brokerageid: $stateParams.brokerageid, rp: 4 }).then(function (result) {
        		$scope.result = result;
        		$scope.mdList = result.list;
			});
        }
        // 经纪人
        function getJlgwList() {
        	BrokerDetailFactory.getJlgwList({ brokerageid: $stateParams.brokerageid, rp: 4 }).then(function (result) {
        		$scope.jlgwList = result;
			});
        }
        // 出售房源
        function getCsList() {
        	BrokerDetailFactory.getCsList({ brokerageid: $stateParams.brokerageid, rp: 4 }).then(function (result) {
        		$scope.csList = result;
			});
        }
        // 出租房源
        function getCzList() {
        	BrokerDetailFactory.getCzList({ brokerageid: $stateParams.brokerageid, rp: 4 }).then(function (result) {
        		$scope.czList = result;
			});
        }
    })

    // 门店详情
    .controller('brokerMdDetailCtrl', function ($scope, $state, $stateParams, $rootScope, $ionicActionSheet, url, UDIP, BrokerDetailFactory) {
    	init();
        function init() {
        	initParams();
        	addMethods();
        	getMdDetail();
        	getMdJlgwList();
        	getMdCsList();
        	getMdCzList()
        }
        function initParams() {
        	$scope.detail = {};
        	$scope.tab = '0';
        	$scope.jlgwList = [1];
        	$scope.csList = { list: [], isover: false };
        	$scope.czList = { list: [], isover: false };
        }
        function addMethods() {
    		$scope.changeTab = function(tab) {
    			$scope.tab = tab;
    			if (tab == '0' && !$scope.csList.length) {
    				getMdCsList();
    			} else if (tab == '1' && !$scope.czList.length) {
    				getMdCzList();
    			}
    		};
    		$scope.share = function() {
    			$rootScope.shareobj(4, $scope.detail);
    		};
    	}
        function getMdDetail() {
        	BrokerDetailFactory.getMdDetail({ storesid: $stateParams.storesid, rp: 4 }).then(function (result) {
        		$scope.result = result;
        		$scope.mddetail = result.mddetail;
			});
        }
        // 经纪人
        function getMdJlgwList() {
        	BrokerDetailFactory.getMdJlgwList({ storesid:$stateParams.storesid, rp: 4 }).then(function (result) {
        		$scope.jlgwList = result;
			});
        }
        // 出售房源
        function getMdCsList() {
        	BrokerDetailFactory.getMdCsList({ storesid:$stateParams.storesid, rp: 4 }).then(function (result) {
        		$scope.csList = result;
			});
        }
        // 出租房源
        function getMdCzList() {
        	BrokerDetailFactory.getMdCzList({ storesid:$stateParams.storesid, rp: 4 }).then(function (result) {
        		$scope.czList = result;
			});
        }
    })
    .directive('brokerIndexFilter', function($state, ModalFactory, UDIP, url, searchcondition, $rootScope) {
    	return {
    		restrict: 'E',
            templateUrl: 'templates/broker/brokerindexfilter.html',
            link: function (scope) {
            	init();
            	function init() {
            		initParams();
            		addMethods();
            		addListeners();
            		addModals();
            	}
            	function initParams() {
            		scope.brokerDistance = searchcondition.brokerdistancelist;
            		scope.brokerArea = searchcondition.gfz_cyh_arealist;
            		scope.brokerPp = [
                    	{value: '', name: '不限'},
                    	{value: '0_10000', name: '我爱我家'},
                        {value: '10000_15000', name: 'Q房网'},
                        {value: '15000_20000', name: '链家'},
                        {value: '20000_25000', name: '绿城'}
                    ];
            		scope.brokerXydj = [
            			{value: '', name: '不限'},
                    	{value: '0_10000', name: '等级1'}
            		];
            		scope.brokerSubway = searchcondition.sz_subway;
            		scope.choseTab = 0;
            		scope.areaid = '';
            		scope.areaList = [];
            		scope.psubid = '';
            	}
            	function addMethods() {
            		scope.goMap = function() {
            			$state.go('property_map');
            		};
            		scope.goSearch = function() {
            			$state.go('broker_search');
            		};
            		// 添加区域modal的事件
            		addQyModalMethods();
            		// 添加信用等级modal的事件
            		addXydjModalMethods();
            	}
            	// 添加区域modal的事件
                function addQyModalMethods() {
                	scope.clearQyParams = function() {
                		scope.closeBrokerQyModal();
                		scope.params.distance = 0;
                		scope.areaid = '';
                		scope.params.areaid = '';
                		scope.psubid = '';
                		scope.params.subidzoom = '';
                		scope.doRefresh();
                	};
                	scope.confirmQyParams = function() {
                		scope.closeBrokerQyModal();
                		if (scope.params.distance != '') {
                			scope.params.lng = $rootScope.Bposition.x;
                			scope.params.lat = $rootScope.Bposition.y;
                		} else {
                			scope.params.lng = '';
                			scope.params.lat = '';
                		}
                		scope.doRefresh();
                	};
                	scope.choseQyTabs = function(idx) {
                		scope.choseTab = idx;
                	};
                	scope.choseDistance = function(distance) {
                		scope.params.distance = distance;
                	};
                	scope.choseArea = function(areaid) {
                		scope.params.areaid = areaid;
                	};
                	scope.choseCqArea = function(areaid) {
                		scope.params.areaid = scope.areaid = areaid;
                		// 城区选择不限
                		if (areaid == '') {
                			scope.confirmQyParams();
                		} else {
                    		getAreaList();
                		}
                	};
                	scope.choseSubway = function(subidzoom) {
                		scope.params.subidzoom = subidzoom;
                	}
                	scope.choseSupSubway = function(psubid) {
                		scope.params.subidzoom = scope.psubid = psubid;
                		// 城区选择不限
                		if (psubid == '') {
                			scope.confirmQyParams();
                		} else {
                			getSubwayList();
                		}
                	}
                }
                // 添加信用等级modal的事件
                function addXydjModalMethods() {
                	scope.confirmXydjParams = function() {
                		scope.closeBrokerXydjModal();
                		scope.doRefresh();
                	};
                	scope.choseXydj = function(xydj) {
                		scope.params.xydj = xydj;
                	}
                }
                function getAreaList() {
                	if (getAreaList[scope.areaid]) {
                		scope.areaList = getAreaList[scope.areaid];
                		return;
                	}
                	UDIP.loadobject(url.esf.cqarealist, { pareaid: scope.areaid }, 'broker.area.list').then(function(result) {
                		scope.areaList = getAreaList[scope.areaid] = result.list;
                	});
                }
                function getSubwayList() {
                	// /tmj3/tmj_subwaystation
                	if (getSubwayList[scope.psubid]) {
                		scope.subwayList = getSubwayList[scope.psubid];
                		return;
                	}
                	UDIP.loadobject(url.tmj.subwaystation, { psubid: scope.psubid }, 'broker.subway.list').then(function(result) {
                		scope.subwayList = getSubwayList[scope.psubid] = result.list;
                	});
                }
                function addListeners() {
                	scope.$on('$ionicView.beforeLeave', function (event, viewData) {
                		ModalFactory.closeAllModal(['brokerQyModal', 'brokerXydjModal'], scope);
                	});
                }
                function addModals() {
                	ModalFactory.init(['brokerQyModal', 'brokerXydjModal'], scope);
                }
            }
    	};
    })
    .directive('brokerItem', function($state) {
    	return {
    		restrict: 'E',
            template: '<div class="padding-horizontal20 mechanism margin-topf1">' +
				'<a ng-click="goDetail(info)" class="relativeP display-block">' +
					'<div class="mechanism-left">' +
						'<img src="images/house-photo-jiazai.png" ng-src="{{_INIT_IMG_YUMING}}/{{info.showlogo}}" onerror="this.src=\'images/house-photo-jiazai.png\'"/>' +
					'</div>' +
					'<div class="mechanism-right">' +
						'<div class="f16 grey3 padding-top10">' +
							'{{info.Storesname || info.brokeragename}} <img class="vertical-middle margin-left5" src="images/beian.png" width="13px" />' +
						'</div>' +
						'<div class="f14 yellow02 margin-top3">' +
							'[信用等级] B级' +
						'</div>' +
						'<div class="grey3 f12 margin-top1">' +
							'门店地址：{{info.comaddress || info.Storeaddr}}<i class="iconfont12 display-inline-block vertical-middle2 margin-left5 grey9">&#xe66f;</i>' +
						'</div>' +
						'<div class="f12 grey9 margin-top1 padding-bottom10">' +
							'统一社会信用代码：{{info.businessno}}' +
						'</div>' +
					'</div>' +
				'</a>' +
			'</div>',
            scope: {
            	info: '=',
            	md: '@'
            },
            link: function(scope) {
            	scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
            	scope.goDetail = function(info) {
//            		var url = scope.md ? 'broker_mddetail' : 'broker_detail';
//            		$state.go(url, { brokerageid: info.brokerageid });
//            		$state.go(url, { brokerageid: info.brokerageid });
            		if (scope.md) {
            			$state.go('broker_mddetail',{storesid: info.storesid})
            		} else {
            			$state.go('broker_detail',{brokerageid: info.brokerageid})
            		}
            	};
            }
    	};
    })
    .directive('brokerJlgwItem', function($rootScope, $state, $ionicModal) {
    	return {
    		restrict: 'E',
            template: '<div class="relativeP">' +
		    	'<a ng-click="gotojlgwdetail(info.brokerid)" class="agent-list padding20 bordeBottomE">' +
		    		'<div class="agent-list-img" style="width: 45px;height: 45px;">' +
		    			'<img style="width: 45px;height: 45px;border-radius: 22.5px;" err-src="images/agent-people.png" ng-src="{{_INIT_IMG_YUMING}}/{{info.showimg}}" />' +
		    		'</div>' +
		    		'<div class="agent-list-jinling3" style="top: 50px;left: 55px;">' +
		    			'<img src="images/jjr-new-bg01.png"/>' +
		    		'</div>' +
		    		'<div class="agent-list-mian2" style="padding-left: 65px;">' +
		    			'<div class="f16 f_gray margin-top2 toverF">{{info.realname}}' + 
		    				'<img ng-if="info.iscertificate == 1" width="43" class="vertical-middle margin-left5" src="images/rzjlgw.png"/>' +
		    			'</div>' +
		    			'<div class="f12 f_gray3 toverF margin-top10">' +
		    				'<div class="toverF fl" style="max-width: 60px;">{{info.recommname}}</div>' +
		    				'<div class="fl toverF" style="width: calc(100% - 60px);">丨{{info.storesname}}</div>' +
		    				'<div class="clear"></div>' +
		    			'</div>' +
		    			'<div class="f12 f_gray3 toverF margin-top3">在售 <span class="f_gray2">{{info.gpnum}} </span>套 / 在租  <span class="f_gray2">{{info.czcount}} </span>套</div>' +
		    			'<div class="f12 f_gray3 toverF margin-top3">主营：' +
		    				'<span class="f_gray2" ng-repeat="zy in info.communititylist">{{$index != 0 ? " | " : ""}}{{zy.communityname}}</span>' +
			    		'</div>' +
			    	'</div>' +
			    '</a>' +
			    '<div class="home-adviser-right" style="top: 34px;right: 15px;">' +
	    			'<div ng-click="gotochat(info.webaccountid, info.brokerid);" class="home-adviser-right-main fl">' +
	    				'<i class="iconfont20">&#xe76e;</i>' +
	    			'</div>' +
	    			'<a href="tel:{{info.usermobile}}" class="home-adviser-right-main fr">' +
	    				'<i class="iconfont20">&#xe76f;</i>' +
	    			'</div>' +
	    			'<a class="clear"></div>' +
				'</div>' +
		    '</div>',
            scope: {
            	info: '='
            },
            link: function(scope) {
            	scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
            	scope.gotojlgwdetail = function(b) {
            		$state.go('adviser_mian', {
						brokerid: b
					});
				}
            	scope.gotochat = function (w, b) {
            		// 跳转前要先判断用户是否已经登录
        			if ($rootScope.islogin) {
        				if (w == 'adminbbt') {
        					$state.go('message_aiquestion');
        				} else {
        					$state.go('message_chat', { webaccountid: w, brokerid: b });
        				}
        			} else {
        				scope.openLoginModal();
        			}
            	}
            	$ionicModal.fromTemplateUrl('templates/modal/loginModal.html', {
        			scope: scope,
        			animation: 'slide-in-up',
        			controller: 'loginCtrl'
        		}).then(function(modal) {
        			scope.loginmodal = modal;
        		});
        		scope.openLoginModal = function() {
        			scope.loginmodal.show();
        		};
        		scope.closeLoginModal = function() {
        			scope.loginmodal.hide();
        		};
            }
    	};
    })
    .directive('brokerCsfyItem', function() {
    	return {
    		restrict: 'E',
    		template: '<div class="padding-left20 bordeBottomE">' +
    			'<a href="#/gpfy/gpxxinfo/{{info.fwcode}}/{{info.xqid}}" class="home-house padding-right20 display-block border-none">' +
    				'<div class="home-house-left">' +
    					'<img width="100%" ng-src="{{ _INIT_IMG_YUMING}}/{{info.img}}" err-src="images/loadingpic0527.png" />' +
    				'</div>' +
    				'<div class="home-house-right">' +
    					'<div class="height1"></div>' +
    					'<div class="line20 grey3 f16 margin-top7 overflow-txt">{{info.fymc}}</div>' +
    					'<div class="line20 grey9 f12 overflow-txt">{{info.areaname}} | {{info.szlcname}}(共{{info.zzcs}}层) | {{info.zxbzname}} </div>' +
    					'<div class="margin-top5 overflow-txt margin-right5 ">' +
    						'<img ng-if="info.gpfyid != 0" src="images/home-house-gp.png" height="16px" class="display-inline-block fl margin-right5 margin-bottom5" />' +
    						'<div ng-if="info.school" class="display-inline-block blue04 bg-blue04 margin-right5 line16 padding-horizontal4 f10 margin-bottom5 fl">{{info.school}}</div>' +
    						'<div ng-if="info.zxbzname" class="display-inline-block blue04 bg-blue04 margin-right5 line16 padding-horizontal4 f10 margin-bottom5 fl">{{info.zxbzname}}</div>' +
    						'<div class="clear"></div>' +
    					'</div>' +
    					'<div class="red01 f14 overflow-txt">{{info.price}}万<span class="f12 grey6 margin-left10">{{info.singleprice}}元/㎡</span></div>' +
    				'</div>' +
    			'</a>' +
    		'</div>',
    		scope: {
    			info: '='
    		},
    		link: function(scope) {
            	scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
            }
    	};
    })
    .directive('brokerCzfyItem', function() {
    	return {
    		restrict: 'E',
    		template: '<div class="padding-left20 bordeBottomE">' +
				'<a href="#/rent/detail/{{info.fwid}}/{{info.communityid}}" class="home-house padding-right20 display-block border-none">' +
					'<div class="home-house-left">' +
						'<img ng-if="info.coverfrom == 1" width="100%" ng-src="{{_INIT_ZL_IMG_YUMING}}/{{info.cover}}" err-src="images/loadingpic0527.png" />' +
						'<img ng-if="info.coverfrom == 2" width="100%" ng-src="{{_INIT_IMG_YUMING}}/{{info.cover}}" err-src="images/loadingpic0527.png" />' +
					'</div>' +
					'<div class="home-house-right">' +
					'<div class="height1"></div>' +
					'<div class="line20 grey3 f16 margin-top7 overflow-txt">{{info.fymc}}</div>' +
					'<div class="line20 grey6 f12 overflow-txt">{{info.arearmk}} | {{info.communityname}}</div>' +
			 			'<div class="margin-top5 overflow-txt margin-right5">' +
			 				'<div class="display-inline-block pink02 bg-pink02 margin-right5 line16 padding-horizontal4 f10 fl">{{info.czfsValue}}</div>' +
						    '<div class="clear"></div>' +
			 			'</div>' +
			 			'<div class="red01 f14 margin-top3 overflow-txt">' +
			 				'{{info.zjje}}元/月<span class="f12 grey6 margin-left10">{{info.hxs}}室{{info.hxt}}厅 {{info.jzmj}}㎡</span>' +
			 			'</div>' +
			 		'</div>' +
			 	'</a>' +
			'</div>',
    		scope: {
    			info: '='
    		},
    		link: function(scope) {
            	scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
            	scope._INIT_ZL_IMG_YUMING = _INIT_ZL_IMG_YUMING;
            }
    	};
    })
;
