angular.module('tmjia.controllers.evalu', [])

	.controller('EvaluIndexCtrl', function ($scope, $rootScope, $stateParams, $ionicNativeTransitions, $timeout, EvaluFactory) {
		//返回按钮
        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            viewData.enableBack = true;
            if (!$scope.search.communityname) {
            	$scope.showloading = true;
            	$timeout(function () {
            		$scope.showloading = false;
            	}, 100);
            }
        });
        var communityname;

		if($stateParams.communityname){
			communityname = $stateParams.communityname;
		}

        $scope.search = {
        		communityname:'',
        		communityid: 0,
        		zrzid: 0,
        		allfloor: '',
        		floor: '',
        		area:''
        };

        if(communityname || communityname == '' ){
        	$scope.search.communityname = communityname;
        	EvaluFactory.loadBuildingList(communityname);
        }

        $scope.$on('buildingList.complete', function () {

        	$scope.buildinglist = EvaluFactory.getBuildingList();

        	$scope.search.communityid = EvaluFactory.getCommunityId();

        });

        //到二手房搜索页面
        $scope.toSerachKeyWordForEsf = function(){
        	var params = {
        		gotourl : "evaluindex",
        		iscoh:0
        	};
        	$ionicNativeTransitions.stateGo('property_searchkeyword', params);
        };

        //选择楼盘操作
        $scope.selectbuilding = function (zrzid){
        	if(zrzid && $scope.buildinglist){
        		for (var i in $scope.buildinglist){
        			if(zrzid == $scope.buildinglist[i].zrzid){
        				if($scope.buildinglist[i].zcs > 0){
        					$scope.search.allfloor = $scope.buildinglist[i].zcs;
        				}
        				else {
        					$scope.search.allfloor = '';
        				}
        				buildfloor();
        				break;
        			}
        		}
        	}
        };
        //创建楼层
        var floorlist;
        $scope.nofloor=true;
        function buildfloor(){
        	floorlist = new Array();
        	if($scope.search.allfloor && $scope.search.allfloor != '0'){
        		for(var i = 1; i <=$scope.search.allfloor; i ++){
        			var json = {id : i, name : i + '层'};
        			floorlist.push(json);
        		}
        		$scope.nofloor=false;
        	}
        	else{
        		$scope.nofloor=true;
        		$scope.search.allfloor = '';
        		$scope.search.floor = '';
        	}
        	$scope.floorlist = floorlist;
        }

        $scope.goResult = function (){
        	if($scope.search.communityid == ''){
        		$rootScope.alert('请输入正确的小区名称！');
    		}
        	else if($scope.search.floor == ''){
        		$rootScope.alert('请输入楼层信息！');
    		}
        	else if($scope.search.allfloor == ''){
        		$rootScope.alert('请输入总楼层信息！');
    		}
        	else if($scope.search.area == ''){
    			$rootScope.alert('请输入房产面积！');
    		}
        	else {
        		$ionicNativeTransitions.stateGo('evaludetail', $scope.search, {
                    "type": "slide",
                    "direction": "left", // 'left|right|up|down', default 'left' (which is like 'next')
                    "duration": 400 // in milliseconds (ms), default 400
                });
        	}
        }
	})

	.controller('EvaluDetailCtrl', function ($scope, $rootScope, $stateParams, $timeout, EvaluDetailFactory) {
		$scope.showloading = true;

		$scope.search = {
        		communityname:$stateParams.communityname,
        		communityid: $stateParams.communityid,
        		zrzid: $stateParams.zrzid,
        		allfloor: $stateParams.allfloor,
        		floor: $stateParams.floor,
        		area:$stateParams.area
	     };

        $scope.$on('evaludetail.updated', function () {

        	$scope.detail = EvaluDetailFactory.getEvaluDetail();
        	$scope.detailinfo = $scope.detail.community;
        	$scope.price = EvaluDetailFactory.getAssessValue();
        	$scope.money = parseInt($scope.price*$scope.search.area/10000);

        	$scope.priceinfo = EvaluDetailFactory.getPriceInfo();

        	if(!$scope.priceinfo.hspf && !$scope.priceinfo.lspf && !$scope.detailinfo.lastsign){
        		$scope.noMessage = true;
        	}
        	else {
        		$scope.noMessage = false;
        	}

        	if($scope.priceinfo.hspf){
        		$scope.hspfdate = $scope.priceinfo.hspf.tjdate.split(' ')[0];
        	}
        	if($scope.priceinfo.lspf){
        		$scope.lspfdate = $scope.priceinfo.lspf.tjdate.split(' ')[0];
        	}
        	if($scope.detail.lastsign){
        		$scope.stjdate = $scope.detail.lastsign.tjdate.split(' ')[0];
        	}

            $scope.showloading = false;

            if($scope.money != 0 && $scope.money != '') {
                var timer = $timeout(function() {
                    var cksf=parseInt($scope.money * 0.3);
                    var dkze=parseInt($scope.money * 0.7);
                    var zflx=parseInt($scope.money * 0.7 * 1.2);
                    echartForPropertyHouse('evaluDetailBox' + $scope.search.communityid, cksf, dkze, zflx);
                }, 2000 );
            }
        });

        EvaluDetailFactory.loadEvaluDetail($scope.search);

		$scope.oneKey2sale = function () {
			$rootScope.alert('您的房源委托需求已提交，请等待工作人员与您取得联系！');
		}
	})
;
