angular.module('tmjia.controllers.modal', [])
    .controller('propertySearchCtrl', function ($rootScope, $scope, $stateParams, growingIOservice, tgio, tgioConfig) {
        $scope.id = $scope.$id;
        $scope.arealist = [
            {value: 33, name: '不限'},
            {value: 99, name: '附近'},
            {value: '320506', name: '吴中区'},
            {value: '320507', name: '相城区'},
            {value: '320508', name: '姑苏区'},
            {value: '320509', name: '吴江区'},
            {value: '320571', name: '工业园区'},
            {value: '320591', name: '高新区'},
            {value: '320581', name: '常熟市'},
            {value: '320582', name: '张家港市'},
            {value: '320583', name: '昆山市'},
            {value: '320585', name: '太仓市'}
        ];
        $scope.pricelist = [
            {value: '', name: '不限'},
            {value: '0_80', name: '8千元以下'},
            {value: '80_100', name: '8千-1万'},
            {value: '100_150', name: '1-1.5万'},
            {value: '150_200', name: '1.5-2万'},
            {value: '200_250', name: '2-2.5万'},
            {value: '250_300', name: '2.5-3万'},
            {value: '300_350', name: '3-3.5万'},
            {value: '350_400', name: '3.5-4万'},
            {value: '400_9999', name: '4万以上'}
        ];
        $scope.propertytypelist = [
            {value: '', name: '不限'},
            {value: '住宅', name: '住宅'},
            {value: '商贸', name: '商贸'},
            {value: '写字楼', name: '写字楼'},
            {value: '其他', name: '其他'}
        ];
        var searchdata = {
            areaid: $stateParams.areaid || 33,
            propertytype: $stateParams.propertytype || '',
            price: $stateParams.price || '',
            log: '',
            lat: ''
        };
        var p = new BMap.Point($rootScope.Bposition.x || 120.175787, $rootScope.Bposition.y || 30.286377); // 创建点坐标
        $scope.areaid = searchdata.areaid;
        $scope.propertytype = searchdata.propertytype;
        $scope.price = searchdata.price;
        $scope.areasearch = function (area) {
            searchdata.areaid = area.value;
            searchdata.log = ((searchdata.areaid == 99) ? p.lng : '');
            searchdata.lat = ((searchdata.areaid == 99) ? p.lat : '');
        };
        $scope.pricesearch = function (price) {
            searchdata.price = price.value;
        };
        $scope.propertytypesearch = function (type) {
            searchdata.propertytype = type.value;
        };
        $scope.search = function () {
            $scope.modal.hide();
            $scope.modalsearch(searchdata);
            var usermobile;
			if ($rootScope.meminfo) {
				usermobile = $rootScope.meminfo.usermobile;
			} else {
				usermobile = '';
			}
            var property_index_tgio = {
					uuid: localStorage.uuid,
					pagename: 'property_index',
					usermobile: usermobile,
					areaid: $stateParams.areaid || 33,
		            propertytype: $stateParams.propertytype || '',
		            price: $stateParams.price || ''
				};
			tgio.track(tgioConfig.track.property_index, property_index_tgio);
        }
    })
    .controller('loginCtrl', function ($scope, $rootScope, $timeout, $state, LoginFactory, HandlelogFactory, ModalFactory) {
        var logindata_telphone = localStorage.logindata_telphone;
        if (logindata_telphone) {
            logindata_telphone = parseInt(logindata_telphone);
        }
        $scope.logindata = {
            telphone: logindata_telphone || '',
            checkcode: '',
            isagreement : true,
            username: localStorage.logindata_username || '',
            password: ''
        };
        $scope.logintype = 0;
        $scope.checkcodebtn = '获取验证码';
        $scope.$on('login', function () {
            HandlelogFactory.log();
            $scope.loginmodal.hide();
            $scope.logindata.checkcode = $scope.logindata.password = '';
            localStorage.logindata_telphone = $scope.logindata.telphone;
            localStorage.logindata_username = $scope.logindata.username;
            //$state.go('tab.my_index');   //默认消失窗口即可。跳转仅一个页面用到
        });
        $scope.$on('loginwithoutmembername', function () {
            HandlelogFactory.log();
            //$scope.loginmodal.hide();
            $scope.logindata.checkcode = $scope.logindata.password = '';
            localStorage.logindata_telphone = $scope.logindata.telphone;
            localStorage.logindata_username = $scope.logindata.username;
            // $state.go('tab.my_index');   //默认消失窗口即可。跳转仅一个页面用到
            $scope.$ionicGoBack()
        });
        $scope.changelogintype = function (index) {
            $scope.logintype = index;
        };
        var reg=/^(13[0-9]|15[0-3,5-9]|16[6]|17[0135678]|18[0-9]|19[89])\d{8}$/;
        var reg2=/^[0-9]{6}$/;
        $scope.login = function () {
            if ($scope.logindata.telphone == "") {
                $rootScope.alert("请输入正确的手机号码！");
            }else if(!reg.test($scope.logindata.telphone)){
            	$rootScope.alert("请输入正确的手机号码！");
            }else if($scope.logindata.checkcode == "") {
                $rootScope.alert("请先获取验证码");
            }else if(!reg2.test($scope.logindata.checkcode)){
            	$rootScope.alert("验证码错误");
            }else{
                LoginFactory.login($scope.logindata);
            }
        };
        $scope.gotopassword = function () {
            $scope.loginmodal.hide();
            $state.go('my_password');
        };
        $scope.loginwithoutmembername = function () {
            if (!$scope.logindata.username) {
                $rootScope.alert("请输入有效的账号");
            }
            else if (!$scope.logindata.password) {
                $rootScope.alert("请输入密码");
            }
            else {
                LoginFactory.loginwithoutmembername($scope.logindata);
            }
        };

        var logintimerid;
        var logintimecount;
        $scope.sendCheckCode = function () {
            if ($scope.checkcodebtn == '获取验证码') {
                LoginFactory.sendCheckCode($scope.logindata);
            }
        };

        $scope.$on('sendCheckCode.success',function(){
        	var reinfo = LoginFactory.getSendCheckCodeReturn();
        	if(reinfo.flag){
        		logintimecount = 60;
                dopageset();
        	}
        	else {
        		$rootScope.alert(reinfo.msg);
        	}
        });

        //倒计时设置
        function dopageset(){
        	logintimecount--;
            $scope.checkcodebtn = logintimecount + '秒后重发';
            if(logintimecount <= 0){
            	$timeout.cancel(logintimerid);
            	$scope.checkcodebtn = '获取验证码';
            }
            else {
            	logintimerid = $timeout(dopageset, 1000);
            }
        }
        ModalFactory.loadCheckCheckCodeModal($scope);
        ModalFactory.init(['yhxyModal','loginindex06'], $scope);
    })

    .controller('propertyCompareModalCtrl', function ($scope, $rootScope, $stateParams, $state, $ionicModal) {
        $scope.checkedlist = new Array();
        var outflag = false; // 记录对比数量是否超出范围
        //$scope.comparelist = JSON.parse(localStorage.comparelist);
        $rootScope.addcompare = function (compareobj) {
            if (typeof (compareobj) == 'object') {
                if (localStorage.comparelist && localStorage.comparelist != '[]') {
                    var comparelist = JSON.parse(localStorage.comparelist);
                    var needadd = true;
                    for (i in comparelist) {
                        if (comparelist[i].cpid == compareobj.cpid) {
                            needadd = false;
                        }
                    }
                    if (needadd) {
                        comparelist.push(compareobj);
                        localStorage.comparelist = JSON.stringify(comparelist);
                    }
                } else {
                    var list = new Array();
                    list.push(compareobj);
                    localStorage.comparelist = JSON.stringify(list);
                }
                //$scope.addcompare();
                $scope.comparelist = JSON.parse(localStorage.comparelist);
            }
        };
        $scope.gocompare = function () {
            var cplist = new Array();
            for (i in $scope.checkedlist) {
                if ($scope.checkedlist[i]) {
                    var cp = {
                        cpid: $scope.comparelist[i].cpid,
                        cptype: $scope.comparelist[i].linktype,
                        cpsid: $scope.comparelist[i].siteid
                    };
                    cplist.push(cp);
                }
            }
            if(cplist.length > 0) {
                if (cplist.length < 5) {
                    $scope.closeCompareModal();
                    $state.go('property_propertycompare', {cplist: cplist});
                } else {
                    $scope.alert('抱歉，每次仅支持最多4个楼盘/小区对比。');
                }
            } else {
                $scope.alert('请勾选对比的楼盘');
            }
        };
        $scope.clearcompare = function () {
            localStorage.comparelist = '';
            $scope.closeCompareModal();
        };
    })
    .controller('CertificateCtrl', function ($scope, $stateParams, $rootScope, MyIndexFactory) {

        //默认显示值
        $scope.meminfo = $rootScope.meminfo;
        $scope.isCertificate = $rootScope.isCertificate;
        $scope.isreadonly=false;

        $scope.certification = { certification_realname:"",
            certification_idnumber:"",
            certification_sex:"0",
            certification_career:""};

        //身份证号合法性验证
        //支持15位和18位身份证号
        //支持地址编码、出生日期、校验位验证
        function IdentityCodeValid(code) {
            var city = {
                11 : "北京", 12 : "天津", 13 : "河北", 14 : "山西", 15 : "内蒙古",
                21 : "辽宁", 22 : "吉林", 23 : "黑龙江 ", 31 : "上海", 32 : "江苏", 33 : "浙江",
                34 : "安徽", 35 : "福建", 36 : "江西", 37 : "山东", 41 : "河南", 42 : "湖北 ",
                43 : "湖南", 44 : "广东", 45 : "广西", 46 : "海南", 50 : "重庆", 51 : "四川",
                52 : "贵州", 53 : "云南", 54 : "西藏 ", 61 : "陕西", 62 : "甘肃", 63 : "青海",
                64 : "宁夏", 65 : "新疆", 71 : "台湾", 81 : "香港", 82 : "澳门", 91 : "国外 "
            };
            var tip = "";
            var pass = true;

            if (!city[code.substr(0, 2)]) {
                tip = "请输入正确的身份证号";
                pass = false;
            } else {
                //18位身份证需要验证最后一位校验位
                if (code.length == 18) {
                    if (!code || !/^[1-9][0-9]{5}(19[0-9]{2}|200[0-9]|2010)(0[1-9]|1[0-2])(0[1-9]|[12][0-9]|3[01])[0-9]{3}[0-9xX]$/i.test(code)) {
                        tip = "请输入正确的身份证号";
                        pass = false;
                    }
                    else{
                        code = code.split('');
                        //∑(ai×Wi)(mod 11)
                        //加权因子
                        var factor = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
                        //校验位
                        var parity = [ 1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2 ];
                        var sum = 0;
                        var ai = 0;
                        var wi = 0;
                        for (var i = 0; i < 17; i++) {
                            ai = code[i];
                            wi = factor[i];
                            sum += ai * wi;
                        }
                        var last = parity[sum % 11];
                        if (parity[sum % 11] != code[17].toUpperCase()) {
                            tip = "请输入正确的身份证号";
                            pass = false;
                        }
                    }

                }
                else if(code.length == 15) {
                    if (!code || !/^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$/i.test(code)) {
                        tip = "请输入正确的身份证号";
                        pass = false;
                    }
                }
                else {
                    tip = "请输入正确的身份证号";
                    pass = false;
                }
            }
            return pass;
        }
        //中文姓名验证（2-4个中文字符）
        function NameValid(val) {
            reg = /^[\u4E00-\u9FA5]{2,4}$/;
            if (!reg.test(val)) {
                return false;
            } else {
                return true;
            }
        }



        //提交实名认证
        $scope.doSubmit=function(){
            if($scope.certification.certification_realname == ''){
                $rootScope.alert('请填写姓名！');
            } else if($scope.certification.certification_idnumber == ''){
                $rootScope.alert('请填写身份证号码！');
            } else if($scope.certification.certification_sex == ''){
                $rootScope.alert('请选择性别！');
            } else if($scope.certification.certification_career ==  ''){
                $rootScope.alert('请选择职业！');
            } else if(!NameValid($scope.certification.certification_realname)){
                $rootScope.alert('姓名填写错误！');
            } else if(!IdentityCodeValid($scope.certification.certification_idnumber)){
                $rootScope.alert('身份证号码填写错误！');
            }else{
                MyIndexFactory.doCertificate($scope.certification);
            }
        };
        //显示我提交实名认证后的信息
        $scope.$on('myinfo.certificate.updated', function () {
            var o=MyIndexFactory.getCertificateRs();
            $rootScope.alert(o.msg);
            if(o.flag){
                $rootScope.isCertificate = true;
                $scope.closeCertificateModal();
            }
        });
    })
    .controller('BuywishCtrl', function ($scope, $stateParams, $rootScope, PropertyDetailFactory, LoginFactory, MyIndexFactory, $timeout, ModalFactory) {
        $scope.checkcodebtn = '获取验证码';
        $scope.kftinfo = {
            name: '',
            telphone: '',
            checkcode: ''
        };
        if($rootScope.islogin){
            MyIndexFactory.loadinfo();
        }
        // $scope.printall = function() {
        // }
        PropertyDetailFactory.get($stateParams.propertyid,$stateParams.siteid, function () {
        	var detail = PropertyDetailFactory.getDetail();
        	//为了获取楼盘名
        	var propertyname = detail.cohProperty.propertyname;
        	$scope.savekft = function() {
                var params = {
                    name : $scope.kftinfo.name,
                    telphone : $scope.kftinfo.telphone,
                    checkcode : $scope.kftinfo.checkcode,
                    propertyid : $stateParams.propertyid,
                    siteid : $stateParams.siteid,
                    propertyname : propertyname
                };
                if($scope.kftinfo.name == ''){
                    $rootScope.alert('请输入姓名！');
                }else if($scope.kftinfo.telphone == ''){
                    $rootScope.alert('请输入手机号码！');
                }else if($scope.kftinfo.checkcode == ''){
                    $rootScope.alert('请输入验证码！');
                }else{
                    PropertyDetailFactory.saveKft(params);
                }
                // PropertyDetailFactory.saveKft(params);
            };
        });
        $scope.$on('meminfo.updated', function(){
            var meminfo = MyIndexFactory.getinfo();
            $scope.kftinfo.telphone = parseInt(meminfo.usermobile);
        });
        $scope.$on('saveKft.completed', function(){
            var msg = PropertyDetailFactory.getMsg();
            if(msg.flag){
                $scope.closeBuywishModal();
                $rootScope.alert(msg.msg);
                $scope.kftcount++;
            }else{
                $rootScope.alert(msg.msg);
            }
        });

        //获取申请人数
        PropertyDetailFactory.loadKftCount();
        $scope.$on('KftCount.updated', function(){
            $scope.kftcount = PropertyDetailFactory.getKftCount();
        });

        //获取验证码
        var logintimerid;
        var logintimecount;
        $scope.sendCheckCode = function () {
            if ($scope.checkcodebtn == '获取验证码') {
                LoginFactory.sendCheckCodeforBuyWish({telphone : $scope.kftinfo.telphone});
            }
        };

        $scope.$on('sendCheckCodeforBuyWish.success',function(){
            var reinfo = LoginFactory.getSendCheckCodeReturn();
            if(reinfo.flag){
                logintimecount = 60;
                dopageset();
            }
            else {
                $rootScope.alert(reinfo.msg);
            }
        });

        //倒计时设置
        function dopageset(){
            logintimecount--;
            $scope.checkcodebtn = logintimecount + '秒后重发';
            if(logintimecount <= 0){
                $timeout.cancel(logintimerid);
                $scope.checkcodebtn = '获取验证码';
            }
            else {
                logintimerid = $timeout(dopageset, 1000);
            }
        }
        ModalFactory.loadCheckCheckCodeModal($scope);
    })
    .controller('mmgjNearbyPopoverCtrl', function($scope, $rootScope,$state, MmgjIndexFactory) {
        var cyqylistnearby, cyrylistnearby;
        var cyqyQueryParams = {};
        var cyryQueryParams = {};
        cyqyQueryParams = {
            space: 1,
            lat: $rootScope.Bposition.y,
            lng: $rootScope.Bposition.x,
            page: 1
        };
        cyryQueryParams = {
            space: 1,
            lat: $rootScope.Bposition.y,
            lng: $rootScope.Bposition.x,
            page: 1
        };
        MmgjIndexFactory.loadCyqylist(cyqyQueryParams, 'NearbyPopover');
        MmgjIndexFactory.loadCyrylist(cyryQueryParams, 'NearbyPopover');
        // 第一次不给刷新
        var unlockLoadMore1 = false;
        var unlockLoadMore2 = false;
        $scope.loadMore = function () {
            if ($scope.linktype == 1) {
                if (unlockLoadMore1) {
                    cyryQueryParams.page = cyryQueryParams.page + 1;
                    MmgjIndexFactory.loadCyrylist(cyryQueryParams, 'NearbyPopover');
                }
            }
            if ($scope.linktype == 2) {
                if (unlockLoadMore2) {
                    cyqyQueryParams.page = cyqyQueryParams.page + 1;
                    MmgjIndexFactory.loadCyqylist(cyqyQueryParams, 'NearbyPopover');
                }
            }
        };
        $scope.hasNextPage = function () {
            if ($scope.linktype == 1 && cyrylistnearby) {
                return !cyrylistnearby.isover;
            }
            if ($scope.linktype == 2 && cyqylistnearby) {
                return !cyqylistnearby.isover;
            }
            return false;
        };
        $scope.$on('mmgj.NearbyPopover.cyqylist.updated', function () {
            cyqylistnearby = MmgjIndexFactory.getCyqylist();
            if ($scope.cyqynearbylist) {
                $scope.cyqynearbylist = $scope.cyqynearbylist.concat(cyqylistnearby.list);
            } else {
                $scope.cyqynearbylist = cyqylistnearby.list;
            }
            //企业头像替换
            for(var i in $scope.cyqynearbylist) {
				if($scope.cyqynearbylist[i].qymc.split('我爱我家').length > 1) {
					$scope.cyqynearbylist[i].ppbs = 'images/wawj_big.jpg';
				} else if($scope.cyqynearbylist[i].qymc.split('链家').length > 1) {
					$scope.cyqynearbylist[i].ppbs = 'images/lj_big.jpg';
				} else if($scope.cyqynearbylist[i].qymc.split('华邦房地产').length > 1) {
					$scope.cyqynearbylist[i].ppbs = 'images/hshb_big.jpg';
				} else if($scope.cyqynearbylist[i].qymc.split('云房源').length > 1) {
					$scope.cyqynearbylist[i].ppbs = 'images/qfang_big.jpg';
				} else {
					$scope.cyqynearbylist[i].ppbs = 'images/ty_big.jpg';
				}
			}
            $scope.cyqynearbycount = cyqylistnearby.count;
            unlockLoadMore1 = true;
        });
        $scope.$on('mmgj.NearbyPopover.cyrylist.updated', function () {
            cyrylistnearby = MmgjIndexFactory.getCyrylist();
            if ($scope.cyrynearbylist) {
                $scope.cyrynearbylist = $scope.cyrynearbylist.concat(cyrylistnearby.list);
            } else {
                $scope.cyrynearbylist = cyrylistnearby.list;
            }
            $scope.cyrynearbycount = cyrylistnearby.count;
            unlockLoadMore2 = true;
        });
        //跳转到从业企业详细页
        $scope.gonearbyCyqyxxdetail = function (index) {
            var params = {qycode: $scope.cyqynearbylist[index].qycode};
            $state.go('mmgj_cyqyxxdetail', params);
        };
        //跳转到从业人员详细页
        $scope.gonearbyCyryxxdetail = function (index) {
            var params = {qycode: $scope.cyrynearbylist[index].qycode, rycode: $scope.cyrynearbylist[index].rycode};
            $state.go('mmgj_cyryxxdetail', params);
        }
    })
    .controller('websitechangeCtrl', function($scope, HomeFactory) {
        HomeFactory.loadWebsitechange();
        $scope.$on('websitechange.updated', function(){
            $scope.websitechange = HomeFactory.getWebsitechange();
            $scope.list = $scope.websitechange.website;
        });

        $scope.sitechange = function(type) {
            localStorage.defaultwebsite = type;
            window.location.href = '../' + type;
        }
    })
	//关键字搜索
	.controller('dcrcomSearchkeywordCtrl', function($scope, $rootScope, $state, $timeout, $resource, url) {
		var keywordurl = url.search.compronamelist + url.daycache;
		var compronamelist = [];
		$scope.id = $scope.$id;
		var emit = 'companyappoint.community.selected';
		$scope.$on('$ionicView.enter', function (event, viewData) {
	        $scope.comprolist = [];
	        document.getElementById('dcrcomsearchkeyword_' + $scope.id).focus();
	        $timeout(function () {
	            document.getElementById('dcrcomsearchkeyword_' + $scope.id).focus();
	        }, 1000);
	        if (typeof(cordova) != 'undefined') {
	            cordova.plugins.Keyboard.show();
	        }
	        if (compronamelist.length > 0) {
	            loadCacheSearchkeyword();
	        }
	    });
	    $resource(keywordurl, {}, {query: {cache: true}}).query({json: true}, function (r) {
	        compronamelist = r.compronamelist;
	        loadCacheSearchkeyword();
	    });
	    $scope.search = function (index) {
	        $rootScope.$emit(emit, compronamelist[index].name, compronamelist[index].linkid);
	        // 缓存当前搜索
	        cacheCacheSearchkeyword(index);
	        $scope.closeDecorationCompanySearchkeywordModal();
	    };
	    $scope.keywordsearch = function (input) {
	        $scope.comprolist = [];
	        var str = '';
	        var temp;
	        var py;
	        var py2;
	        var listlength;
	        kw = input.keyword;
	        if (kw) {
	            kw = kw.toLocaleUpperCase();
	            listlength = 0;
	            for (i in compronamelist) {
	            	if(compronamelist[i].linktype != 2) {
	            		continue;
	            	}
	                if (listlength > 30) {
	                    break;
	                }
	                temp = compronamelist[i].name.split(kw);
	                py = compronamelist[i].py.split(kw);
	                py2 = compronamelist[i].py2.split(kw);
	                // 判断是否找到匹配
	                if (temp.length > 1 || py.length > 1 || py2.length > 1) {
	                    // 汉字匹配
	                    if (temp.length > 1) {
	                        str = '';
	                        for (j in temp) {
	                            str += (j != 0 ? '<i class="tm-orange">' + kw + '</i>' : '') + temp[j];
	                        }
	                        // 拼音匹配
	                    } else if (py.length > 1 || py2.length > 1) {
	                        str = compronamelist[i].name;
	                    }
	            		var compro = {
	            			index : i,
	                        str: str
	                     };
	            		 $scope.comprolist.push(compro);
	                     listlength++;
	                }
	            }
	        }
	    };
	    function loadCacheSearchkeyword() {
	        if (localStorage.searchkeywordlist) {
	            var l = eval('(' + localStorage.searchkeywordlist + ')');
	            var str = '';
	            $scope.comprolist = [];
	            for (i in l) {
	            	if(!isNaN(l[i])) {
	            		$scope.comprolist.push({
	            			index: l[i],
	            			str: compronamelist[l[i]].name + (compronamelist[l[i]].linktype == 2 ? '-二手房' : '')
	            		})
	            	}
	            }
	        }
	    }
	    function cacheCacheSearchkeyword(kw) {
	        if (kw == '') {
	            return;
	        }
	        if (localStorage.searchkeywordlist) {
	            var l = eval('(' + localStorage.searchkeywordlist + ')');
	            var str = '[\'' + kw;
	            for (i in l) {
	                if (l[i] != kw) {
	                    str += '\',\'' + l[i];
	                }
	            }
	            str += '\']';
	            localStorage.searchkeywordlist = str;
	        } else {
	            localStorage.searchkeywordlist = '[\'' + kw + '\']';
	        }
	    }
	})
	.controller('dcrAppointModalCtrl', function ($scope, $stateParams, $timeout, $rootScope, ModalFactory, LoginFactory, dcrAppointFactory, MyIndexFactory) {
		$scope.checkcodebtn = '获取验证码';
        //获取小区名称的广播
		$rootScope.$on('companyappoint.community.selected', function (event, communityname, communityid) {
			$scope.appointParams.communityid = communityid;
			$scope.appointParams.communityname = communityname;
		});
		//获取会员信息
        $scope.$on('meminfo.updated', function () {
			$scope.meminfo = MyIndexFactory.getinfo();
			//预约设计参数
			$scope.appointParams = {
				uuid: localStorage.uuid,
				realname: '',
				communityid: '',
				communityname: '',
				builtuparea: '',
				checkcode: '',
				storeid: $stateParams.storeid || $scope.store.storeid,
				usermobile: parseInt($scope.meminfo.usermobile) || ''
//				usermobile: $scope.cancelchange_tel == true ? parseInt(localStorage.logindata_telphone) : ''
			};
		});
        MyIndexFactory.loadinfo();
		//预约弹出层更换号码切换
		$scope.change_tel = false;
		$scope.cancelchange_tel = true;
		$scope.usermobile = localStorage.logindata_telphone;
		$scope.changetel = function () {
			$scope.change_tel = !$scope.change_tel;
			$scope.cancelchange_tel = !$scope.cancelchange_tel;
		};
		$scope.cancelchangetel = function () {
			$scope.change_tel = !$scope.change_tel;
			$scope.cancelchange_tel = !$scope.cancelchange_tel;
		};

        $scope.sendCheckCode = function () {
            if ($scope.checkcodebtn == '获取验证码') {
                LoginFactory.sendCheckCodeforAppoint({telphone : $scope.appointParams.usermobile});
            }
        };

        $scope.$on('sendCheckCodeforAppoint.success',function(){
        	var reinfo = LoginFactory.getSendCheckCodeReturn();
        	if(reinfo.flag){
        		logintimecount = 60;
                dopageset();
        	}
        	else {
        		$rootScope.alert(reinfo.msg);
        	}
        });

        //倒计时设置
        function dopageset(){
        	logintimecount--;
            $scope.checkcodebtn = logintimecount + '秒后重发';
            if(logintimecount <= 0){
            	$timeout.cancel(logintimerid);
            	$scope.checkcodebtn = '获取验证码';
            }
            else {
            	logintimerid = $timeout(dopageset, 1000);
            }
        }
        //预约设计提交
        $scope.saveAppoint = function () {
        	if($scope.appointParams.realname == '') {
                $rootScope.alert('请输入真实姓名！');
            } else if ($scope.appointParams.builtuparea == '') {
                $rootScope.alert('请输入房屋面积！');
            } else if ($scope.appointParams.builtuparea > 10000) {
            	$rootScope.alert('输入的面积过大！');
            } else if ($scope.appointParams.communityname == '') {
                $rootScope.alert('请输入小区名称！');
            } else if ($scope.appointParams.usermobile == '') {
            	$rootScope.alert('请输入手机号码！');
            } else if ($scope.change_tel && $scope.appointParams.checkcode == '') {
            	$rootScope.alert('请输入验证码！');
            } else {
            	dcrAppointFactory.save($scope.appointParams);
            }
        };
        $scope.$on('appointsave.completed', function(){
            var msg = dcrAppointFactory.getMsg();
            if(msg.flag){
                $scope.closeDecorationAppointModal();
                $rootScope.alert(msg.msg);
            }else{
                $rootScope.alert(msg.msg);
            }
        });
        //加载弹出层
        ModalFactory.loadLoginModal($scope);
		ModalFactory.loadDecorationCompanySearchkeywordModal($scope);
        ModalFactory.loadCheckCheckCodeModal($scope);
	})
;
