angular.module('tmjia.controllers.shaking', [])
	.controller('ShakingListCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, url,
		UDI, searchcondition, ModalFactory, timePickerService, $resource, $ionicSlideBoxDelegate) {
		$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
		// 列表数据
		$scope.shakingResult = { list: [], isover: false };
		// 是否已经加载过了
		$scope.issearched = false;
		// 接口url
		var listUrl = url.shaking.list;
		var now = new Date();
		// 时间参数
		$scope.timeParams = {
			dateTime: now.getTime(),
			result: ''
		};
		// 页面请求参数
		$scope.params = {
			page: 1,
			areaid: '',
			price: '',
			state: '',
			year: now.getFullYear(),
			month: now.getMonth() + 1
		};
		// 城区list
		$scope.areaList = searchcondition.areaid;
		// 均价list
		$scope.averPriceList = searchcondition.yh_pricelist;
		// 摇号状态
		$scope.stateList = searchcondition.yh_stateList;
		var bc = 'shaking.list.';
		// 从第一页开始重新获取数据
		$scope.doRefresh = function(reload) {
			UDI.removeresult(bc);
			$scope.params.page = 1;
			$scope.shakingResult.list = [];
			$scope.shakingResult.isover = true;
			!reload && $scope.openJzModal();
			$scope.loadMore(reload);
			reload && $scope.loadAdv();
		};
		// 广告位数据
		$scope.index_ad = [];
		//广告位
		var indexadurl = url.tmj.indexad + url.hourcache;
		$scope.showad = false;
		$scope.loadAdv = function() {
			$resource(indexadurl, {}, { query: { cache: false, isArray: true } }).query({
				adtypeid: 99932,
				a: 33,
				json: true
			}, function (r) {
				$scope.index_ad = r;
				$scope.showad = r.length > 0;
				$timeout(function() {
					$ionicSlideBoxDelegate.$getByHandle('list-handle').update();
				}, 0);
			});
		};
		$scope.loadAdv();
		UDI.removeresult(bc);
		// 分页加载
		$scope.loadMore = function(reload) {
			!$scope.issearched && !reload && $scope.openJzModal();
			UDI.loadobject(listUrl, $scope.params, bc, function(result) {
				$scope.shakingResult = result;
				$scope.issearched = true;
				$scope.closeJzModal();
				$rootScope.$broadcast('scroll.infiniteScrollComplete');
				$rootScope.$broadcast('scroll.refreshComplete');
			});
		}
		// 点击列表的item进入详情页
		$scope.goDetail = function(siid) {
			$state.go('shaking_detail', {
				siid: siid,
				_r: parseInt(Math.random() * 10000)
			});
		};
		// 进入搜索页
		$scope.goSearch = function() {
			$state.go('shaking_search');
		};
		// 选择时间
		$scope.changeTime = function(result) {
			var timeArr = result.split('-');
			$scope.params.year = timeArr[0];
			$scope.params.month = timeArr[1];
			$scope.doRefresh();
		};
		// 日期显示格式化
		$scope.showDateFormat = function(result) {
			return result.year.item.data + '.' + result.month.item.data;
		}
		// 选择城区
		$scope.changeArea = function(areaid) {
			$scope.params.areaid = areaid;
			$scope.closeShakinglistXzcq();
			$scope.doRefresh();
		};
		// 选择均价
		$scope.changeAverPrice = function(price) {
			$scope.params.price = price;
			$scope.closeShakinglistJj();
			$scope.doRefresh();
		};
		// 选择摇号状态
		$scope.changeState = function(state) {
			$scope.params.state = state;
			$scope.closeShakinglistYhzt();
			$scope.doRefresh();
		};
		// 页面离开时，清除关键字监听和modal
		$scope.$on('$ionicView.beforeLeave', function () {
	    	ModalFactory.closeAllModal();
	    	$scope.closeJzModal();
		});
		//是否存在下一页判断
		$scope.hasNextPage = function () {
			return !$scope.shakingResult.isover;
		};
		// 弹出层
		ModalFactory.init(['shakinglistXzcq', 'shakinglistYhzt', 'shakinglistJj'], $scope);
		ModalFactory.loadJzModal($scope);
	})
	.controller('ShakingLpDetailCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, url, $resource, ModalFactory) {
		var siid = $stateParams.siid;
		var detailUrl = url.shaking.detail;
		$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;//图片域名
		$scope.detail = {};
		// 添加loading的Modal
		ModalFactory.loadJzModal($scope);
		$timeout(function() {
			// 获取摇号详情
			$scope.openJzModal();
			$resource(detailUrl, {}, { query: { method: 'get', timeout: 20000 } }).query({
				siid: siid,
	            json: true
	        }, function(data) {
	        	$scope.closeJzModal();
	            $scope.detail = data.yaohaoInfo || {};
	        }, function() {
	        	$rootScope.alert('加载失败');
	        	$scope.closeJzModal();
	        });
		}, 20);
		// 获取无房家庭人数
		$scope.getWfjt = function() {
			if ($scope.detail.djrs && $scope.detail.proportion) {
				var rate = +$scope.detail.proportion.replace('%', '');
				return (rate * $scope.detail.djrs / 100).toFixed(0);
			}
			return '';
		};
		// 进入搜索页
		$scope.goSearch = function() {
			$state.go('shaking_search');
		};
		// 查看一房一价
		$scope.goHouseList = function() {
			$state.go('property_sellhouse', {
				propertyid: $scope.detail.propertyid,
				siteid: $scope.detail.siteid,
				buildingid: ''
			});
		};
		// 楼盘点评
		$scope.goComment = function() {
			$state.go('property_comment', {
				propertyid: $scope.detail.propertyid,
				siteid: $scope.detail.siteid,
				linkname: ''
			});
		};
		// 网友谍报
		$scope.goNews = function() {
			$state.go('property_news', {
				propertyid: $scope.detail.propertyid
			});
		};
		// 页面离开时，清除modal
		$scope.$on('$ionicView.beforeLeave', function () {
	    	$scope.closeJzModal();
		});
	})
	.controller('ShakingSearchCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, $resource, url, UDI) {
		$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
		// 历史搜索记录公共方法
		var CACHE = {
			// 本地保存的key
			key: '__search_history__',
			// 最多保留记录条数
			maxLen: 10,
			init: function(key, maxLen) {
				CACHE.key = key || '__search_history__';
				CACHE.maxLen = maxLen || 10;
			},
			getSearchHistory: function() {
				var searchHistory = localStorage[CACHE.key] || "[]";
				return angular.fromJson(searchHistory);
			},
			saveSearchHistory: function(keyword) {
				var list = CACHE.removeItem(keyword);
				list.unshift(keyword);
				list.length >= CACHE.maxLen && list.splice(CACHE.maxLen);
				localStorage[CACHE.key] = angular.toJson(list);
			},
			removeItem: function(keyword) {
				var list = CACHE.getSearchHistory();
				var index = -1;
				angular.forEach(list, function(name, idx) {
					if (name === keyword) {
						index = idx;
					}
				});
				~index && list.splice(index, 1);
				localStorage[CACHE.key] = angular.toJson(list);
				return list;
			},
			removeAll: function() {
				localStorage.removeItem(CACHE.key);
			}
		};
		// 历史搜索列表
		$scope.historyList = CACHE.getSearchHistory();
		// 接口url
		var listUrl = url.shaking.list;
		// 搜索关键字
		$scope.params = { keyword: '' };
		// 列表数据
		$scope.searchList = [];
		// 广告位数据
		$scope.searchkeyword_ad = [];
		//广告位
		var indexadurl = url.tmj.indexad + url.hourcache;
		$resource(indexadurl, {}, { query: { cache: true, isArray: true } }).query({
			adtypeid: 99931,
			a: 33,
			json: true
		}, function (r) {
			$scope.searchkeyword_ad = r;
		});
		//广告位延迟0.5秒显示,避免ios上面焦点问题
		$timeout(function () {
			$scope.showdelay = false;
		}, 500);
		$scope.id = $scope.$id;
		// 从第一页开始重新获取数据
		$scope.doRefresh = function(keyword) {
			$scope.params.page = 1;
			$scope.loadMore(keyword);
		};
		// 分页加载
		$scope.loadMore = function(keyword) {
			$resource(listUrl, $scope.params, { query: { method: 'get', timeout: 20000 } })
				.query({}, function(result) {
		        	$scope.searchList = createSearchResult(result, keyword);
					$rootScope.$broadcast('scroll.infiniteScrollComplete');
		        }, function() {
		        	$rootScope.alert('加载失败');
		        });
		}
		// 清空输入框
		$scope.clear = function() {
			$scope.params.keyword = '';
			$scope.searchList = [];
		}
		// 搜索关键字,300ms延迟
		$scope.search = (function() {
			var timer;
			return function(input) {
				$scope.params.keyword = input.params.keyword.replace(/^\s*|\s*$/g, '');
				if (!$scope.params.keyword) {
					$scope.searchList = [];
					return;
				}
				timer && $timeout.cancel(timer);
				timer = $timeout(function() {
					$scope.doRefresh($scope.params.keyword);
				}, 300);
			};
		})();
		// 点击历史搜索记录搜索，并保存关键字
		$scope.clickHisItem = function(name) {
			$scope.params.keyword = name;
			$scope.doRefresh($scope.params.keyword);
			CACHE.saveSearchHistory(name);
			$scope.historyList = CACHE.getSearchHistory();
		};
		// 点击列表的item进入详情页，并保存关键字
		$scope.goDetail = function(siid, propertyname) {
			CACHE.saveSearchHistory(propertyname);
			$scope.historyList = CACHE.getSearchHistory();
			$state.go('shaking_detail', {
				siid: siid,
				_r: parseInt(Math.random() * 10000)
			});
		};
		$scope.removeItem = function(keyword) {
			CACHE.removeItem(keyword);
			$scope.historyList = CACHE.getSearchHistory();
		};
		$scope.removeAll = function() {
			CACHE.removeAll();
			$scope.historyList = CACHE.getSearchHistory();
		}
		// 页面打开是输入框聚焦
		$scope.$on('$ionicView.enter', function (event, viewData) {
			document.getElementById('searchkeyword_' + $scope.id).focus();
			$timeout(function () {
				document.getElementById('searchkeyword_' + $scope.id).focus();
			}, 1000);
			if (typeof (cordova) != 'undefined') {
				cordova.plugins.Keyboard.show();
			}
		});
		// 根据关键字生成最终展现的记录
		function createSearchResult(result, keyword) {
			if (!result.list.length) {
				return [];
			}
			var list = [];
			angular.forEach(result.list, function(r) {
				var ws = r.propertyname.split(keyword);
				var str = ws[0] || '';
				for (var j = 1; j < ws.length; j++) {
					str += '<span class="balanced">' + keyword + '</span>' + ws[j];
				}
				str = '<i class="iconfont18 tm-margin-right10 vertical-middle tm-display-inlineblock tm-margin-topf3">&#xe749;</i>' +
					str + '<div class="tm-shaking-search-colse iconfont18">&#xe787;</div>';
				list.push({
					str: str,
					propertyname: r.propertyname,
					siid: r.siid
				});
			});
			return list;
		}
	})
	.controller('ShakingNewsCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, url, UDI) {
		// 列表数据
		$scope.newsResult = { list: [], isover: false };
		// 是否已经加载过了
		$scope.issearched = false;
		// 接口url
		var listUrl = url.news.list;
		// 页面请求参数
		$scope.params = {
			page: 1,
			cateid: '1159715393',
			keyword: ''
		};
		var bc = 'shaking.news.list.';
		// 从第一页开始重新获取数据
		$scope.doRefresh = function() {
			UDI.removeresult(bc);
			$scope.params.page = 1;
			$scope.newsResult.list = [];
			$scope.newsResult.isover = true;
			$scope.loadMore();
		};
		//加载数据前先移除到原来的数据 防止数据重复
		UDI.removeresult(bc);
		// 分页加载
		$scope.loadMore = function() {
			UDI.loadobject(listUrl, $scope.params, bc, function(result) {
				$scope.newsResult = result;
				$scope.issearched = true;
				$rootScope.$broadcast('scroll.infiniteScrollComplete');
				$rootScope.$broadcast('scroll.refreshComplete');
			});
		}
		// 进入搜索页
		$scope.goSearch = function() {
			$state.go('shaking_search');
		};
		// 进入新闻详情页
		$scope.goDetail = function(contentid) {
			$state.go('newsinfo', {
				contentid: contentid,
				_r: parseInt(Math.random() * 10000)
			});
		};
		//是否存在下一页判断
		$scope.hasNextPage = function () {
			return !$scope.newsResult.isover;
		};
	})
	.controller('ShakingLotteryCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, url, UDI, $resource, $ionicActionSheet) {
		$scope.fyList = [];
		var listUrl = url.shaking.fyList;
		// 加载房源列表
		$resource(listUrl, {}, {query: {timeout: 20000, isArray: false}}).query({
			uuid: localStorage.uuid,
			openid: localStorage.openid
		}, function (result) {
			$scope.fyList = result.list;
		}, function (r) {
			$rootScope.alert('楼盘加载失败');
		});
		$scope.selParam = {
			yhlp: null,
			siid: ''
		};
		// 查询参数
		$scope.params = {
			presalenumber: '',
			djnumber: '',
			phone: '',
			checkCode: ''
		};
		// 图片验证码地址
		$scope.code_url = {
			url : _INIT_YUMING + '/mem/checkcodeimage.jsp?_time=' + new Date()
		};
		// 刷新验证码
		$scope.refreshCode = function () {
			$scope.code_url.url = _INIT_YUMING + '/mem/checkcodeimage.jsp?_time=' + new Date();
		};
		var searchUrl = url.shaking.searchYhResult;
		// 搜索摇号结果
		$scope.searchYhResult = function() {
			if (!$scope.selParam.yhlp) {
				$rootScope.alert('楼盘名称未选择');
				return;
			}
			$scope.params.presalenumber = $scope.selParam.yhlp.presellid;
			$scope.selParam.siid = $scope.selParam.yhlp.siid;
			if (!$scope.params.djnumber) {
				$rootScope.alert('购房登记号未填写');
				return;
			}
			if (!$scope.params.phone) {
				$rootScope.alert('手机号码未填写');
				return;
			}
			if (!/^\d{11}$/.test($scope.params.phone)) {
				$rootScope.alert('手机号码格式错误');
				return;
			}
			if (!$scope.params.checkCode) {
				$rootScope.alert('验证码未填写');
				return;
			}
			UDI.saveobject(searchUrl, $scope.params, 'shaking.lottery.search.', function(result) {
				if (!result.flag) {
					$rootScope.alert(result.returnMsg || '查询失败');
					$scope.refreshCode();
				} else {
					$state.go('shaking_lottery_result', {
						successid: result.successid,
						siid: $scope.selParam.siid
					});
				}
			});
		};
		$scope.yhNums = 0;
		var yhNumsUrl = url.shaking.yhNums;
		// 获取摇号总人数
		UDI.loadobject(yhNumsUrl, {}, 'shaking.lottery.yhnums.', function(result) {
			var total = result.yhlog.total;
			if (total < 1000) {
				total *= 5;
			} else if (total < 6000) {
				total = 5000 + (total - 1000) * 3;
			} else {
				total += 14000;
			}
			$scope.yhNums = total;
		});
		// 分享按钮弹出
        $scope.shareshow = function() {
	        $ionicActionSheet.show($rootScope.shareobj(17));
        };
	})
	.controller('ShakingLotteryResultCtrl', function ($scope, $rootScope, $state, $stateParams, $timeout, url, UDI, $ionicActionSheet, ModalFactory) {
		var infoUrl = url.shaking.yhjgInfo;
		$scope.detail = {};
		// 添加loading的Modal
		ModalFactory.loadJzModal($scope);
		$timeout(function() {
			// 获取摇号结果详情
			$scope.openJzModal();
			UDI.loadobject(infoUrl, { successid: $stateParams.successid }, 'shaking.lottery.yhjginfo.', function(result) {
				$scope.closeJzModal();
				$scope.detail = result.yhsuccess || {};
			});
		}, 20);
		// 查看楼盘详情
		$scope.goDetail = function() {
			$state.go('shaking_detail', {
				siid: $stateParams.siid,
				_r: parseInt(Math.random() * 10000)
			});
		};
		// 分享按钮弹出
        $scope.shareshow = function() {
	        $ionicActionSheet.show($rootScope.shareobj(17));
        };
        // 页面离开时，清除modal
		$scope.$on('$ionicView.beforeLeave', function () {
	    	$scope.closeJzModal();
		});
	})
	;