
var directiveMod = angular.module("tmjia.directive", []);


directiveMod.directive('showTabs', function ($rootScope) {
    return {
        restrict: 'AE',
        link: function ($scope) {
            $rootScope.showTabs = false;
            $scope.$on('$destroy', function () {
                $rootScope.showTabs = true;
            })
        }
    }
})
    .directive('script', function () {
        return {
            restrict: 'E',
            scope: false,
            link: function (scope, elem, attr) {
                if (attr.type === 'text/javascript-lazy') {
                    var s = document.createElement("script");
                    s.type = "text/javascript";
                    var src = elem.attr('src');
                    if (src !== undefined) {
                        s.src = src;
                    }
                    else {
                        var code = elem.text();
                        s.text = code;
                    }
                    document.head.appendChild(s);
                    elem.remove();
                }
            }
        }
    })
    .directive('compileRichTextImg', function ($compile, $parse, $rootScope) {
	    return {
	        restrict: 'A',
	        scope: false,
	        link: function (scope, element, attr) {
	        	$rootScope.contImgsList = [];//直播模块图片
	            setTimeout(function () {
	            	scope.$apply(function () {
                        var html = element.html($parse(attr.ngBindHtml)(scope));
                        if (!html) {
                        	return;
                        }
                        // 找到el中的html
                        var content = html.html();
                        var reg = /<img[^>]*>/gi;
                        // 匹配出html中的src属性
                        var images = content.match(reg);
                        if (images && images.length) {
                        	var imgs = [];
                            for (var i = 0; i < images.length; i++) {
                                // 将ng-click事件拼接到html中
                                var image = images[i];
                                var match = image.match(/src="([^"]*)"/);
                                if (match) {
                                	imgs.push(match[1]);
                                }
                                image.substr(0, image.indexOf(" "));
                                var first = image.substr(0, image.indexOf(' ') + 1);
                                var next = image.substr(image.indexOf(' '));
                                var final = first + 'ng-click="lnkImgShow($event)"' + next;
                                content = content.replace(image, final);
                                element.html(content);
                                // 编译dom,使其在angularjs的监听下
                                $compile(element.contents())(scope);
                            }
                        }
                        $rootScope.contImgs = imgs;
                        $rootScope.contImgsList.push(imgs);
                    });
	            },0);
	        }
	    }
	})
	// 暂无数据
	.directive('noData', function () {
		return {
			restrict: 'E',
			templateUrl: 'templates/directive/nodata.html',
			scope: {
				tip: '@',
				showBorder: '@'
			}
		};
	})
	// 网络异常
	.directive('hzfTimeout', function ($ionicModal, $timeout, TimeoutFactory) {
		return {
			restirct: 'E',
			templateUrl: 'templates/directive/timeout.html',
			link: function (scope) {
				var enter = true;
				scope.showFlag = false;
				scope.openHzfTimeoutModal = function () {
					if (enter && !scope.showFlag) {
						scope.showFlag = true
					}
				};
				scope.closeHzfTimeoutModal = function () {
					scope.showFlag = false;
				};
				scope.reload = function () {
					TimeoutFactory.broadcastTimeoutReload();
					scope.closeHzfTimeoutModal();
				};
				TimeoutFactory.addTimeoutListener(scope, function () {
					$timeout(scope.openHzfTimeoutModal, 300);
				});
				// view进入或者离开时，改变enter的值，防止对其它页面发送的超时广播做出响应
				scope.$on('$ionicView.beforeLeave', function () {
					enter = false;
				});
				scope.$on('$ionicView.beforeEnter', function () {
					enter = true;
				});
			}
		};
	})
	
	
	.directive('tmjStar', function() {
        return {
            restrict: 'E',
            scope: {
                info: '=',
                handleClick: '=',
                index: '='
            },
            template: '<div ng-click="starClick()" class="evaluate-right-mian" ng-class="{true: \'evaluate-right-mian01\', false: \'evaluate-right-mian02\'}[info.light]"></div>',
            link: function(scope) {
                scope.starClick = function() {
                    scope.handleClick(scope.index);
                };
            }
        };
    })
	.directive('tmjStars', function() {
        return {
            restrict: 'E',
            scope: {
                scores: '=', // { score, totalScore }
                handleClick: '=', // 点击星星的回调,
                name: '@' // 用于表示该列表的star
            },
            template: '<tmj-star handle-click="starClick" index="item.index" info="item" ng-repeat="item in list"></tmj-star>',
            link: function(scope) {
                scope.$watch('scores', function(scores) {
                    for (var i = 0, arr = []; i < scores.totalScore; i++) {
                        arr.push({ light: i < scores.score, index: i });
                    }
                    scope.list = arr;
                });
                scope.starClick = function(index) {
                    for (var i = 0; i < scope.list.length; i++) {
                        scope.list[i].light = i <= index;
                    }
                    scope.handleClick(scope.name, index + 1);
                };
            }
        };
    })
	
	.directive('focusInput', ['$ionicScrollDelegate', '$window', '$timeout', '$ionicPosition', function ($ionicScrollDelegate, $window, $timeout, $ionicPosition) {
        return {
            restrict: 'A',
            scope: false,
            link: function ($scope, iElm, iAttrs, controller) {
                if (ionic.Platform.isIOS()) {
                    iElm.on('focus', function () {
                        var top = $ionicScrollDelegate.getScrollPosition().top;
                        var eleTop = ($ionicPosition.offset(iElm).top) / 2
                        var realTop = eleTop + top;
                        $timeout(function () {
                            if (!$scope.$last) {
                                $ionicScrollDelegate.scrollTo(0,realTop);
                            } else {
                                try {
                                    var aim = angular.element(document).find('.scroll')
                                    aim.css('transform', 'translate3d(0px,' + '-' + realTop + 'px, 0px) scale(1)');
                                    $timeout(function () {
                                        iElm[0].focus();
                                        console.log(2);
                                    }, 100)
                                } catch (e) {
                                }

                            }
                        }, 500)
                    })
                }

            }
        }
    }]);


