var lineChart;
/**
 * 走势图生成js
 * @param linebox 走势图所在的div的id
 * @param timelist 走势图的时间队列
 * @param datalist 走势图的数据队列
 */
function echartForProperty(linebox, timelist, datalist, dw) {
	lineChart= echarts.init(document.getElementById(linebox));
	var option = {
		tooltip : {
			trigger: 'axis',
			formatter:  '{b0}<br />{c0}' + dw
		},
		grid: {
			show:false,
			top: '3%',
			left: '3%',
			right: '5%',
			bottom: '3%',
			borderWidth: 2,
			containLabel: true,
		},
		xAxis: [
			{
				type : 'category',
				boundaryGap : false,
				data : timelist,
				axisLine : {
					lineStyle:{
						color: '#dddddd'
					}
				},
				axisTick : {
					lineStyle : {
						color: '#dddddd'
					}
				},
				axisLabel : {
					textStyle : {
						color: '#999',
						fontFamily: 'Helvetica, Arial, "Microsoft Yahei", sans-serif'
					}
				}
			}
		],
		yAxis: [
			{
				type : 'value',
				axisLine : {
					lineStyle:{
						color: '#dddddd'
					}
				},
				axisTick : {
					lineStyle : {
						color: '#dddddd'
					}
				},
				axisLabel : {
					textStyle : {
						color: '#999',
						fontFamily: 'Helvetica, Arial, "Microsoft Yahei", sans-serif'
					}
				}
			}
		],
		series : [				        
			{
				name:'签约均价',
				type:'line',
				stack: null,
				smooth: true,
				symbolSize:6,
				label: {
					normal: {
						show: false,
						position: 'top',
					}
				},
				itemStyle:{
					normal: {
						color:'#27ae61',
						borderWidth:1,
					}
				},
				lineStyle:{
					normal: {
						width:1.5,
					}
				},
				areaStyle:{
					normal: {
						color:'rgba(39, 174, 97, .3)',
					}
				},
				data:datalist
			}
		],
		textStyle :{
			fontFamily: 'Helvetica, Arial, "Microsoft Yahei", sans-serif'
		}
	};
	lineChart.setOption(option);
}

//首付、按揭、利息
var pieChart;
function echartForPropertyHouse(idname, cksf, dkze, zflx){
	pieChart = echarts.init(document.getElementById(idname));
	var option = {
		color: ['#45c358','#f4a048','#3398DB'],
		tooltip : {
			trigger: 'item',
			position: 'right',
			formatter: "{a} <br/>{b} : {c} 万元 ({d}%)"
		},
		legend: {
			show:false,
			data: ['首付','按揭','利息']
		},
		series : [
			{
				name: '买房参考',
				type: 'pie',
				radius : '75%',
				data:[
					{value:cksf, name:'首付'},
					{value:dkze, name:'按揭'},
					{value:zflx, name:'利息'}
				],
				label: {
	                normal: {
	                    position: 'inner'
	                }
	            },
				itemStyle: {
					emphasis: {
						shadowBlur: 10,
						shadowOffsetX: 0,
						shadowColor: 'rgba(0, 0, 0, 0.5)'
					}
				}
			}
		]
	};
	pieChart.setOption(option);
}

function echartForGpfy(linebox, namelist, datalist){
	var lineChart = echarts.init(document.getElementById(linebox));
	var option = {
			label:{//数值样式
				normal:{ 
					show: true,
					position: 'top',
					textStyle: {
						color:'#333'
					}
				},
				emphasis:{
				   	show: true,
					position: 'top',
					textStyle: {
						color:'#333'
					} 
				  
				}
			},
		    tooltip : {
		        trigger: 'axis',
		        formatter:  '{b0}<br />{c0}万元',
		        axisPointer : {            // 坐标轴指示器，坐标轴触发有效
		            type : 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
		        }
		    },
		    grid: {
		        left: '3%',
		        right: '4%',
		        bottom: '3%',
		        containLabel: true
		    },
		    xAxis : [
		        {
		            type: 'category',
		            data: namelist,
		            axisTick: {
		                alignWithLabel: true
		            }
		        }
		    ],
		    yAxis : [
		        {
		        	name: '总价',
		            type: 'value',
		            axisLabel : {
						formatter: '{value}万'
					}
		        }
		    ],
		    series : [
		        {
		            name:'总价',
		            type:'bar',
		            barWidth: 20,
		            data: datalist,
		            itemStyle:{
						normal:{
							color:function(params){
								var colorList=['#3398DB','#ff7f50', '#87cefa','#9BCA63','#FAD860','#F3A43B','#60C0DD'];
								 return colorList[params.dataIndex]
							}
						}
					}
		        }
		    ]
		};
	lineChart.setOption(option);
}