﻿/*
	coder chenja
	*/
angular.module('tmim', [])
	.constant('tmimServiceConfig', {
		//帐号模式，0-表示独立模式，1-表示托管模式
		accountMode: 0,
		//官方 demo appid,需要开发者自己修改（托管模式）
		sdkAppID: 1400168838,
		accountType: 36862,

		pageSize: 15, //表格的每页条数，bootstrap table 分页时用到
		totalCount: 200, //每次接口请求的条数，bootstrap table 分页时用到

		maxNameLen: 12, //我的好友或群组列表中名称显示最大长度，仅demo用得到
		reqMsgCount: 15, //每次请求的历史消息(c2c获取群)条数，仅demo用得到

		//存放c2c或者群信息（c2c用户：c2c用户id，昵称，头像；群：群id，群名称，群头像）
		infoMap: {}, //初始化时，可以先拉取我的好友和我的群组信息
		getPrePageC2CHistroyMsgInfoMap: {}, //保留下一次拉取好友历史消息的信息
		getPrePageGroupHistroyMsgInfoMap: {}, //保留下一次拉取群历史消息的信息

		AdminAcount: 'admin001',
		selType: webim.SESSION_TYPE.C2C, //当前聊天类型
		selToID: null, //当前选中聊天id（当聊天类型为私聊时，该值为好友帐号，否则为群号）
		selSess: null, //当前聊天会话对象
		recentSessMap: {}, //保存最近会话列表
		reqRecentSessCount: 50, //每次请求的最近会话条数，业务可以自定义

		isPeerRead: 1,//是否需要支持APP端已读回执的功能,默认为0。是：1，否：0。

		//默认好友头像
		friendHeadUrl: 'images/agent-people-none.png',//仅demo使用，用于没有设置过头像的好友
		//默认群头像
		groupHeadUrl: 'img/group.jpg',//仅demo使用，用于没有设置过群头像的情况

		loginInfo: {
			'sdkAppID': 0, //用户所属应用id,必填
			'identifier': null, //当前用户ID,必须是否字符串类型，必填
			'accountType': 0, //用户所属应用帐号类型，必填
			'userSig': null, //当前用户身份凭证，必须是字符串类型，必填
			'identifierNick': null, //当前用户昵称，不用填写，登录接口会返回用户的昵称，如果没有设置，则返回用户的id
			'headurl': 'images/house-people-none.png' //当前用户默认头像，选填，如果设置过头像，则可以通过拉取个人资料接口来得到头像信息
		},

		listeners: {},
		options: {}
	})
	.service('tmimService', function ($rootScope, $timeout, tmimServiceConfig) {

		tmimServiceConfig.loginInfo.sdkAppID = tmimServiceConfig.sdkAppID;
		tmimServiceConfig.loginInfo.accountType = tmimServiceConfig.accountType;





		var emotionFlag = false; //是否打开过表情选择框

		var curPlayAudio = null; //当前正在播放的audio对象

		var defaultSelGroupId = null; //登录默认选中的群id，选填，仅demo用得到
		var listeners;
		var options;
		function init() {
			var onC2cEventNotifys = {
				"92": onMsgReadedNotify, //消息已读通知,
				"96": onMultipleDeviceKickedOut
			};

			//监听连接状态回调变化事件
			var onConnNotify = function (resp) {
				var info;
				switch (resp.ErrorCode) {
					case webim.CONNECTION_STATUS.ON:
						webim.Log.warn('建立连接成功: ' + resp.ErrorInfo);
						break;
					case webim.CONNECTION_STATUS.OFF:
						info = '连接已断开，无法收到新消息，请检查下你的网络是否正常: ' + resp.ErrorInfo;
						// alert(info);
						webim.Log.warn(info);
						break;
					case webim.CONNECTION_STATUS.RECONNECT:
						info = '连接状态恢复正常: ' + resp.ErrorInfo;
						// alert(info);
						webim.Log.warn(info);
						break;
					default:
						webim.Log.error('未知连接状态: =' + resp.ErrorInfo);
						break;
				}
			};

			//IE9(含)以下浏览器用到的jsonp回调函数
			function jsonpCallback(rspData) {
				webim.setJsonpLastRspData(rspData);
			}
			function onAppliedDownloadUrl(data) {
				console.debug(data);
			}
			//监听事件
			listeners = {
				"onConnNotify": onConnNotify //监听连接状态回调变化事件,必填
				,
				"jsonpCallback": jsonpCallback //IE9(含)以下浏览器用到的jsonp回调函数，
				,
				"onMsgNotify": onMsgNotify //监听新消息(私聊，普通群(非直播聊天室)消息，全员推送消息)事件，必填
				,
				// "onBigGroupMsgNotify": onBigGroupMsgNotify //监听新消息(直播聊天室)事件，直播场景下必填
				// ,
				//"onGroupSystemNotifys": onGroupSystemNotifys //监听（多终端同步）群系统消息事件，如果不需要监听，可不填
				//,
				// "onGroupInfoChangeNotify": onGroupInfoChangeNotify //监听群资料变化事件，选填
				// ,
				//"onFriendSystemNotifys": onFriendSystemNotifys //监听好友系统通知事件，选填
				//,
				// "onProfileSystemNotifys": onProfileSystemNotifys //监听资料系统（自己或好友）通知事件，选填
				// ,
				"onKickedEventCall": onKickedEventCall //被其他登录实例踢下线
				,
				"onC2cEventNotifys": onC2cEventNotifys //监听C2C系统消息通道
				,
				"onAppliedDownloadUrl": onAppliedDownloadUrl //申请文件/音频下载地址的回调
			};

			var isAccessFormalEnv = true; //是否访问正式环境



			var isLogOn = false; //是否开启sdk在控制台打印日志

			//初始化时，其他对象，选填
			options = {
				'isAccessFormalEnv': isAccessFormalEnv, //是否访问正式环境，默认访问正式，选填
				'isLogOn': isLogOn //是否开启控制台打印日志,默认开启，选填
			}



			var msgflow = document.getElementsByClassName("msgflow")[0];
			var bindScrollHistoryEvent = {
				init: function () {
					msgflow.onscroll = function () {
						if (msgflow.scrollTop == 0) {
							msgflow.scrollTop = 10;
							if (selType == webim.SESSION_TYPE.C2C) {
								getPrePageC2CHistoryMsgs();
							} else {
								getPrePageGroupHistoryMsgs();
							}

						}
					}
				},
				reset: function () {
					msgflow.onscroll = null;
				}
			};
		}
		return {
			init: function (info, tmimService_receive_new_msg) {
				onMsgNotify = tmimService_receive_new_msg.onMsgNotify;
				onBigGroupMsgNotify = tmimService_receive_new_msg.onBigGroupMsgNotify;
				onMsgReadedNotify = tmimService_receive_new_msg.onMsgReadedNotify;
				init();
				tmimServiceConfig.loginInfo.identifier = info.webaccountid; //当前用户ID,必须是否字符串类型，必填
				tmimServiceConfig.loginInfo.accountType = tmimServiceConfig.accountType; //用户所属应用帐号类型，必填
				tmimServiceConfig.loginInfo.userSig = info.usersig; //当前用户身份凭证，必须是字符串类型，必填
				tmimServiceConfig.loginInfo.identifierNick = info.realname; //当前用户昵称，不用填写，登录接口会返回用户的昵称，如果没有设置，则返回用户的id
				tmimServiceConfig.loginInfo.headurl = info.headimage ? (_INIT_IMG_YUMING + '/' + info.headimage) : 'images/house-people-none.png'; //当前用户默认头像，选填，如果设置过头像，则可以通过拉取个人资料接口来得到头像信息
				tmimServiceConfig.listeners = listeners;
				tmimServiceConfig.options = options;
			}
		}
	})
	.service('tmimService_login', function ($rootScope, $timeout, tmimServiceConfig) {
		//tls登录
		function tlsLogin() {
			//跳转到TLS登录页面
			TLSHelper.goLogin({
				sdkappid: loginInfo.sdkAppID,
				acctype: loginInfo.accountType,
				url: window.location.href
			});
		}
		//第三方应用需要实现这个函数，并在这里拿到UserSig
		function tlsGetUserSig(res) {
			//成功拿到凭证
			if (res.ErrorCode == webim.TLS_ERROR_CODE.OK) {
				//从当前URL中获取参数为identifier的值
				loginInfo.identifier = webim.Tool.getQueryString("identifier");
				//拿到正式身份凭证
				loginInfo.userSig = res.UserSig;
				//从当前URL中获取参数为sdkappid的值
				loginInfo.sdkAppID = loginInfo.appIDAt3rd = Number(webim.Tool.getQueryString("sdkappid"));
				//从cookie获取accountType
				var accountType = webim.Tool.getCookie('accountType');
				if (accountType) {
					loginInfo.accountType = accountType;
					//sdk登录
					webimLogin();

				} else {
					console.log('accountType非法');
				}
			} else {
				//签名过期，需要重新登录
				if (res.ErrorCode == webim.TLS_ERROR_CODE.SIGNATURE_EXPIRATION) {
					tlsLogin();
				} else {
					console.log("[" + res.ErrorCode + "]" + res.ErrorInfo);
				}
			}
		}

		//sdk登录
		function webimLogin() {
			webim.login(
				tmimServiceConfig.loginInfo, tmimServiceConfig.listeners, tmimServiceConfig.options,
				function (resp) {
					console.log('webim.login.success');
					tmimServiceConfig.loginInfo.identifierNick = resp.identifierNick;//设置当前用户昵称
					tmimServiceConfig.loginInfo.headurl = resp.headurl;//设置当前用户头像
					$rootScope.$broadcast('webim.login.success');
				},
				function (err) {
					console.log(tmimServiceConfig.loginInfo);
					console.log(err.ErrorInfo);
				}
			);
		}
		return {
			tlsLogin: tlsLogin,
			webimLogin: webimLogin
		}
	})
	.service('tmimService_logout', function (tmimServiceConfig) {
		function quitClick() {
			if (tmimServiceConfig.loginInfo.identifier) {
				//sdk登出
				webim.logout(
					function (resp) {
						tmimServiceConfig.loginInfo.identifier = null;
						tmimServiceConfig.loginInfo.userSig = null;
						console.log(resp);
						console.log('登出成功');
					}
				);
			} else {
				console.log('未登录');
			}
		};
		return {
			logout: quitClick
		}
	})
	.service('tmimService_friend_manager', function (tmimServiceConfig) {
		return {
			initInfoMapByMyFriends: function (cbOK) {
				var options = {
					'From_Account': tmimServiceConfig.loginInfo.identifier,
					'TimeStamp': 0,
					'StartIndex': 0,
					'GetCount': tmimServiceConfig.totalCount,
					'LastStandardSequence': 0,
					"TagList": [
						"Tag_Profile_IM_Nick",
						"Tag_Profile_IM_Image"
					]
				};

				webim.getAllFriend(
					options,
					function (resp) {
						if (resp.FriendNum > 0) {
							var friends = resp.InfoItem;
							if (!friends || friends.length == 0) {
								if (cbOK) {
									cbOK();
								}
								return;
							}
							var count = friends.length;

							for (var i = 0; i < count; i++) {
								var friend = friends[i];
								var friend_account = friend.Info_Account;
								var friend_name = friend_image = '';
								for (var j in friend.SnsProfileItem) {
									switch (friend.SnsProfileItem[j].Tag) {
										case 'Tag_Profile_IM_Nick':
											friend_name = friend.SnsProfileItem[j].Value;
											break;
										case 'Tag_Profile_IM_Image':
											friend_image = friend.SnsProfileItem[j].Value;
											break;
									}
								}
								var key = webim.SESSION_TYPE.C2C + "_" + friend_account;
								tmimServiceConfig.infoMap[key] = {
									'name': friend_name,
									'image': friend_image
								};
							}
							if (cbOK) {
								cbOK();
							}
						} else {
							if (cbOK) {
								cbOK();
							}
						}
					},
					function (err) {
						console.log(err.ErrorInfo);
					}
				);
			}
		}
	})
	.service('tmimService_send_common_msg', function ($rootScope, $ionicLoading, tmimServiceConfig) {
		//发送消息(文本或者表情)
		function onSendMsg(msgContent) {

			if (!tmimServiceConfig.selToID) {
				return "你还没有选中好友或者群组，暂不能聊天";
			}
			//获取消息内容
			var msgLen = webim.Tool.getStrBytes(msgContent);

			if (msgContent.length < 1) {
				return "发送的消息不能为空!";
			}
			var maxLen, errInfo;
			if (tmimServiceConfig.selType == webim.SESSION_TYPE.C2C) {
				maxLen = webim.MSG_MAX_LENGTH.C2C;
				errInfo = "消息长度超出限制(最多" + Math.round(maxLen / 3) + "汉字)";
			} else {
				maxLen = webim.MSG_MAX_LENGTH.GROUP;
				errInfo = "消息长度超出限制(最多" + Math.round(maxLen / 3) + "汉字)";
			}
			if (msgLen > maxLen) {
				return errInfo;
			}
			//发消息处理
			return handleMsgSend(msgContent);
		}
		// 处理消息(文本)
		function handleMsgSend(msgContent) {
			if (!tmimServiceConfig.selSess) {
				tmimServiceConfig.selSess = new webim.Session(tmimServiceConfig.selType, tmimServiceConfig.selToID, tmimServiceConfig.selToID, tmimServiceConfig.friendHeadUrl, Math.round(new Date().getTime() / 1000));
			}
			var isSend = true; //是否为自己发送
			var seq = -1; //消息序列，-1表示sdk自动生成，用于去重
			var random = Math.round(Math.random() * 4294967296); //消息随机数，用于去重
			var msgTime = Math.round(new Date().getTime() / 1000); //消息时间戳
			var subType; //消息子类型
			if (tmimServiceConfig.selType == webim.SESSION_TYPE.C2C) {
				tmimServiceConfig.subType = webim.C2C_MSG_SUB_TYPE.COMMON;
			} else {
				//webim.GROUP_MSG_SUB_TYPE.COMMON-普通消息,
				//webim.GROUP_MSG_SUB_TYPE.LOVEMSG-点赞消息，优先级最低
				//webim.GROUP_MSG_SUB_TYPE.TIP-提示消息(不支持发送，用于区分群消息子类型)，
				//webim.GROUP_MSG_SUB_TYPE.REDPACKET-红包消息，优先级最高
				tmimServiceConfig.subType = webim.GROUP_MSG_SUB_TYPE.COMMON;
			}
			var msg = new webim.Msg(tmimServiceConfig.selSess, isSend, seq, random, msgTime, tmimServiceConfig.loginInfo.identifier, subType, tmimServiceConfig.loginInfo.identifierNick);

			var text_obj, face_obj, tmsg, emotionIndex, emotion, restMsgIndex;
			//解析文本和表情
			var expr = /\[[^[\]]{1,3}\]/mg;
			var emotions = msgContent.match(expr);
			if (!emotions || emotions.length < 1) {
				text_obj = new webim.Msg.Elem.Text(msgContent);
				msg.addText(text_obj);
			} else {
				for (var i = 0; i < emotions.length; i++) {
					tmsg = msgContent.substring(0, msgContent.indexOf(emotions[i]));
					if (tmsg) {
						text_obj = new webim.Msg.Elem.Text(tmsg);
						msg.addText(text_obj);
					}
					emotionIndex = webim.EmotionDataIndexs[emotions[i]];
					emotion = webim.Emotions[emotionIndex];

					if (emotion) {
						face_obj = new webim.Msg.Elem.Face(emotionIndex, emotions[i]);
						msg.addFace(face_obj);
					} else {
						text_obj = new webim.Msg.Elem.Text(emotions[i]);
						msg.addText(text_obj);
					}
					restMsgIndex = msgContent.indexOf(emotions[i]) + emotions[i].length;
					msgContent = msgContent.substring(restMsgIndex);
				}
				if (msgContent) {
					text_obj = new webim.Msg.Elem.Text(msgContent);
					msg.addText(text_obj);
				}
			}

			msg.PushInfo = {
				"PushFlag": 0,
				"Desc": '测试离线推送内容', //离线推送内容
				"Ext": '测试离线推送透传内容', //离线推送透传内容
				"AndroidInfo": {
					"Sound": "android.mp3" //离线推送声音文件路径。
				},
				"ApnsInfo": {
					"Sound": "apns.mp3", //离线推送声音文件路径。
					"BadgeMode": 1
				}
			};

			msg.PushInfoBoolean = true; //是否开启离线推送push同步
			msg.sending = 1;
			msg.originContent = msgContent;
			//addMsg(msg);

			webim.sendMsg(msg, function (resp) {
				//发送成功，把sending清理
				console.log(resp);
				$rootScope.$broadcast('webim.sendmsg.success');
				//$("#id_" + msg.random).find(".spinner").remove();
				webim.Tool.setCookie("tmpmsg_" + tmimServiceConfig.selToID, '', 0);
			}, function (err) {
				console.log(err.ErrorInfo);
				$rootScope.$broadcast('webim.sendmsg.failed');
				//提示重发
				showReSend(msg);
			});
			return msg;
		}
		function base64toFile(base64) {
			var arr = base64.split(','), mime = arr[0].match(/:(.*?);/)[1],
				bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
			while (n--) {
				u8arr[n] = bstr.charCodeAt(n);
			}
			var blob  = new Blob([u8arr], { type: mime });
			return blob;
		};
		// 处理消息(图片)
		function uploadPic(base64) {
			var file = base64toFile('data:image/png;base64,' + base64);
			var selType = tmimServiceConfig.selType;
			var businessType; //业务类型，1-发群图片，2-向好友发图片
			if (selType == webim.SESSION_TYPE.C2C) { //向好友发图片
				businessType = webim.UPLOAD_PIC_BUSSINESS_TYPE.C2C_MSG;
			} else if (selType == webim.SESSION_TYPE.GROUP) { //发群图片
				businessType = webim.UPLOAD_PIC_BUSSINESS_TYPE.GROUP_MSG;
			}
			//封装上传图片请求
			var opt = {
				'file': file, //图片对象
				'onProgressCallBack': onProgressCallBack, //上传图片进度条回调函数
				//'abortButton': document.getElementById('upd_abort'), //停止上传图片按钮
				'To_Account': tmimServiceConfig.selToID, //接收者
				'businessType': businessType //业务类型
			};
			//上传图片
			webim.uploadPic(opt,
				function(resp) {
					//上传成功发送图片
					sendPic(resp, 'uploadimage.jpg');
					$ionicLoading.hide();
				},
				function(err) {
					console.log(err.ErrorInfo);
					$ionicLoading.hide();
				}
			);
		}
		//发送图片消息

		function sendPic(images, imgName) {
			console.debug('sendPic', imgName);
			if (!tmimServiceConfig.selToID) {
				alert("您还没有好友，暂不能聊天");
				return;
			}

			if (!tmimServiceConfig.selSess) {
				tmimServiceConfig.selSess = new webim.Session(tmimServiceConfig.selType, tmimServiceConfig.selToID, tmimServiceConfig.selToID, tmimServiceConfig.friendHeadUrl, Math.round(new Date().getTime() / 1000));
			}
			var msg = new webim.Msg(selSess, true, -1, -1, -1, tmimServiceConfig.loginInfo.identifier, 0, tmimServiceConfig.loginInfo.identifierNick);

			console.debug(imgName.split(".")[1]);
			var images_obj = new webim.Msg.Elem.Images(images.File_UUID, imgName.split(".")[1]);
			for (var i in images.URL_INFO) {
				var img = images.URL_INFO[i];
				var newImg;
				var type;
				switch (img.PIC_TYPE) {
					case 1: //原图
						type = 1; //原图
						break;
					case 2: //小图（缩略图）
						type = 3; //小图
						break;
					case 4: //大图
						type = 2; //大图
						break;
				}
				newImg = new webim.Msg.Elem.Images.Image(type, img.PIC_Size, img.PIC_Width, img.PIC_Height, img.DownUrl);
				images_obj.addImage(newImg);
			}
			msg.addImage(images_obj);
			//if(imgName){
			//    var data=imgName;//通过自定义消息中的data字段保存图片名称
			//    var custom_obj = new webim.Msg.Elem.Custom(data, '', '');
			//    msg.addCustom(custom_obj);
			//}
			//调用发送图片消息接口
			webim.sendMsg(msg, function (resp) {
				if (tmimServiceConfig.selType == webim.SESSION_TYPE.C2C) { //私聊时，在聊天窗口手动添加一条发的消息，群聊时，长轮询接口会返回自己发的消息
					$rootScope.$broadcast('webim.get.history.msg.success', msg);
				}
			}, function (err) {
				console.log(err.ErrorInfo);
			});
		}
		function showReSend(msg) {
			/*
			//resend a dom
			var resendBtn = $('<a href="javascript:;">重发</a>');
			//绑定重发事件
			resendBtn.click(function () {
				//删除当前的dom
				$("#id_" + msg.random).remove();
				//发消息处理
				handleMsgSend(msg.originContent);
			});
			$("#id_" + msg.random).find(".spinner").empty().append(resendBtn);
			*/
			console.log('发送失败');
		}

		function onProgressCallBack(loadedSize, totalSize) {
			
			var downloadProgress = loadedSize / totalSize * 100;
			$ionicLoading.show({
				template: "已经上传：" + Math.floor(downloadProgress) + "%"
			});
			var progress = document.getElementById('upd_progress'); //上传图片进度条
			progress.value = (loadedSize / totalSize) * 100;
		}
		return {
			onSendMsg: onSendMsg,
			uploadPic: uploadPic,
			handleMsgSend: handleMsgSend
		}
	})
	.service('tmimService_show_one_msg', function ($rootScope, $timeout, tmimServiceConfig) {
		//聊天页面增加一条消息
		function addMsg(msg, prepend) {
			var isSelfSend, fromAccount, fromAccountNick, fromAccountImage, sessType, subType;


			//获取会话类型，目前只支持群聊
			//webim.SESSION_TYPE.GROUP-群聊，
			//webim.SESSION_TYPE.C2C-私聊，
			sessType = msg.getSession().type();

			isSelfSend = msg.getIsSend();//消息是否为自己发的

			fromAccount = msg.getFromAccount();
			if (!fromAccount) {
				return;
			}
			if (isSelfSend) {//如果是自己发的消息
				if (tmimServiceConfig.loginInfo.identifierNick) {
					fromAccountNick = tmimServiceConfig.loginInfo.identifierNick;
				} else {
					fromAccountNick = fromAccount;
				}
				//获取头像
				if (tmimServiceConfig.loginInfo.headurl) {
					fromAccountImage = tmimServiceConfig.loginInfo.headurl;
				} else {
					fromAccountImage = tmimServiceConfig.friendHeadUrl;
				}
			} else {//如果别人发的消息
				var key = webim.SESSION_TYPE.C2C + "_" + fromAccount;
				var info = tmimServiceConfig.infoMap[key];
				if (info && info.name) {
					fromAccountNick = info.name;
				} else if (msg.getFromAccountNick()) {
					fromAccountNick = msg.getFromAccountNick();
				} else {
					fromAccountNick = fromAccount;
				}
				//获取头像
				if (info && info.image) {
					fromAccountImage = info.image;
				} else if (msg.fromAccountHeadurl) {
					fromAccountImage = msg.fromAccountHeadurl;
				} else {
					fromAccountImage = tmimServiceConfig.friendHeadUrl;
				}
			}

			onemsg = {};
			if (msg.sending) {
				onemsg.id = "id_" + msg.random;
				//发送中
				var spinner = {};
				spinner.className = "spinner";
				spinner.innerHTML = '<div class="bounce1"></div> <div class="bounce2"></div> <div class="bounce3"></div>';
				onemsg.spinner = spinner;
			}

			onemsg.className = "onemsg";
			// var msghead = document.createElement("p");
			// var msgbody = document.createElement("p");
			// var msgPre = document.createElement("pre");
			var msghead = {};
			var msgbody = {};
			var msgPre = {};
			// msghead.className = "msghead";
			msgbody.className = "msgbody";


			//如果是发给自己的消息
			if (!isSelfSend) {
				// msghead.style.color = "blue";
			}
			//昵称  消息时间
			// msghead.innerHTML = "<img class='headurlClass' src='" + fromAccountImage + "'>" + "&nbsp;&nbsp;" + webim.Tool.formatText2Html(fromAccountNick + "&nbsp;&nbsp;" + webim.Tool.formatTimeStamp(msg.getTime()));
			msghead = {
				headimg: fromAccountImage,
				account: fromAccountNick,
				timestamp: webim.Tool.formatTimeStamp(msg.getTime())
			}

			//解析消息

			//获取消息子类型
			//会话类型为群聊时，子类型为：webim.GROUP_MSG_SUB_TYPE
			//会话类型为私聊时，子类型为：webim.C2C_MSG_SUB_TYPE
			subType = msg.getSubType();


			switch (subType) {
				case webim.C2C_MSG_SUB_TYPE:
				case webim.GROUP_MSG_SUB_TYPE.COMMON://群普通消息
					msgPre.html = convertMsgtoHtml(msg);
					break;
				case webim.GROUP_MSG_SUB_TYPE.REDPACKET://群红包消息
					msgPre.html = "[群红包消息]" + convertMsgtoHtml(msg);
					break;
				case webim.GROUP_MSG_SUB_TYPE.LOVEMSG://群点赞消息
					//业务自己可以增加逻辑，比如展示点赞动画效果
					msgPre.html = "[群点赞消息]" + convertMsgtoHtml(msg);
					//展示点赞动画
					//showLoveMsgAnimation();
					break;
				case webim.GROUP_MSG_SUB_TYPE.TIP://群提示消息
					msgPre.html = "[群提示消息]" + convertMsgtoHtml(msg);
					break;
			}

			// msgbody.appendChild(msgPre);

			// onemsg.appendChild(msghead);
			// onemsg.appendChild(msgbody);
			msgbody.msgPre = msgPre;
			onemsg.msghead = msghead;
			onemsg.msgbody = msgbody;
			//消息列表
			// var msgflow = document.getElementsByClassName("msgflow")[0];
			// if (prepend) {
			// 	//300ms后,等待图片加载完，滚动条自动滚动到底部
			// 	msgflow.insertBefore(onemsg, msgflow.firstChild);
			// 	if (msgflow.scrollTop == 0) {
			// 		setTimeout(function () {
			// 			msgflow.scrollTop = 0;
			// 		}, 300);
			// 	}
			// } else {
			// 	msgflow.appendChild(onemsg);
			// 	//300ms后,等待图片加载完，滚动条自动滚动到底部
			// 	setTimeout(function () {
			// 		msgflow.scrollTop = msgflow.scrollHeight;
			// 	}, 300);
			// }
			return onemsg;
		}
		//把消息转换成Html
		function convertMsgtoHtml(msg) {
			var html = "",
				elems, elem, type, content;
			elems = msg.getElems(); //获取消息包含的元素数组
			var count = elems.length;
			for (var i = 0; i < count; i++) {
				elem = elems[i];
				type = elem.getType();//获取元素类型
				content = elem.getContent();//获取元素对象
				switch (type) {
					case webim.MSG_ELEMENT_TYPE.TEXT:
						var eleHtml = convertTextMsgToHtml(content);
						//转义，防XSS
						//html += webim.Tool.formatText2Html(eleHtml);
						html += eleHtml;
						break;
					case webim.MSG_ELEMENT_TYPE.FACE:
						html += convertFaceMsgToHtml(content);
						break;
					case webim.MSG_ELEMENT_TYPE.IMAGE:
						if (i <= count - 2) {
							var customMsgElem = elems[i + 1];//获取保存图片名称的自定义消息elem
							var imgName = customMsgElem.getContent().getData();//业务可以自定义保存字段，demo中采用data字段保存图片文件名
							html += convertImageMsgToHtml(content, imgName);
							i++;//下标向后移一位
						} else {
							html += convertImageMsgToHtml(content);
						}
						break;
					case webim.MSG_ELEMENT_TYPE.SOUND:
						html += convertSoundMsgToHtml(content);
						break;
					case webim.MSG_ELEMENT_TYPE.FILE:
						html += convertFileMsgToHtml(content);
						break;
					case webim.MSG_ELEMENT_TYPE.LOCATION:
						html += convertLocationMsgToHtml(content);
						break;
					case webim.MSG_ELEMENT_TYPE.CUSTOM:
						var eleHtml = convertCustomMsgToHtml(content);
						//转义，防XSS
						html += webim.Tool.formatText2Html(eleHtml);
						break;
					case webim.MSG_ELEMENT_TYPE.GROUP_TIP:
						var eleHtml = convertGroupTipMsgToHtml(content);
						//转义，防XSS
						html += webim.Tool.formatText2Html(eleHtml);
						break;
					default:
						webim.Log.error('未知消息元素类型: elemType=' + type);
						break;
				}
			}
			return html;
		}

		//解析文本消息元素
		function convertTextMsgToHtml(content) {
			var text = content.getText();
			if (text.split('linkid').length > 1) {
				try {
					var obj = {
						linkid: text.split('linkid:')[1].split(',')[0],
						xqid: text.split('xqid:')[1].split(',')[0],
						linkimg: text.split('linkimg:')[1].split(',')[0],
						linkname: text.split('linkname:')[1].split(',')[0],
						linkprice: text.split('linkprice:')[1].split(',')[0],
						type: text.split('type:')[1].split(',')[0]
					};
					var linkurl = '';
					if (obj.type == 1) {
						linkurl = '#/gpfy/gpxxinfo/' + obj.linkid + '/' +  obj.xqid;
					} else {
						//linkurl = '#/community/detail/' + obj.linkid;
					}
					var fulltext = '<a href="' + linkurl + '" class="system-chat-right2 screen-display-block">'
					+'<div class="system-chat-right-mian">'
					+'<div class="system-chat-right-mian-left">'
					+	'<img src="' + obj.linkimg + '" class="mini"/>'
					+'</div>'
					+'<div class="system-chat-right-mian-right f_gray3 ">'
						+'<div class="toverF2 f14 f_gray line26" >'+
						obj.linkname
						+'</div>'
						+'<div class="f12 f_gray8 line26"><font class="f14 f_red mr5">' + obj.linkprice.split(' ')[0] + '</font>' + obj.linkprice.split(' ')[1]+
						'</div>'
					+'</div>'
				+'</div>'
				+'</a>';
					return fulltext;
				} catch (e) {
					console.log(e);
					return text;
				}
			} else {
				return text;
			}
		}
		//解析表情消息元素
		function convertFaceMsgToHtml(content) {
			var faceUrl = null;
			var data = content.getData();
			var index = webim.EmotionDataIndexs[data];

			var emotion = webim.Emotions[index];
			if (emotion && emotion[1]) {
				faceUrl = emotion[1];
			}
			if (faceUrl) {
				return "<img src='" + faceUrl + "'/>";
			} else {
				return data;
			}
		}
		//解析图片消息元素
		function convertImageMsgToHtml(content, imageName) {
			var smallImage = content.getImage(webim.IMAGE_TYPE.SMALL);//小图
			var bigImage = content.getImage(webim.IMAGE_TYPE.LARGE);//大图
			var oriImage = content.getImage(webim.IMAGE_TYPE.ORIGIN);//原图
			if (!bigImage) {
				bigImage = smallImage;
			}
			if (!oriImage) {
				oriImage = smallImage;
			}
			return "<img name='" + imageName + "' src='" + smallImage.getUrl() + "#" + bigImage.getUrl() + "#" + oriImage.getUrl() + "' style='CURSOR: hand' id='" + content.getImageId() + "' bigImgUrl='" + bigImage.getUrl() + "' onclick='imageClick(this)' />";
		}
		//解析语音消息元素
		function convertSoundMsgToHtml(content) {
			var second = content.getSecond();//获取语音时长
			var downUrl = content.getDownUrl();
			if (webim.BROWSER_INFO.type == 'ie' && parseInt(webim.BROWSER_INFO.ver) <= 8) {
				return '[这是一条语音消息]demo暂不支持ie8(含)以下浏览器播放语音,语音URL:' + downUrl;
			}
			return '<audio id="uuid_' + content.uuid + '" src="' + downUrl + '" controls="controls" onplay="onChangePlayAudio(this)" preload="none"></audio>';
		}
		//解析文件消息元素
		function convertFileMsgToHtml(content) {
			var fileSize, unitStr;
			fileSize = content.getSize();
			unitStr = "Byte";
			if (fileSize >= 1024) {
				fileSize = Math.round(fileSize / 1024);
				unitStr = "KB";
			}
			// return '<a href="' + content.getDownUrl() + '" title="点击下载文件" ><i class="glyphicon glyphicon-file">&nbsp;' + content.getName() + '(' + fileSize + unitStr + ')</i></a>';

			return '<a href="javascript:;" onclick=\'webim.onDownFile("' + content.uuid + '")\' title="点击下载文件" ><i class="glyphicon glyphicon-file">&nbsp;' + content.name + '(' + fileSize + unitStr + ')</i></a>';
		}
		//解析位置消息元素
		function convertLocationMsgToHtml(content) {
			return '经度=' + content.getLongitude() + ',纬度=' + content.getLatitude() + ',描述=' + content.getDesc();
		}
		//解析自定义消息元素
		function convertCustomMsgToHtml(content) {
			var data = content.getData();//自定义数据
			var desc = content.getDesc();//描述信息
			var ext = content.getExt();//扩展信息
			return "data=" + data + ", desc=" + desc + ", ext=" + ext;
		}
		//解析群提示消息元素
		function convertGroupTipMsgToHtml(content) {
			var WEB_IM_GROUP_TIP_MAX_USER_COUNT = 10;
			var text = "";
			var maxIndex = WEB_IM_GROUP_TIP_MAX_USER_COUNT - 1;
			var opType, opUserId, userIdList;
			var groupMemberNum;
			opType = content.getOpType();//群提示消息类型（操作类型）
			opUserId = content.getOpUserId();//操作人id
			switch (opType) {
				case webim.GROUP_TIP_TYPE.JOIN://加入群
					userIdList = content.getUserIdList();
					//text += opUserId + "邀请了";
					for (var m in userIdList) {
						text += userIdList[m] + ",";
						if (userIdList.length > WEB_IM_GROUP_TIP_MAX_USER_COUNT && m == maxIndex) {
							text += "等" + userIdList.length + "人";
							break;
						}
					}
					text = text.substring(0, text.length - 1);
					text += "加入该群，当前群成员数：" + content.getGroupMemberNum();
					break;
				case webim.GROUP_TIP_TYPE.QUIT://退出群
					text += opUserId + "离开该群，当前群成员数：" + content.getGroupMemberNum();
					break;
				case webim.GROUP_TIP_TYPE.KICK://踢出群
					text += opUserId + "将";
					userIdList = content.getUserIdList();
					for (var m in userIdList) {
						text += userIdList[m] + ",";
						if (userIdList.length > WEB_IM_GROUP_TIP_MAX_USER_COUNT && m == maxIndex) {
							text += "等" + userIdList.length + "人";
							break;
						}
					}
					text += "踢出该群";
					break;
				case webim.GROUP_TIP_TYPE.SET_ADMIN://设置管理员
					text += opUserId + "将";
					userIdList = content.getUserIdList();
					for (var m in userIdList) {
						text += userIdList[m] + ",";
						if (userIdList.length > WEB_IM_GROUP_TIP_MAX_USER_COUNT && m == maxIndex) {
							text += "等" + userIdList.length + "人";
							break;
						}
					}
					text += "设为管理员";
					break;
				case webim.GROUP_TIP_TYPE.CANCEL_ADMIN://取消管理员
					text += opUserId + "取消";
					userIdList = content.getUserIdList();
					for (var m in userIdList) {
						text += userIdList[m] + ",";
						if (userIdList.length > WEB_IM_GROUP_TIP_MAX_USER_COUNT && m == maxIndex) {
							text += "等" + userIdList.length + "人";
							break;
						}
					}
					text += "的管理员资格";
					break;

				case webim.GROUP_TIP_TYPE.MODIFY_GROUP_INFO://群资料变更
					text += opUserId + "修改了群资料：";
					var groupInfoList = content.getGroupInfoList();
					var type, value;
					for (var m in groupInfoList) {
						type = groupInfoList[m].getType();
						value = groupInfoList[m].getValue();
						switch (type) {
							case webim.GROUP_TIP_MODIFY_GROUP_INFO_TYPE.FACE_URL:
								text += "群头像为" + value + "; ";
								break;
							case webim.GROUP_TIP_MODIFY_GROUP_INFO_TYPE.NAME:
								text += "群名称为" + value + "; ";
								break;
							case webim.GROUP_TIP_MODIFY_GROUP_INFO_TYPE.OWNER:
								text += "群主为" + value + "; ";
								break;
							case webim.GROUP_TIP_MODIFY_GROUP_INFO_TYPE.NOTIFICATION:
								text += "群公告为" + value + "; ";
								break;
							case webim.GROUP_TIP_MODIFY_GROUP_INFO_TYPE.INTRODUCTION:
								text += "群简介为" + value + "; ";
								break;
							default:
								text += "未知信息为:type=" + type + ",value=" + value + "; ";
								break;
						}
					}
					break;

				case webim.GROUP_TIP_TYPE.MODIFY_MEMBER_INFO://群成员资料变更(禁言时间)
					text += opUserId + "修改了群成员资料:";
					var memberInfoList = content.getMemberInfoList();
					var userId, shutupTime;
					for (var m in memberInfoList) {
						userId = memberInfoList[m].getUserId();
						shutupTime = memberInfoList[m].getShutupTime();
						text += userId + ": ";
						if (shutupTime != null && shutupTime !== undefined) {
							if (shutupTime == 0) {
								text += "取消禁言; ";
							} else {
								text += "禁言" + shutupTime + "秒; ";
							}
						} else {
							text += " shutupTime为空";
						}
						if (memberInfoList.length > WEB_IM_GROUP_TIP_MAX_USER_COUNT && m == maxIndex) {
							text += "等" + memberInfoList.length + "人";
							break;
						}
					}
					break;
				default:
					text += "未知群提示消息类型：type=" + opType;
					break;
			}
			return text;
		}
		return {
			addMsg: addMsg,
			convertTextMsgToHtml: convertTextMsgToHtml
		}
	})
	.service('tmimService_receive_new_msg', function ($rootScope, $timeout, tmimServiceConfig) {
		//监听新消息事件
		var msgList = [];
		var dateStart = null;
		var dateEnd = null;
		//newMsgList 为新消息数组，结构为[Msg]
		function onMsgNotify(newMsgList) {
			console.warn(newMsgList[0].formAccount);
			console.log(typeof newMsgList);
			console.log(JSON.stringify(newMsgList[0].elems[0]));
			// fromAccount
			if (typeof cordova != 'undefined') {
				var from = '';
				if (typeof $rootScope.imnames != 'undefined' && $rootScope.imnames[newMsgList[0].formAccount]) {
					from = $rootScope.imnames[newMsgList[0].formAccount] + ':';
					cordova.plugins.notification.local.schedule({
						title: "您有新的消息",
						text: from + newMsgList[0].elems[0].content.text,
						data: { fromAccount: newMsgList[0].fromAccount }
					});
				}
			}
			$rootScope.$broadcast('webim.msg.success.needfrom', newMsgList[0].elems[0].content.text, newMsgList[0].fromAccount);
			var sess, newMsg;
			//获取所有聊天会话
			var sessMap = webim.MsgStore.sessMap();

			for (var j in newMsgList) {//遍历新消息
				newMsg = newMsgList[j];
				var selToID = tmimServiceConfig.selToID;
				var selType = tmimServiceConfig.selType;
				if (!selToID) {//没有聊天对象
					selToID = newMsg.getSession().id();
					selType = newMsg.getSession().type();
					selSess = newMsg.getSession();
					var headUrl;
					if (selType == webim.SESSION_TYPE.C2C) {
						headUrl = tmimServiceConfig.friendHeadUrl;
					} else {
						headUrl = tmimServiceConfig.groupHeadUrl;
					}
					// addSess(selType, selToID, newMsg.getSession().name(), headUrl, 0, 'sesslist');//新增一个对象
					// setSelSessStyleOn(selToID);
				}
				if (newMsg.getSession().id() == selToID) {//为当前聊天对象的消息
					//在聊天窗体中新增一条消息
					//console.warn(newMsg);
					//addMsg(newMsg);
					$rootScope.$broadcast('webim.get.history.msg.success', newMsg);
				}
				msgList.push(newMsg.elems[0].content.text);
			}
			//消息已读上报，以及设置会话自动已读标记
			webim.setAutoRead(selSess, true, true);

			for (var i in sessMap) {
				sess = sessMap[i];
				if (selToID != sess.id()) {//更新其他聊天对象的未读消息数
					if (!dateStart) {
						dateStart = new Date();
					}
					//updateSessDiv(sess.type(), sess.id(), sess.name(), sess.unread());
					console.debug(sess.id(), sess.unread());
					dateEnd = new Date();
				}
			}
		}

		//监听直播聊天室新消息事件
		//newMsgList 为新消息数组，结构为[Msg]
		//监听大群新消息（普通，点赞，提示，红包）
		function onBigGroupMsgNotify(newMsgList) {
			var newMsg;
			for (var i = newMsgList.length - 1; i >= 0; i--) {//遍历消息，按照时间从后往前
				newMsg = newMsgList[i];
				webim.Log.warn('receive a new group(AVChatRoom) msg: ' + newMsg.getFromAccountNick());
				//显示收到的消息
				//addMsg(newMsg);
				$rootScope.$broadcast('webim.get.history.msg.success', newMsg);
			}
		}


		//消息已读通知
		function onMsgReadedNotify(notify) {
			var sessMap = webim.MsgStore.sessMap()[webim.SESSION_TYPE.C2C + notify.From_Account];
			if (sessMap) {
				var msgs = _.clone(sessMap.msgs());
				var rm_msgs = _.remove(msgs, function (m) {
					return m.time <= notify.LastReadTime
				});
				var unread = sessMap.unread() - rm_msgs.length;
				unread = unread > 0 ? unread : 0;
				//更新sess的未读数
				sessMap.unread(unread);
				// console.debug('更新C2C未读数:',notify.From_Account,unread);
				//更新页面的未读数角标
				console.log(notify);
				if (unread > 0) {
					$("#badgeDiv_" + notify.From_Account).text(unread).show();
				} else {
					$("#badgeDiv_" + notify.From_Account).val("").hide();
				}
			}
		}

		return {
			onMsgNotify: onMsgNotify,
			onBigGroupMsgNotify: onBigGroupMsgNotify,
			onMsgReadedNotify: onMsgReadedNotify
		}

	})
	.service('tmimService_get_history_msg', function ($rootScope, $timeout, tmimServiceConfig) {
		//获取历史消息(c2c或者group)成功回调函数
		//msgList 为消息数组，结构为[Msg]
		if (typeof cordova == 'undefined') {
			function getHistoryMsgCallback(msgList, prepage) {
				var msg;
				prepage = prepage || false;

				//如果是加载前几页的消息，消息体需要prepend，所以先倒排一下
				if (prepage) {
					msgList.reverse();
				}

				for (var j in msgList) {//遍历新消息
					msg = msgList[j];
					if (msg.getSession().id() == tmimServiceConfig.selToID) {//为当前聊天对象的消息
						selSess = msg.getSession();
						//在聊天窗体中新增一条消息
						//addMsg(msg, prepage);
						$rootScope.$broadcast('webim.get.history.msg.success', msg, prepage);
					}
					// 消息列表遍历完后发送通知告诉页面已经加载完了
					if (j == msgList.length - 1) {
						$rootScope.$broadcast('webim.get.history.msg.success.allover', j);
					}
				}
				//消息已读上报，并将当前会话的消息设置成自动已读
				webim.setAutoRead(selSess, true, true);
			}

			//获取最新的c2c历史消息,用于切换好友聊天，重新拉取好友的聊天消息
			var getLastC2CHistoryMsgs = function (cbOk, cbError) {
				if (tmimServiceConfig.selType == webim.SESSION_TYPE.GROUP) {
					alert('当前的聊天类型为群聊天，不能进行拉取好友历史消息操作');
					return;
				}
				if (!tmimServiceConfig.selToID || tmimServiceConfig.selToID == '@TIM#SYSTEM') {
					alert('当前的聊天id非法，selToID=' + tmimServiceConfig.selToID);
					return;
				}
				var lastMsgTime = 0;//第一次拉取好友历史消息时，必须传0
				var msgKey = '';
				var options = {
					'Peer_Account': tmimServiceConfig.selToID, //好友帐号
					'MaxCnt': tmimServiceConfig.reqMsgCount, //拉取消息条数
					'LastMsgTime': lastMsgTime, //最近的消息时间，即从这个时间点向前拉取历史消息
					'MsgKey': msgKey
				};
				selSess = null;
				webim.MsgStore.delSessByTypeId(tmimServiceConfig.selType, tmimServiceConfig.selToID);


				webim.getC2CHistoryMsgs(
					options,
					function (resp) {
						var complete = resp.Complete;//是否还有历史消息可以拉取，1-表示没有，0-表示有

						if (resp.MsgList.length == 0) {
							webim.Log.warn("没有历史消息了:data=" + JSON.stringify(options));
							return;
						}
						tmimServiceConfig.getPrePageC2CHistroyMsgInfoMap[tmimServiceConfig.selToID] = {//保留服务器返回的最近消息时间和消息Key,用于下次向前拉取历史消息
							'LastMsgTime': resp.LastMsgTime,
							'MsgKey': resp.MsgKey
						};
						//清空聊天界面
						// document.getElementsByClassName("msgflow")[0].innerHTML = "";
						if (cbOk) {
							cbOk(resp.MsgList);
						}
					},
					cbError
				);
			};

			//向上翻页，获取更早的好友历史消息
			var getPrePageC2CHistoryMsgs = function (cbOk, cbError) {
				if (tmimServiceConfig.selType == webim.SESSION_TYPE.GROUP) {
					alert('当前的聊天类型为群聊天，不能进行拉取好友历史消息操作');
					return;
				}
				var tempInfo = tmimServiceConfig.getPrePageC2CHistroyMsgInfoMap[tmimServiceConfig.selToID];//获取下一次拉取的c2c消息时间和消息Key
				var lastMsgTime;
				var msgKey;
				if (tempInfo) {
					lastMsgTime = tempInfo.LastMsgTime;
					msgKey = tempInfo.MsgKey;
				} else {
					console.log('获取下一次拉取的c2c消息时间和消息Key为空');
					return;
				}
				var options = {
					'Peer_Account': selToID, //好友帐号
					'MaxCnt': tmimServiceConfig.reqMsgCount, //拉取消息条数
					'LastMsgTime': lastMsgTime, //最近的消息时间，即从这个时间点向前拉取历史消息
					'MsgKey': msgKey
				};
				webim.getC2CHistoryMsgs(
					options,
					function (resp) {
						var complete = resp.Complete;//是否还有历史消息可以拉取，1-表示没有，0-表示有
						if (resp.MsgList.length == 0) {
							webim.Log.warn("没有历史消息了:data=" + JSON.stringify(options));
							return;
						}
						tmimServiceConfig.getPrePageC2CHistroyMsgInfoMap[tmimServiceConfig.selToID] = {//保留服务器返回的最近消息时间和消息Key,用于下次向前拉取历史消息
							'LastMsgTime': resp.LastMsgTime,
							'MsgKey': resp.MsgKey
						};
						if (cbOk) {
							cbOk(resp.MsgList);
						} else {
							getHistoryMsgCallback(resp.MsgList, true);
						}
					},
					cbError
				);
			};

			//获取最新的群历史消息,用于切换群组聊天时，重新拉取群组的聊天消息
			var getLastGroupHistoryMsgs = function (cbOk) {
				if (tmimServiceConfig.selType == webim.SESSION_TYPE.C2C) {
					alert('当前的聊天类型为好友聊天，不能进行拉取群历史消息操作');
					return;
				}
				getGroupInfo(selToID, function (resp) {
					//拉取最新的群历史消息
					var options = {
						'GroupId': selToID,
						'ReqMsgSeq': resp.GroupInfo[0].NextMsgSeq - 1,
						'ReqMsgNumber': tmimServiceConfig.reqMsgCount
					};
					if (options.ReqMsgSeq == null || options.ReqMsgSeq == undefined || options.ReqMsgSeq <= 0) {
						webim.Log.warn("该群还没有历史消息:options=" + JSON.stringify(options));
						return;
					}
					selSess = null;
					webim.MsgStore.delSessByTypeId(selType, selToID);
					recentSessMap[webim.SESSION_TYPE.GROUP + "_" + selToID] = {};

					recentSessMap[webim.SESSION_TYPE.GROUP + "_" + selToID].MsgGroupReadedSeq = resp.GroupInfo && resp.GroupInfo[0] && resp.GroupInfo[0].MsgSeq;
					webim.syncGroupMsgs(
						options,
						function (msgList) {
							if (msgList.length == 0) {
								webim.Log.warn("该群没有历史消息了:options=" + JSON.stringify(options));
								return;
							}
							var msgSeq = msgList[0].seq - 1;
							tmimServiceConfig.getPrePageGroupHistroyMsgInfoMap[selToID] = {
								"ReqMsgSeq": msgSeq
							};
							//清空聊天界面
							document.getElementsByClassName("msgflow")[0].innerHTML = "";
							if (cbOk)
								cbOk(msgList);
						},
						function (err) {
							console.log(err.ErrorInfo);
						}
					);
				});
			};

			//向上翻页，获取更早的群历史消息
			var getPrePageGroupHistoryMsgs = function (cbOk) {
				if (selType == webim.SESSION_TYPE.C2C) {
					alert('当前的聊天类型为好友聊天，不能进行拉取群历史消息操作');
					return;
				}
				var tempInfo = tmimServiceConfig.getPrePageGroupHistroyMsgInfoMap[selToID];//获取下一次拉取的群消息seq
				var reqMsgSeq;
				if (tempInfo) {
					reqMsgSeq = tempInfo.ReqMsgSeq;
					if (reqMsgSeq <= 0) {
						webim.Log.warn('该群没有历史消息可拉取了');
						return;
					}
				} else {
					webim.Log.error('获取下一次拉取的群消息seq为空');
					return;
				}
				var options = {
					'GroupId': selToID,
					'ReqMsgSeq': reqMsgSeq,
					'ReqMsgNumber': tmimServiceConfig.reqMsgCount
				};

				webim.syncGroupMsgs(
					options,
					function (msgList) {
						if (msgList.length == 0) {
							webim.Log.warn("该群没有历史消息了:options=" + JSON.stringify(options));
							return;
						}
						var msgSeq = msgList[0].seq - 1;
						tmimServiceConfig.getPrePageGroupHistroyMsgInfoMap[selToID] = {
							"ReqMsgSeq": msgSeq
						};

						if (cbOk) {
							cbOk(msgList);
						} else {
							getHistoryMsgCallback(msgList, true);
						}
					},
					function (err) {
						console.log(err.ErrorInfo);
					}
				);
			};
			return {
				getHistoryMsgCallback: getHistoryMsgCallback,
				getLastC2CHistoryMsgs: getLastC2CHistoryMsgs,
				getPrePageC2CHistoryMsgs: getPrePageC2CHistoryMsgs,
				getLastGroupHistoryMsgs: getLastGroupHistoryMsgs,
				getPrePageGroupHistoryMsgs: getPrePageGroupHistoryMsgs
			}
		}
	})
	;
