﻿(function () {
	/*
	 coder chenja
	 */
	'use strict';
	angular.module('tmlocation', [])
		.service('locationService', function ($rootScope, $timeout) {
			var _this = this;
			$rootScope.position = {
				x: 120.5916941890,
				y: 31.3053856841
			};
			$rootScope.Bposition = {
				x: 120.5916941890,
				y: 31.3053856841
			};
			if (!localStorage.position) {
				localStorage.position = '{"x":"120.5916941890","y":"31.3053856841"}';
			}
			if (!localStorage.Bposition) {
				localStorage.Bposition = '{"x":"120.5916941890","y":"31.3053856841"}';
			}
			/**
			 * 坐标转换, GPS坐标转换为百度坐标
			 */
			function convertor() {
				var point = new BMap.Point($rootScope.position.x, $rootScope.position.y); // 创建点坐标
				var convertor = new BMap.Convertor();
				var pointArr = [];
				pointArr.push(point);
				convertor.translate(pointArr, 1, 5, function(data) {
					if(data.status === 0) {
						$rootScope.Bposition = {
							x: data.points[0].lng,
							y: data.points[0].lat
						};
						localStorage.Bposition = '{"x":"' + data.points[0].lng + '","y":"' + data.points[0].lat + '"}';
					}
				});
			}

			function watchPosition() {
				defaultposition();
				navigator.geolocation.watchPosition(getCurrentPositionSuccess, function (error) {

				}, {maximumAge: 3000, timeout: 6000, enableHighAccuracy: true});
			}
			function getCurrentPosition() {
				defaultposition();
				navigator.geolocation.getCurrentPosition(getCurrentPositionSuccess, function (error) {

				}, {maximumAge: 3000, timeout: 6000, enableHighAccuracy: true});
			}
			function getCurrentPositionSuccess(position) {
				var lastposition = $rootScope.position;
				localStorage.position = '{"x":"' + position.coords.longitude + '","y":"' + position.coords.latitude + '"}';
				console.log(localStorage.position);
				$rootScope.position = {
					x: position.coords.longitude,
					y: position.coords.latitude
				};
				if ($rootScope.position.x.toFixed(8) == lastposition.x.toFixed(8) &&
					$rootScope.position.y.toFixed(8) == lastposition.y.toFixed(8)) {
				} else {
					convertor();
				}
			}
			// 只有系统自带坐标定位
			function defaultposition() {
				convertor();
			}
			_this.watchPosition = function () {
				$timeout(watchPosition, 1000);
			};
			_this.getCurrentPosition = function () {
				$timeout(getCurrentPosition, 1000);
			};
			return _this;
		})
		.directive('appMap', function ($rootScope, $timeout, $state, $q, mapsearchcondition, PropertyMapFactory1) {
			// 地铁线路全选时的历史缓存数据，分别存地铁的 统计信息 和 所有小区信息
			var hisSubwayList = {}, hisTotalSubwayList = {};
			// 地铁线路单个站点时的历史缓存数据，分别存地铁的 统计信息 和 所有小区信息
			var singleFetchSubwayList = {}, singleTotalSubwayList = {};
			return {
				restrict: "E",
				replace: true,
				template: "<div></div>",
				scope: {
					params: "="
				},
				link: function (scope, element, attrs) {
					var worker;
					var addedInfo = {
					    type: -1,
					    listMap: {}
					};
					// 地图
					var map;
					// 保存当前地图上显示的城区商圈、小区，用于后续销毁用
					var _labels = [], _comLabels = [];
					// 用于保存地图中心点图标用于后续销毁、保存当前最新请求的时间戳，避免显示上一次请求的数据
					var centerMarker, curTimestamp;
					/* 获取小区房源的条数 */
					var pagecountmax = 30;
					// 存储地图蓝圈用于后续销毁、蓝圈的配置参数
					var blueCricle, cricleConfig = {
					    strokeColor: 'rgb(191,206,227)',
					    fillColor: 'rgb(189,205,227)',
					    strokeWeight : '2',
					    strokeOpacity : 0.3,
					    enableMassClear: false
					};
					// 是否显示蓝圈
					var showCircle = $rootScope.maptype != 3;
					// 当前地图滑杆的距离
					var scrollBarDistance;
					// 存储所有地铁线路信息，存储当前是否处于地铁选房 或者 处于地铁选房全选状态
					var subwayList = [], subwayInfo = {}, isSubway = false, isAllSubway = false;
					// 当前选择的地铁线路
					var subwaylineIndex, subwayItemClick = false;
					// 添加二手房、租房定位点
					function setDefaultPoint() {
						clearCenterMarker();
						var point = getCurrentPoint();
						centerMarker = new BMap.Marker(point, { enableMassClear: false });
						map.addOverlay(centerMarker);
					}
					// 添加顾问中心点
					function setGwPoint(point) {
						clearCenterMarker();
						var point = getCenterPoint();
		             	centerMarker = new BMap.Label("<div class='myPoint2'></div>",{ offset:new BMap.Size(-7, -32), position:point, enableMassClear: false });
		             	centerMarker.setStyle({
							fontSize:"1em",
							color:"#000",
							backgroundColor :"rgba(0,0,0,0)",
							border:"0",
							height:"36px",
							padding: '0',
							lineHeight:"36px",
							background:"rgba(0,0,0,0)",
							borderRadius:"14px",
							AutoSize: "false",
							overflow:"hidden",
							whiteSpace:"nowrap",
							textAlign:"center"
						});
						map.addOverlay(centerMarker);
		            }
					// 清除地图中心点
					function clearCenterMarker() {
						if (centerMarker) {
							map.removeOverlay(centerMarker);
							centerMarker = null;
						}
					}
					// 获取中心点坐标
					function getCenterPoint() {
						var center = map.getCenter();
						return new BMap.Point(center.lng, center.lat);
					}
					function getCurrentPoint() {
						var position = JSON.parse(localStorage.Bposition);
						return new BMap.Point(position.x, position.y);
					}
					/**
					 * 设置城区商圈图标
					 * @param {string} point 坐标点
					 * @param {string} title 标题
					 * @param {number} count 小区数
					 */
					function addAreaMarker(point, title, count) {
						var u = map.getZoom();
						var unit = '套';
						if ($rootScope.maptype == 3) {
							unit = '人';
						} else if ($rootScope.maptype == 0) {
							unit = '个楼盘';
						}
						var label = new BMap.Label("<div class='circleType'><p>" + title + "</p><p>" + count + unit + "</p></div>", { offset: new BMap.Size(-35, -35), position: point });
						label.setStyle({
							fontSize: "1em",
							color: "#000",
							backgroundColor: "rgba(0,0,0,0)",
							border: "0",
							AutoSize: "false",
							width: "70px",
							height:"70px",
							overflow: "hidden",
							whiteSpace: "nowrap",
							textAlign: "center"
						});
						map.addOverlay(label);
						label.addEventListener('click', function() {
							zoomUp(point);
						});
						_labels.push(label);
						return label;
					}
					function zoomUp(point) {
						$rootScope.$broadcast('map.area.click', point, map.getZoom());
						map.centerAndZoom(point, map.getZoom() + 1);
					}
					function doAddCommunityMarker(item, type) {
						addCommunityMarker(new BMap.Point(item.prjx, item.prjy), item.communityname,
							item[type == 1 ? 'cscount' : 'czcount'], item.communityid, item.gpprice, item.isGy);
					}
					/**
					 * 设置二手房、租房小区图标
					 * @param {string} point 坐标点
					 * @param {string} title 小区名称
					 * @param {number} count 小区出售房源数
					 * @param {number} communityid 小区id
					 * @param {number} gpprice 挂牌均价
					 * @param {boolean} isGy 是否是品牌公寓
					 */
					function addCommunityMarker(point, title, count, communityid, gpprice, isGy) {
						// 在售/在租0套的小区不要显示
						if (!count && ($rootScope.maptype == 1 || $rootScope.maptype == 2)) {
							return;
						}
						var u = map.getZoom();
						var unit = '套';
						if ($rootScope.maptype == 3) {
							unit = '人';
						}
						var gp = '';
						if ($rootScope.maptype == 1 && gpprice > 0) {
							gp = gpprice.toFixed(0) + '万 ';
						}
						var style = $rootScope.maptype == 2 ? 'padding-right: 45px;' : '';
						var label = new BMap.Label("<div class='" + (isGy ? "longType3" : "longType-map") + "' style='" + style + "'>" + title + "&nbsp;<div class='wantao'>" + gp + '(' + count + unit + ")</div></div>", { offset: new BMap.Size(0, 0), position: point });
						label.setStyle({
							fontSize:"1em",
							color:"#000",
							backgroundColor :"rgba(0,0,0,0)",
							border:"0",
							height:"28px",
							lineHeight:"28px",
							background:"rgba(0,0,0,0)",
							borderRadius:"14px",
							padding:"0 12px",
							overflow:"hidden",
							whiteSpace:"nowrap",
							textAlign:"center"
						});
						map.addOverlay(label);
						var handler = function() {
							$rootScope.$broadcast('map.community.detail.click', communityid, isGy);
						}
						label.addEventListener('click', handler);
						_comLabels.push({
							label: label,
							handler: handler
						});
						return label;
					}
					// 设置新房楼盘
					function doAddPropertyMarker(item) {
						var price = '近月无成交';
						if (item.startprice && item.startprice != '0') {
							price = item.startprice;
						} else if (item.day30) {
							price = item.day30.toFixed(0);
							price += '元/㎡';
						}
						addPropertyMarker(new BMap.Point(item.prjx, item.prjy), item.propertyname, price,
							item.propertystateid || 2, item.propertyid, item.siteid || 33);
					}
					// 设置新房楼盘
					function addPropertyMarker(point, title, price, stateid, propertyid, siteid) {
						var state = getPropertyState(stateid);
						var position = { offset: new BMap.Size(0, 0), position: point };
						var labelHtml = "<div class='longType-map longType-map-property'>" + title + " " + price + " | " + state + "</div>";
						var label = new BMap.Label(labelHtml, position);
						label.setStyle({
							fontSize:"1em",
							color:"#000",
							backgroundColor :"rgba(0,0,0,0)",
							border:"0",
							height:"28px",
							lineHeight:"28px",
							background:"rgba(0,0,0,0)",
							borderRadius:"14px",
							padding:"0 12px",
							overflow:"hidden",
							whiteSpace:"nowrap",
							textAlign:"center"
						});
						map.addOverlay(label);
						var handler = function() {
							$rootScope.$broadcast('map.property.detail.click', propertyid, siteid);
						}
						label.addEventListener('click', handler);
						_comLabels.push({
							label: label,
							handler: handler
						});
						return label;
					}
					// 获取新房楼盘销售状态
					function getPropertyState(stateid) {
						if (stateid == 1) {
							return '在售'; // 打折
						} else if (stateid == 2) {
							return '在售';
						} else if (stateid == 3) {
							return '尾盘';
						} else if (stateid == 4) {
							return '售完';
						} else if (stateid == 5) {
							return '待售';
						}
					}
					function addGwMarker(point, img, brokerid, gpnum) {
						var u = map.getZoom();
						var label = new BMap.Label("<div class='longType2'><div class='touxiang'><img src='" + img + "'></div><div class='wantao'> 在售" + gpnum + "套</div></div>", { position: point, offset: new BMap.Size(0, 0) });
						label.setStyle({
							backgroundColor: "transparent",
							border: "0"
						});
						label.setStyle({
							fontSize: "1em",
							color: "#000",
							backgroundColor: "rgba(0,0,0,0)",
							border: "0",
							height:"28px",
							lineHeight:"28px",
							AutoSize: "false",
							overflow: "hidden",
						    padding: '0px 12px',
							whiteSpace: "normal",
							textAlign: "center"
						});
						map.addOverlay(label);
						var handler = function() {
							$state.go('adviser_mian', { brokerid: brokerid });
						}
						label.addEventListener('click', handler);
						_comLabels.push({
							label: label,
							handler: handler
						});
					}
					Math.seededRandom = function (max, min) {
						max = max || 1;
						min = min || 0;
						Math.seed = (Math.seed * 9301 + 49297) % 233280;
						var rnd = Math.seed / 233280.0;
						return min + rnd * (max - min);
					};
					/**
					 * 清除原先的地图上的标记
					 */
					function clearMarker() {
						if (_labels.length) {
							for (var i = 0; i < _labels.length; i++) {
								_labels[i].removeEventListener('click', zoomUp);
							}
						}
						if (_comLabels.length) {
							for (var i = 0; i < _comLabels.length; i++) {
								_comLabels[i].label.removeEventListener('click', _comLabels[i].handler);
							}
						}
						_comLabels = [];
						_labels = [];
						map.clearOverlays();
						if (isSupportWorker()) {
							postWorkerMessage('clearAllSubways');
						} else {
							initAddedInfo(-1);
						}
					}
					function initAddedInfo(type) {
					    addedInfo = {
					        type: type,
					        listMap: {},
					        list: []
					    };
					}
					// 加载小区
					function queryCommunitylist() {
						var params = getMapBounds();
						params.rp = pagecountmax * 2;
						// 只要二手房和租房才需要增加筛选的参数
						if ($rootScope.maptype == 1 || $rootScope.maptype == 2) {
							if (scope.params) {
								for (var k in scope.params) {
									params[k] = scope.params[k];
								}
							}
							if (showCircle) {
								var point = getCurrentPoint();
								params.lng = point.lng;
								params.lat = point.lat;
								params.distance = scrollBarDistance / 1000;
							}
						}
						return PropertyMapFactory1.getCommunityList(params);
					}
					// 加载顾问列表
					function loadGwList(timestamp) {
						$q.all([
							queryCommunitylist(),
							queryGwList()
						]).then(function(result) {
							handleGwLoaded(result[0], result[1], timestamp);
						});
						searchCenterCommunity(timestamp);
					}
					// 搜索顾问
					function queryGwList() {
						var params = getMapBounds();
						params.rp = pagecountmax * 5;
						// 增加筛选的参数
						if (scope.params) {
							for (var k in scope.params) {
								params[k] = scope.params[k];
							}
						}
						return PropertyMapFactory1.getGwList(params);
					}
					// 加载新房楼盘
					function loadPropertyList(timestamp) {
						var params = getMapBounds();
						params.rp = pagecountmax * 2;
						// 只要新房才需要增加筛选的参数
						if ($rootScope.maptype == 0) {
							if (scope.params) {
								for (var k in scope.params) {
									params[k] = scope.params[k];
								}
							}
							if (showCircle) {
								var point = getCurrentPoint();
								params.lng = point.lng;
								params.lat = point.lat;
								params.distance = scrollBarDistance / 1000;
							}
						}
						return PropertyMapFactory1.getPropertyList(params).then(function(result) {
							handlePropertyList(result, timestamp);
						});
					}
					// 处理二手房、租房只记载小区的返回结果
					function handlePropertyList(result, timestamp) {
						if (timestamp != curTimestamp)	return;
						clearMarker();
						angular.forEach(result.list, function(item) {
							doAddPropertyMarker(item);
						});
						if ($rootScope.maptype == 0) {
							$rootScope.$broadcast('map.showdata.loaded', result.list.length, map.getZoom());
						}
					}
					function getMapBounds() {
						return {
							neLat: map.getBounds().getNorthEast().lat,
							neLng: map.getBounds().getNorthEast().lng,
							swLat: map.getBounds().getSouthWest().lat,
							swLng: map.getBounds().getSouthWest().lng,
							rp: pagecountmax
						};
					}
					// 顾问页面加载小区时，对结果进行处理
					function handleGwLoaded(communityList, gwList, timestamp) {
						if (timestamp != curTimestamp) return;
						clearMarker();
						var gwlist = [];
						var comGwMidList = communityList.list;
						if (gwList.list.length > 0) {
							for (var i in comGwMidList) {
								repeatgwlist:
									for (var j = 0; j < gwList.list.length; j++) {
										var gw = gwList.list[j];
										for (var k in gw.communititylist) {
											if (gw.communititylist[k].communityid == comGwMidList[i].communityid) {
												Math.seed = gw.brokerid;
												var randomx = 0.0005 + (Math.seededRandom() - 0.5) * 0.0005;
												var randomy = 0.0005 + (Math.seededRandom() - 0.5) * 0.0005;
												gwlist.push({
													gpnum: gw.gpnum,
													prjx: comGwMidList[i].prjx - randomx,
													prjy: comGwMidList[i].prjy - randomy,
													brokerid: gw.brokerid,
													img: _INIT_IMG_YUMING + '/' + gw.showimg
												});
												break repeatgwlist;
											}
										}
									}
							}
						}
						for (var i in gwlist) {
							var c = gwlist[i];
							addGwMarker(new BMap.Point(c.prjx, c.prjy), c.img, c.brokerid, c.gpnum);
						}
						var count = pagecountmax * 5;
						if (gwlist.length < count) {
							count = gwlist.length;
						}
						$rootScope.$broadcast('map.showdata.loaded', count, map.getZoom());
					}

					// 加载小区列表
					function loadCommunityList(timestamp) {
						queryCommunitylist().then(function(result) {
							handleCommunitylist(result, timestamp)
						});
					}
					// 处理二手房、租房加载小区的返回结果
					function handleCommunitylist(result, timestamp) {
						if (timestamp != curTimestamp)	return;
						clearMarker();
						var count = 0;
						for (i in result.list) {
							var c = result.list[i];
							if ($rootScope.maptype == 1) {
								count += c.cscount;
							} else if ($rootScope.maptype == 2) {
								count += c.czcount;
							}
							doAddCommunityMarker(c, $rootScope.maptype);
						}
						if ($rootScope.maptype == 1 || $rootScope.maptype == 2) {
							$rootScope.$broadcast('map.showdata.loaded', count, map.getZoom());
						}
					}
					function showdata() {
						curType = $rootScope.maptype;
						curTimestamp = new Date().getTime();
						var zoom = map.getZoom();
						if (zoom == 11 || zoom == 12) {
							addDistrictMakers(curTimestamp);
							$rootScope.$broadcast('map.showdata.loaded', 0, zoom);
						} else if (zoom == 13 || zoom == 14) {
							addAreaMakers(curTimestamp);
							$rootScope.$broadcast('map.showdata.loaded', 0, zoom);
						} else if (zoom > 14) {
							loaddetaillist(curTimestamp);
						}
						// 显示顾问的地图中心点
						if ($rootScope.maptype == 3) {
							setGwPoint();
						}
					}
					// 选择顾问时，根据地图中心点搜索附件小区并展示
					function searchCenterCommunity(timestamp) {
						$rootScope.$broadcast('gw.community.update', null);
						var center = map.getCenter();
						var params = {
							rp: 5,
							lng: center.lng,
							lat: center.lat,
							distance: 0.1
						};
						$q.all([
							PropertyMapFactory1.getCommunityList(params),
							PropertyMapFactory1.getGyList(params)
						]).then(function(result) {
							if (timestamp != curTimestamp)	return;
							var list = result[0].list.concat(result[1].list);
							list.length && $rootScope.$broadcast('gw.community.update', list[0]);
						});
					}
					// 不是地铁找房时，加载页面数据
					function loaddetaillist(timestamp) {
						// 新房
						if ($rootScope.maptype == 0) {
							loadPropertyList(timestamp);
						// 二手房、租房
						} else if ($rootScope.maptype == 1 || $rootScope.maptype == 2) {
							loadCommunityList(timestamp);
						// 顾问
						} else if ($rootScope.maptype == 3) {
							loadGwList(timestamp);
						}
					}
					// 将城区的房源数添加到map中
					function addDistrictMakers(timestamp) {
						var num;
						if (timestamp != curTimestamp) return;
//						if ($rootScope.maptype == 0 && scope.propertyDistrictList.length) {
//							clearMarker();
//							angular.forEach(scope.propertyDistrictList, function(item) {
//								addAreaMarker(new BMap.Point(item.gisx, item.gisy), item.title, item.number_);
//							});
//						} else if ($rootScope.maptype != 0 && scope.districtList.length) {
						if (scope.districtList.length) {
							clearMarker();
							angular.forEach(scope.districtList, function(item) {
								if ($rootScope.maptype == 0) {
									num = item.pronum;
								} else if ($rootScope.maptype == 1) {
									num = item.sellnum;
								} else if ($rootScope.maptype == 2) {
									num = item.rentnum;
								} else {
									num = item.gwnum;
								}
								addAreaMarker(new BMap.Point(item.gisx, item.gisy), item.cqmc, num);
							});
						} else {
							loadAreaList(timestamp).then(function() {
								addDistrictMakers(timestamp);
							});
						}
					}
					// 将商圈的房源数添加到map中
					function addAreaMakers(timestamp) {
						var num;
						if (timestamp != curTimestamp)	return;
//						if ($rootScope.maptype == 0 && scope.propertyAreaList.length) {
//							clearMarker();
//							angular.forEach(scope.propertyAreaList, function(item) {
//								addAreaMarker(new BMap.Point(item.gisx, item.gisy), item.areaname, item.number_);
//							});
//						} else if ($rootScope.maptype != 0 && scope.areaList.length) {
						if (scope.areaList.length) {
							clearMarker();
							angular.forEach(scope.areaList, function(item) {
								if ($rootScope.maptype == 0) {
									num = item.pronum;
								} else if ($rootScope.maptype == 1) {
									num = item.sellnum;
								} else if ($rootScope.maptype == 2) {
									num = item.rentnum;
								} else {
									num = item.gwnum;
								}
								addAreaMarker(new BMap.Point(item.gisx, item.gisy), item.sqmc, num);
							});
						} else {
							loadAreaList(timestamp).then(function() {
								addAreaMakers(timestamp);
							});
						}
					}
					// 蓝圈
					function drawCircle(distance) {
						removeCircle();
						var point = getCurrentPoint();
						// 如果选中了某个地铁站点
						if (isSubway && !isAllSubway) {
							var tmp = subwayList[subwayItemClick];
							point = new BMap.Point(tmp.prjx, tmp.prjy);
						}
						var zoom = map.getZoom();
						if (!distance) {
							distance = scrollBarDistance || scope.defaultBarData.value;
						}
						blueCricle = new BMap.Circle(point, distance, cricleConfig);
						map.addOverlay(blueCricle);
					}
					function getDefaultBarData() {
						for (var i = 0; i < mapsearchcondition.barData.length; i++) {
							if (!mapsearchcondition.barData[i].all) {
								return mapsearchcondition.barData[i];
							}
						}
						return mapsearchcondition.barData[0];
					}
					function getAllCityBarData() {
						for (var i = 0; i < mapsearchcondition.barData.length; i++) {
							if (mapsearchcondition.barData[i].all) {
								return mapsearchcondition.barData[i];
							}
						}
						return mapsearchcondition.barData[0];
					}
					function removeCircle() {
						if (blueCricle) {
							map.removeOverlay(blueCricle);
							blueCricle = null;
						}
					}
					var fetchSubwayList = {}, totalSubwayList = {}, subwayFetchingInfo = {};
					var singleFetchingInfo = {};
					// 获取单个地铁站点附件小区的信息
					function getSingleSubwayInfo(info, zoom, timestamp) {
						clearMarker();
						var key = JSON.stringify(scope.params);
						var type = $rootScope.maptype;
						if (type == 0) {
							loadSinglePropertyInfo(info, type, key, subwayItemClick, scrollBarDistance, zoom, timestamp);
						} else {
							loadSingleSubwayInfo(info, type, key, subwayItemClick, scrollBarDistance, zoom, timestamp);
						}
					}
					// 加载新房楼盘小区
					function loadSinglePropertyInfo(info, type, key, subwayItemIdx, distance, zoom, timestamp, flag) {
						var params = {
							rp: pagecountmax,
							distance: distance / 1000,
							lng: info.prjx,
							lat: info.prjy
						};
						for (var k in scope.params) {
							params[k] = scope.params[k];
						}
						return PropertyMapFactory1.getPropertyList(params).then(function (result) {
							if (timestamp != curTimestamp) return;
							handleSinglePropertyLoaded(result.list, info, type, key, subwayItemIdx, distance, zoom);
							return result;
						}).catch(function() {
							addSingleFetchingStatus(key, type, false);
						});
					}
					// 处理新房单个地铁站点附件楼盘的信息加载完毕的函数
					function handleSinglePropertyLoaded(list, info, type, key, subwayItemIdx, distance, zoom) {
						addSingleFetchingStatus(key, type, false);
						if (zoom > 14 && isSubway) {
							angular.forEach(list, function(item) {
								doAddPropertyMarker(item);
							});
						}
						var sub = {
							prjx: info.prjx,
							prjy: info.prjy,
							subname: info.subname,
							count: list.length
						};
						if (zoom < 15 && isSubway) {
							addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, list.length);
						}
						addSingleHistory(list, type, key, subwayItemIdx, distance, sub);
					}
					// 处理二手房、租房单个地铁站点附件小区、公寓的信息加载完毕的函数
					function handleSingleLoaded(list, info, type, key, subwayItemIdx, distance, zoom) {
						addSingleFetchingStatus(key, type, false);
						var cscount = 0, czcount = 0;
						angular.forEach(list, function(l) {
							cscount += l.cscount;
							if (l.allkzts != undefined) {
								l.czcount = l.allkzts || 0;
								l.communityname = l.gymc;
								l.communityid = l.apid;
								l.isGy = true;
							}
							czcount += l.czcount;
							if (zoom > 14 && isSubway) {
								doAddCommunityMarker(l, $rootScope.maptype);
							}
						});
						var sub = {
							prjx: info.prjx,
							prjy: info.prjy,
							subname: info.subname,
							cscount: cscount,
							czcount: czcount
						};
						if (zoom < 15 && isSubway) {
							addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, $rootScope.maptype == 1 ? cscount : czcount);
						}
						addSingleHistory(list, type, key, subwayItemIdx, distance, sub);
					}
					// 添加加载过的数据到缓存中
					function addSingleHistory(list, type, key, subwayItemIdx, distance, sub) {
						singleFetchSubwayList[type] = singleFetchSubwayList[type] || {};
						singleFetchSubwayList[type][subwayItemIdx] = singleFetchSubwayList[type][subwayItemIdx] || {};
						singleFetchSubwayList[type][subwayItemIdx][key] = singleFetchSubwayList[type][subwayItemIdx][key] || {};
						singleFetchSubwayList[type][subwayItemIdx][key][distance] = sub;

						singleTotalSubwayList[type] = singleTotalSubwayList[type] || {};
						singleTotalSubwayList[type][subwayItemIdx] = singleTotalSubwayList[type][subwayItemIdx] || {};
						singleTotalSubwayList[type][subwayItemIdx][key] = singleTotalSubwayList[type][subwayItemIdx][key] || {};
						singleTotalSubwayList[type][subwayItemIdx][key][distance] = list;
					}
					// 加载单个地铁站点附件小区
					function loadSingleSubwayInfo(info, type, key, subwayItemIdx, distance, zoom, timestamp, flag) {
						var params = {
							rp: pagecountmax,
							distance: distance / 1000,
							lng: info.prjx,
							lat: info.prjy
						};
						// 只要二手房和租房才需要增加筛选的参数
						if (type == 1 || type == 2) {
							if (scope.params) {
								for (var k in scope.params) {
									params[k] = scope.params[k];
								}
							}
						}
						return PropertyMapFactory1.getCommunityList(params).then(function (result) {
							if (timestamp != curTimestamp) return;
							// 如果不是同时请求公寓数据
							if (!flag) {
								handleSingleLoaded(result.list, info, type, key, subwayItemIdx, distance, zoom);
							}
							return result;
						}).catch(function() {
							addSingleFetchingStatus(key, type, false);
						});
					}
					// 显示单个地铁站点的小区房源信息
					function addSingleSubwayInfo(key, type, timestamp) {
						if (isSubway && !isAllSubway && timestamp == curTimestamp) {
							clearMarker();
							if (map.getZoom() < 15) {
								var info = singleFetchSubwayList[type][subwayItemClick][key][scrollBarDistance];
								var count = type == 0 ? info.count : type == 1 ? info.cscount : info.czcount;
								addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, count);
							} else {
								for (var i = 0; i < singleTotalSubwayList[type][subwayItemClick][key][scrollBarDistance].length; i++) {
									var info = singleTotalSubwayList[type][subwayItemClick][key][scrollBarDistance][i];
									// 新房
									if (type == 0) {
										doAddPropertyMarker(info);
									// 二手房、租房
									} else {
										doAddCommunityMarker(info, type);
									}
								}
							}
						}
					}
					// 获取地铁附件的小区、公寓
					function getSubwayInfo(list, timestamp) {
						var key = JSON.stringify(scope.params);
						var type = $rootScope.maptype;
						var zoom = map.getZoom();
						// 如果是选中某个站点，不是全选
						if (!isAllSubway) {
							if (isSingleSubwayLoaded(key, type)) {
								addSingleSubwayInfo(key, type, timestamp);
							} else {
								addSingleFetchingStatus(key, type, true);
								getSingleSubwayInfo(subwayList[subwayItemClick], zoom, timestamp);
							}
							return;
						}
						// 如果选择整条路线
						if (isAllSubwayLoaded(key, type)) {
							fetchSubwayList[type][subwaylineIndex][key] = hisSubwayList[type][subwaylineIndex][key];
							totalSubwayList[type][subwaylineIndex][key] = hisTotalSubwayList[type][subwaylineIndex][key];
							addSubwayMarkers(key, type, timestamp);
						} else {
							addAllFetchingStatus(key, type, true);
							initAllSubwayData(key, type, list);
							doGetAllSubwayList(list, type, key, zoom, timestamp);
						}
					}
					// 获取整条线路到房源信息
					function doGetAllSubwayList(list, type, key, zoom, timestamp) {
						clearMarker();
						curType = type;
						var start = Math.floor(list.length / 2);
						var fetchList = [];
						// 从地铁中间点开始加载数据
						for (var j = start; j < list.length; j++) {
							pushFetchItem(list[j], key, type, false, timestamp, subwaylineIndex, zoom, fetchList);
						}
						for (var i = start - 1; i >= 0; i--) {
							pushFetchItem(list[i], key, type, false, timestamp, subwaylineIndex, zoom, fetchList);
						}
						$q.all(fetchList).then(function() {
							if (timestamp == curTimestamp) {
								addAllFetchingStatus(key, type, false);
								hisSubwayList[type] = hisSubwayList[type] || {};
								hisSubwayList[type][subwaylineIndex] = hisSubwayList[type][subwaylineIndex] || {};
								hisSubwayList[type][subwaylineIndex][key] = fetchSubwayList[type][subwaylineIndex][key];
								hisTotalSubwayList[type] = hisTotalSubwayList[type] || {};
								hisTotalSubwayList[type][subwaylineIndex] = hisTotalSubwayList[type][subwaylineIndex] || {};
								hisTotalSubwayList[type][subwaylineIndex][key] = totalSubwayList[type][subwaylineIndex][key];
							}
						}).catch(function() {
							if (timestamp == curTimestamp) {
								addAllFetchingStatus(key, type, false);
							}
						});
					}
					// 请求整条地铁线路所有站点时，给每个站点添加获取数据的请求
					function pushFetchItem(item, key, type, flag, timestamp, subwaylineIndex, zoom, fetchList) {
						var info = { prjx: item.prjx, prjy: item.prjy, subname: item.subname };
						if (type == 0) {
							fetchList.push(loadSubwayPropertyList(info, key, type, timestamp, subwaylineIndex, zoom));
						} else {
							fetchList.push(loadSubwayAreaList(info, key, type, flag, timestamp, subwaylineIndex, zoom));
						}
					}
					function loadSubwayPropertyList(info, key, type, timestamp, subwaylineIdx, zoom) {
						var params = {
							rp: pagecountmax,
							distance: 1,
							lng: info.prjx,
							lat: info.prjy
						};
						if (type == 0 && scope.params) {
							for (var k in scope.params) {
								params[k] = scope.params[k];
							}
						}
						return PropertyMapFactory1.getPropertyList(params, 60000).then(function (result) {
							if (timestamp != curTimestamp)	return;
							totalSubwayList[type][subwaylineIdx][key] = totalSubwayList[type][subwaylineIdx][key].concat(result.list);
							handleAllPropertyLoaded(result.list, info, key, type, subwaylineIdx, zoom, timestamp);
							return result;
						});
					}
					// 选择整条线路时加载某个站点新房楼盘信息记载完毕的处理函数
					function handleAllPropertyLoaded(list, info, key, type, subwaylineIdx, zoom, timestamp) {
						if (zoom > 14 && isSubway) {
							var bs = map.getBounds();
							var bssw = bs.getSouthWest();   //可视区域左下角
							var bsne = bs.getNorthEast();   //可视区域右上角
							if (isSupportWorker()) {
								postWorkerMessage('showAllSubways', {
									mapBounds: {
										bssw: bssw,
										bsne: bsne
									},
									list: list,
									timestamp: timestamp,
									type: type
								});
							} else {
								drawAllSubwaysComAndProperty(key, type, timestamp, bssw, bsne, list);
							}
						}
						fetchSubwayList[type][subwaylineIdx][key].push({
							prjx: info.prjx,
							prjy: info.prjy,
							subname: info.subname,
							count: list.length
						});
						if (zoom < 15 && isSubway) {
							addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, list.length);
						}
					}
					// 选择整条线路时加载某个站点小区信息加载完毕的处理函数
					function handleAllLoaded(list, info, key, type, subwaylineIdx, zoom, timestamp) {
						var cscount = 0, czcount = 0;
						var supportWorker = isSupportWorker();
						var bs = map.getBounds();
						var bssw = bs.getSouthWest();   //可视区域左下角
						var bsne = bs.getNorthEast();   //可视区域右上角
						for (var i = 0; i < list.length; i++) {
							var l = list[i];
							cscount += l.cscount;
							czcount += l.czcount;
							if (!supportWorker && zoom > 14 && isSubway) {
								if (isInRange(bssw, bsne, +l.prjx, +l.prjy) && !addedInfo.listMap[l.communityid]) {
									addedInfo.listMap[l.communityid] = true;
									doAddCommunityMarker(l, $rootScope.maptype);
								}
							}
						}
						if (supportWorker && zoom > 14 && isSubway) {
							postWorkerMessage('showAllSubways', {
								mapBounds: {
									bssw: bssw,
									bsne: bsne
								},
								list: list,
								timestamp: timestamp,
								type: type
							});
						}
						fetchSubwayList[type][subwaylineIdx][key].push({
							prjx: info.prjx,
							prjy: info.prjy,
							subname: info.subname,
							cscount: cscount,
							czcount: czcount
						});
						if (zoom < 15 && isSubway) {
							addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, $rootScope.maptype == 1 ? cscount : czcount);
						}
					}
					// 获取地铁整条线路附近小区信息
					function loadSubwayAreaList(info, key, type, flag, timestamp, subwaylineIdx, zoom) {
						var params = {
							rp: pagecountmax,
							distance: 1,
							lng: info.prjx,
							lat: info.prjy
						};
						// 只要二手房和租房才需要增加筛选的参数
						if (type == 1 || type == 2) {
							if (scope.params) {
								for (var k in scope.params) {
									params[k] = scope.params[k];
								}
							}
						}
						return PropertyMapFactory1.getCommunityList(params, 60000).then(function (result) {
							if (timestamp != curTimestamp) return;
							totalSubwayList[type][subwaylineIdx][key] = totalSubwayList[type][subwaylineIdx][key].concat(result.list);
							if (!flag) {
								handleAllLoaded(result.list, info, key, type, subwaylineIdx, zoom, timestamp);
							}
							return result;
						});
					}
					// 改变地铁整条线路的请求状态
					function addAllFetchingStatus(key, type, flag) {
						subwayFetchingInfo[type] = subwayFetchingInfo[type] || {};
						subwayFetchingInfo[type][subwaylineIndex] = subwayFetchingInfo[type][subwaylineIndex] || {};
						subwayFetchingInfo[type][subwaylineIndex][key] = flag;
					}
					// 初始化地铁整条线路的数据
					function initAllSubwayData(key, type, list) {
						fetchSubwayList[type] = fetchSubwayList[type] || {};
						fetchSubwayList[type][subwaylineIndex] = fetchSubwayList[type][subwaylineIndex] || {};
						fetchSubwayList[type][subwaylineIndex][key] = [];

						totalSubwayList[type] = totalSubwayList[type] || {};
						totalSubwayList[type][subwaylineIndex] = totalSubwayList[type][subwaylineIndex] || {};
						totalSubwayList[type][subwaylineIndex][key] = [];
					}
					// 判断地铁整条线路的请求状态
					function isAllSubwayFetching(key, type) {
						return subwayFetchingInfo[type] && subwayFetchingInfo[type][subwaylineIndex] &&
							subwayFetchingInfo[type][subwaylineIndex][key];
					}
					// 判断地铁整条线路是否已经加载过了
					function isAllSubwayLoaded(key, type, subwaylineIdx) {
						return hisSubwayList[type] && hisSubwayList[type][subwaylineIndex] && hisSubwayList[type][subwaylineIndex][key];
					}
					// 改变地铁单个站点的请求状态
					function addSingleFetchingStatus(key, type, flag) {
						singleFetchingInfo[type] = singleFetchingInfo[type] || {};
						singleFetchingInfo[type][subwayItemClick] = singleFetchingInfo[type][subwayItemClick] || {};
						singleFetchingInfo[type][subwayItemClick][key] = singleFetchingInfo[type][subwayItemClick][key] || {};
						singleFetchingInfo[type][subwayItemClick][key][scrollBarDistance] = flag;
					}
					// 判断地铁单个站点的请求状态
					function isSingleSubwayFetching(key, type) {
						return singleFetchingInfo[type] && singleFetchingInfo[type][subwayItemClick] &&
							singleFetchingInfo[type][subwayItemClick][key] &&
							singleFetchingInfo[type][subwayItemClick][key][scrollBarDistance];
					}
					// 判断地铁单个站点是否已经加载过了
					function isSingleSubwayLoaded(key, type) {
						return singleFetchSubwayList[type] && singleFetchSubwayList[type][subwayItemClick] &&
							singleFetchSubwayList[type][subwayItemClick][key] &&
							singleFetchSubwayList[type][subwayItemClick][key][scrollBarDistance];
					}
					// 判断显示地铁房源信息时是否需要发起请求获取数据，或者直接显示
					function showSubwayData(timestamp) {
						var key = JSON.stringify(scope.params);
						var type = $rootScope.maptype;
						if (!isAllSubway && isSingleSubwayFetching(key, type)) {
							return;
						}
						if (isAllSubway && isAllSubwayFetching(key, type)) {
							return;
						}
						if (!timestamp) {
							timestamp = new Date().getTime();
							curTimestamp = timestamp;
						}
						getSubwayInfo(subwayInfo[subwaylineIndex], timestamp);
					}
					var curType, curSublineIdx, curKey, curZoom = -1;
					function shouldClearAllSubwayMarker(type, key) {
						var flag = false;
						var zoom = map.getZoom();
						if (curType != type || curSublineIdx != subwaylineIndex || curKey != key) {
							flag = true;
						} else if (curZoom >= 15 && zoom < 15 || curZoom < 15 && zoom >= 15) {
							flag = true;
						}
						if (flag) {
							curType = type;
							curSublineIdx = subwaylineIndex;
							curKey = key;
							curZoom = zoom;
						}
						return flag;
					}
					// 显示地铁房源信息
					function addSubwayMarkers(key, type, timestamp) {
						if (isSubway && timestamp == curTimestamp) {
							var zoom = map.getZoom();
							var clearFlag = shouldClearAllSubwayMarker(type, key);
							if (clearFlag) {
								clearMarker();
							}
							if (zoom < 15) {
								if (clearFlag) {
									for (var i = 0; i < fetchSubwayList[type][subwaylineIndex][key].length; i++) {
										var info = fetchSubwayList[type][subwaylineIndex][key][i];
										var count = type == 0 ? info.count : type == 1 ? info.cscount : info.czcount;
										addAreaMarker(new BMap.Point(info.prjx, info.prjy), info.subname, count);
									}
								}
							} else {
								var bs = map.getBounds();   //获取可视区域
								var bssw = bs.getSouthWest();   //可视区域左下角
								var bsne = bs.getNorthEast();   //可视区域右上角
								if (isSupportWorker()) {
									postDrawAllSubwaysComAndPropertyMsg(key, type, timestamp, bssw, bsne);
								} else {
									drawAllSubwaysComAndProperty(key, type, timestamp, bssw, bsne);
								}
							}
						}
					}
					function drawAllSubwaysComAndProperty(key, type, timestamp, bssw, bsne, list) {
						list = list || totalSubwayList[type][subwaylineIndex][key];
						var communitys = findMapBoundsCommunitys(list, type, bssw, bsne);
						drawAllSubwayComOrPropertyMarker({
							type: type,
							list: communitys
						});
					}
					function findMapBoundsCommunitys(list, type, bssw, bsne) {
					    if (type != addedInfo.type) {
					        initAddedInfo(type);
					    }
					    var keyName = type == '0' ? 'propertyid' : 'communityid';
					    var result = [];
					    for (var i = 0; i < list.length; i++) {
					        var info = list[i];
					        if (isInRange(bssw, bsne, +info.prjx, +info.prjy) && !addedInfo.listMap[info[keyName]]) {
					            result.push(info);
					            addedInfo.listMap[info[keyName]] = true;
					        }
					    }
					    return result;
					}
					function isInRange(bssw, bsne, prjx, prjy) {
					    return prjx >= bssw.lng && prjx <= bsne.lng && prjy >= bssw.lat && prjy <= bsne.lat;
					}
					function isSupportWorker() {
						return typeof Worker != 'undefined';
					}
					function postDrawAllSubwaysComAndPropertyMsg(key, type, timestamp, bssw, bsne) {
						postWorkerMessage('showAllSubways', {
							mapBounds: {
								bssw: bssw,
								bsne: bsne
							},
							list: totalSubwayList[type][subwaylineIndex][key],
							timestamp: timestamp,
							type: type
						});
					}
					function postWorkerMessage(type, data) {
						worker.postMessage({
							type: type,
							data: data
						});
					}
					// 加载新房、二手房、租房的城区、商圈
					function loadAreaList(timestamp) {
						return $q.all([
							PropertyMapFactory1.getPropertyDistrictList(),
							PropertyMapFactory1.getPropertySqList(),
							PropertyMapFactory1.getCommunityAreaList()
						]).then(function(result) {
							if (!timestamp || timestamp == curTimestamp) {
								scope.propertyDistrictList = result[0].propertylist;
								scope.propertyAreaList = result[1].propertylist;
								scope.districtList = result[2].cqlist;
								scope.areaList = result[2].sqlist;
								$rootScope.$broadcast('map.arealist.loaded', {
									propertyDistrictList: scope.propertyDistrictList,
									propertyAreaList: scope.propertyAreaList,
									districtList: scope.districtList,
									areaList: scope.areaList
								});
							}
						});
					}
					function initMap() {
						map = new BMap.Map(element[0], { mapType: BMAP_NORMAL_MAP, minZoom: 3, maxZoom: 18 });
						map.setMapStyle({ style: "googlelite" });
					}
					function handleZoomAndMove() {
						if (showCircle) {
							drawCircle();
						} else {
							removeCircle();
						}
						if (!isSubway) {
							showdata();
						} else {
							showSubwayData();
						}
					}
					function addListeners() {
						/* 对地图的自定义操作 */
						map.addEventListener("zoomend", function() {
							$rootScope.$broadcast('map.zoom.end', map.getZoom());
							handleZoomAndMove();
						});

						map.addEventListener("moveend", function() {
							handleZoomAndMove();
						});
						// 二手房、租房、金领顾问类型改变时
						scope.$on('map.showdata.maptype.change', function() {
							if ($rootScope.maptype != 3) {
								setDefaultPoint();
								isSubway = subwaylineIndex != null;
							} else {
								isSubway = false;
							}
							clearMarker();
							handleZoomAndMove();
						})
						// 筛选参数改变时
						scope.$on('map.showdata.params.change', function() {
							clearMarker();
							if (isSubway) {
								curTimestamp = new Date().getTime();
								showSubwayData(curTimestamp);
							} else {
								showdata();
							}
						})
						// 监听地图移动缩放的广播
						scope.$on('map.go.centerAndZoom', function (e, params) {
							var zoom = map.getZoom();
							if (params.zoom && (params.zoom > zoom || params.zoomChange)) {
								map.centerAndZoom(new BMap.Point(params.prjx, params.prjy), params.zoom);
							} else {
								map.centerAndZoom(new BMap.Point(params.prjx, params.prjy), zoom);
							}
						});
						// 显示、隐藏蓝圈
						scope.$on('map.circle.show.change', function(r, showFlag) {
							if (showCircle != showFlag) {
								showCircle = !!showFlag;
								if (showCircle) {
									drawCircle();
								} else {
									removeCircle();
								}
							}
						});
						// 滑杆距离改变时
						scope.$on('map.scrollbar.distance.change', function(r, distance) {
							if (scrollBarDistance != distance) {
								scrollBarDistance = distance;
								if (isSubway && !isAllSubway && showCircle) {
									curTimestamp = new Date().getTime();
									getSubwayInfo(subwayInfo[subwaylineIndex], curTimestamp);
								}
							}
						});
						// 滑动滑动杆
						scope.$on('map.scrollbar.move', function(e, info) {
							var flag = false;
							if (info.distance != scrollBarDistance) {
								scrollBarDistance = info.distance;
								flag = true;
							}
							if (map.getZoom() != info.zoom) {
								map.setZoom(info.zoom);
							} else if (flag) {
								handleZoomAndMove();
							}
						});

						// 地铁信息加载完成
						scope.$on('esf.map.subway.data.loaded', function(e, info, list) {
							subwayInfo = info;
							subwayList = list;
						});
						// 选择地铁
						scope.$on('map.subway.chose', function(e, flag) {
							if (isSubway != flag) {
								isSubway = flag;
								if (!isSubway) {
									// 防止地图类型切换时，isSubway被重置未true
									subwaylineIndex = null;
									clearMarker();
									isAllSubway = false;
									if (showCircle) {
										drawCircle(scrollBarDistance);
									} else {
										removeCircle();
									}
									showdata();
								}
							}
						});
						// 选择地铁线路的全部站点
						scope.$on('map.subway.all.chose', function(e, index) {
							isAllSubway = true;
							subwaylineIndex = index;
							subwayItemClick = -1;
							var type = $rootScope.maptype;
							var key = JSON.stringify(scope.params);
							if (map.getZoom() == 14) {
								if (isAllSubwayFetching(key, type)) {
									return;
								}
								curTimestamp = new Date().getTime();
								getSubwayInfo(subwayInfo[subwaylineIndex], curTimestamp);
							}
						});
						// 选择地铁某个站点
						scope.$on('map.subway.item.chose', function(e, index, itemIdx) {
							subwaylineIndex = index;
							subwayItemClick = itemIdx;
							isAllSubway = false;
							var type = $rootScope.maptype;
							curTimestamp = new Date().getTime();
							// 选择某个站点时，会缩放地图到15级，如果当前地图正好是15级，则地图不会触发缩放操作，则需要手动调用获取站点小区到方法ß
							if (map.getZoom() == 15) {
								getSubwayInfo(subwayInfo[index], curTimestamp);
							}
						});
						scope.$on('$destory', function() {
							worker.terminate();
						});
						if (isSupportWorker()) {
							worker.onmessage = function (event) {
							  	var data = event.data;
								if (data.type == 'showAllSubways') {
									// if (data.data.timestamp == curTimestamp) {
									// 	drawAllSubwayComOrPropertyMarker(data.data);
									// }
									if (data.data.type == $rootScope.maptype) {
										drawAllSubwayComOrPropertyMarker(data.data);
									}
								}
							}
						}
					}
					// 当处于地铁找房时，往地图中添加新房和小区当图标
					function drawAllSubwayComOrPropertyMarker(data) {
						var list = data.list;
						var type = data.type;
						for (var i = 0; i < list.length; i++) {
							var info = list[i];
							if (type == 0) {
								doAddPropertyMarker(info);
							} else {
								doAddCommunityMarker(info, type);
							}
						}
					}
					function initParams() {
						scope.propertyDistrictList = [];
						scope.propertyAreaList = [];
						scope.districtList = [];
						scope.areaList = [];
						// 数组里除了全市外的第一个
						scope.defaultBarData = getDefaultBarData();
						// 全市
						scope.allCityBarData = getAllCityBarData();
						scrollBarDistance = scope.defaultBarData.value;
					}
					function initWorker() {
						worker = new Worker('js/plugin/map-worker.js');
					}
					function init() {
						if (isSupportWorker()) {
							initWorker();
						}
						initMap();
						initParams();
						addListeners();
						$timeout(setDefaultPoint, 100);
						loadAreaList();
						var point = getCurrentPoint();
						var zoom = $rootScope.zoom || scope.allCityBarData.zoom;
						map.centerAndZoom(point, zoom);
						$rootScope.zoom = 0;
					}
					init();
				}
			};
		});
})(window, document);
