var addedInfo = {
    type: -1,
    listMap: {}
};
self.addEventListener('message', function(e) {
    var data = e.data;
    switch (data.type) {
        case 'showAllSubways':
            findMapBoundsCommunitys(data.data);
            break;
        case 'clearAllSubways':
            initAddedInfo(-1);
            break;
    };
}, false);

function initAddedInfo(type) {
    addedInfo = {
        type: type,
        listMap: {},
        list: []
    };
}
function findMapBoundsCommunitys(data) {
    if (data.type != addedInfo.type) {
        initAddedInfo(data.type);
    }
    var keyName = data.type == '0' ? 'propertyid' : 'communityid';
    var bs = data.mapBounds;
    var list = data.list;
    var result = [];
    for (var i = 0; i < list.length; i++) {
        var info = list[i];
        if (isInRange(bs.bssw, bs.bsne, +info.prjx, +info.prjy) && !addedInfo.listMap[info[keyName]]) {
            result.push(info);
            addedInfo.listMap[info[keyName]] = true;
        }
    }
    if (result.length) {
        self.postMessage({
            type: 'showAllSubways',
            data: {
                list: result,
                timestamp: data.timestamp,
                type: data.type
            }
        });
    }
}
function isInRange(bssw, bsne, prjx, prjy) {
    return prjx >= bssw.lng && prjx <= bsne.lng && prjy >= bssw.lat && prjy <= bsne.lat;
}
