/**
 * 可选参数, 地图的容器名称
 */
function initMap(container) {
	var can;
	if (container) {
		can = container;
	} else {
		can = 'container';
	}
	map = new BMap.Map(can);
	map.centerAndZoom(new BMap.Point(120.010951, 30.356294), 13); // 杭州中心点位置
}
/**
 * 得到圆的内接正方形bounds
 * 
 * @param {Point}
 *            centerPoi 圆形范围的圆心
 * @param {Number}
 *            r 圆形范围的半径
 * @return 无返回值
 */
function getSquareBounds(centerPoi, r) {
	var a = Math.sqrt(2) * r; // 正方形边长

	mPoi = getMecator(centerPoi);
	var x0 = mPoi.x, y0 = mPoi.y;

	var x1 = x0 + a / 2, y1 = y0 + a / 2;// 东北点
	var x2 = x0 - a / 2, y2 = y0 - a / 2;// 西南点

	var ne = getPoi(new BMap.Pixel(x1, y1)), sw = getPoi(new BMap.Pixel(x2, y2));
	return new BMap.Bounds(sw, ne);

}

// 根据球面坐标获得平面坐标。
function getMecator(poi) {
	return map.getMapType().getProjection().lngLatToPoint(poi);
}
// 根据平面坐标获得球面坐标。
function getPoi(mecator) {
	return map.getMapType().getProjection().pointToLngLat(mecator);
}

function mapsearch(point, div, key) {
	mapcountlimit++;
	var circle = new BMap.Circle(point, 1000, {
		fillColor : "blue",
		strokeWeight : 1,
		fillOpacity : 0.3,
		strokeOpacity : 0.3
	});
	map.addOverlay(circle);
	map.clearOverlays();
	// 定义搜索关键词 (多关键词搜索)
	var myKeys = [ key ];
	//检索结束后的回调函数
	var options = {
		pageCapacity : 9,
		renderOptions : {
			map : map
		},
		onSearchComplete : function(results) {
			var a = results[0].getNumPois();
			if (a > 3) {
				a = 3;
			}
			var str = '';
			for (var i = 0; i < a; i++) {
				var title1 = results[0].getPoi(i).title;
				var title = title1;
				if (title.length > 17) {
					title = title.substr(0, 17);
				}
				var point1 = results[0].getPoi(i).point;
				var dis = map.getDistance(point, point1) / 1000;
				//str += '<li class="am-text-center"><span class="tm-askbtn">' + title + '</span><span class="tm-askbtn tm-text-muted">距离：' + dis.toFixed(2) + 'km</span></li>';
				if (str != '') {
					str +=',';
				}
				str += title;
			}
			$('#' + div).html(str + '&nbsp;');
			if(mapcount) {
				mapcount++;
			}
		}
	}
	// renderOptions: 搜索结果, 地图于map实例显示，列表在 r-result显示

	var local = new BMap.LocalSearch(map, options);
	local.disableFirstResultSelection();
	var bounds = getSquareBounds(circle.getCenter(), circle.getRadius());
	local.searchInBounds(myKeys, bounds);

}

function mapsearchonly(key) {
	mapcountlimit++;
	map.clearOverlays();
	//楼盘标记覆盖物，重新设置地图定位。
	if(propertyOverlay != undefined && propertyOverlay != null){
		map.addOverlay(propertyOverlay);
	}
	
	// 定义搜索关键词 (多关键词搜索)
	var myKeys = [ key ];
	//检索结束后的回调函数
	var options = {
		pageCapacity : 9,
		renderOptions : {
			map : map
		},
		onSearchComplete : function(results) {
			var a = results[0].getNumPois();
			if (a == 0){
				alert('该范围内没有此类配套设施，请缩小地图后再次进行搜索！');
			}
			if (a > 3) {
				a = 3;
			}
			var str = '';
			for (var i = 0; i < a; i++) {
				var title1 = results[0].getPoi(i).title;
				var title = title1;
				if (title.length > 17) {
					title = title.substr(0, 17);
				}
				var point1 = results[0].getPoi(i).point;
				var marker = new BMap.Marker(point1);        // 创建标注      
				map.addOverlay(marker);
				//var dis = map.getDistance(point, point1) / 1000;
			}
			if(mapcount) {
				mapcount++;
			}
			
		}
		// renderOptions: 搜索结果, 地图于map实例显示，列表在 r-result显示
	}
	var local = new BMap.LocalSearch(map, options);
	local.disableFirstResultSelection();
	local.searchInBounds(myKeys, map.getBounds());
}

// 定义自定义覆盖物的构造函数
function PropertyOverlay(center, title, linktype, linkid, sid){
	this._center = center;
	this._height = 30;
	this._width = 90;
	this._title = title;
	this._linktype = linktype;
	this._linkid = linkid;
	this._sid = sid;
}
// 继承API的BMap.Overlay
PropertyOverlay.prototype = new BMap.Overlay();
//实现初始化方法  
PropertyOverlay.prototype.initialize = function(map){
	// 保存map对象实例 
	this._map = map;
	// 创建div元素，作为自定义覆盖物的容器
	var str = '<div class="tm-mapcode-lp" linktype="' + this._linktype + '" linkid="' + this._linkid + '" sid="' + this._sid + '">'
			+ '<div>' + this._title + '</div><i></i>'
			+ '</div>';
	var div = $(str)[0];
	div.style.position = "absolute";
	// 可以根据参数设置元素外观
	//div.style.width = this._width + "px";	//名称过长，默认自适应
	div.style.height = this._height + "px";
	div.setAttribute("class", "tm-mapcode-lp");
	// 将div添加到覆盖物容器中
	map.getPanes().markerPane.appendChild(div);
	// 保存div实例
	this._div = div;
	// 需要将div元素作为方法的返回值，当调用该覆盖物的show、
	// hide方法，或者对覆盖物进行移除时，API都将操作此元素。
	return div;
}

//实现绘制方法   
PropertyOverlay.prototype.draw = function(){
// 根据地理坐标转换为像素坐标，并设置给容器
	var position = this._map.pointToOverlayPixel(this._center);
	this._div.style.left = position.x - this._width / 2 + "px";
	this._div.style.top = position.y - this._height / 2 + "px";
}
//实现显示方法    
PropertyOverlay.prototype.show = function(){
	if (this._div){
		this._div.style.display = "";
	}
}
// 实现隐藏方法  
PropertyOverlay.prototype.hide = function(){
	if (this._div){
		this._div.style.display = "none";
	}
}

// 此处为城区div在地图上的描绘

//定义自定义覆盖物的构造函数
function AreaOverlay(center, title, count, type){
	this._center = center;
	this._height = 100;
	this._width = 100;
	this._title = title;
	this._count = count;
	this._type = 1;
	if (type) {
		if (type == 2) {
			this._width = 66;
			this._height = 66;
			this._type = 2;
		}
	}
}
//继承API的BMap.Overlay
AreaOverlay.prototype = new BMap.Overlay();
//实现初始化方法  
AreaOverlay.prototype.initialize = function(map){
	// 保存map对象实例 
	this._map = map;
	// 创建div元素，作为自定义覆盖物的容器
	var str = '<div lng="' + this._center.lng + '" lat="' + this._center.lat + '">'
		+ '<div class="tm-mapcode-district tm-map-top-xl">'
		+ '<div>' + this._title + '</div>'
		+ '<div class="am-text-sm">' + this._count + '</div>'
		+ '</div>'
		+ '</div>';
	var str2 = '<div lng="' + this._center.lng + '" lat="' + this._center.lat + '">'
		+ '<div class="tm-mapcode-district3 am-padding-top-lg">'
		+ '<div class="tm-f24">' + this._title + '</div>'
		+ '<div class="am-text-sm">' + this._count + '</div>'
		+ '</div>'
		+ '</div>';
	if (this._type == 1) {
		var div = $(str)[0];
	} else {
		var div = $(str2)[0];
	}
	div.style.position = "absolute";
	// 可以根据参数设置元素外观
	div.style.width = this._width + "px";
	div.style.height = this._height + "px";
	div.setAttribute("class", "tm-mapcode-con");
	// 将div添加到覆盖物容器中
	map.getPanes().markerPane.appendChild(div);
	// 保存div实例
	this._div = div;
	// 需要将div元素作为方法的返回值，当调用该覆盖物的show、
	// hide方法，或者对覆盖物进行移除时，API都将操作此元素。
	return div;
}

//实现绘制方法   
AreaOverlay.prototype.draw = function(){
// 根据地理坐标转换为像素坐标，并设置给容器
	var position = this._map.pointToOverlayPixel(this._center);
	this._div.style.left = position.x - this._width / 2 + "px";
	this._div.style.top = position.y - this._height / 2 + "px";
}
//实现显示方法    
AreaOverlay.prototype.show = function(){
	if (this._div){
		this._div.style.display = "";
	}
}
// 实现隐藏方法  
AreaOverlay.prototype.hide = function(){
	if (this._div){
		this._div.style.display = "none";
	}
}