/**
 * Created by zealot on 2016/8/2.
 */
angular.module('tmjia.routers', [])
    .config(function ($stateProvider, $urlRouterProvider, news_category) {
        $stateProvider
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'templates/tabs2.html',
                controller: 'tabsCtrl'
            })

            // Each tab has its own nav history stack:
            //首页
            .state('tab.home', {
                url: '/home',
                views: {
                    'tab-home': {
                        templateUrl: 'templates/tab-home2.html',
                        controller: 'HomeCtrl'
                    }
                }
            })
            //顾问首页，引用到home下面
			.state('tab.gw_home', {
				url: '/gw/home',
				views: {
					'tab-home': {
						templateUrl: 'templates/gw_index.html',
						controller: 'gwIndexCtrl'
					}
				}
			})
            //关注fous，留给丁一写
            .state('tab.focus', {
                url: '/focus',
                views: {
                    'tab-focus': {
                        templateUrl: 'templates/focus/index.html',
                        controller: 'FocusIndexCtrl'
                    }
                },
                params : {
                    isesftab : false
                },
                cache : false
            })

            //发现--弃用
            .state('tab.discover', {
                url: '/discover',
                views: {
                    'tab-news': {
                        templateUrl: 'templates/tab-discover.html',
                        controller: 'DiscoverIndexCtrl'
                    }
                }
            })

            .state('tab.news', {
                url: '/news',
                views: {
                    'tab-news': {
                        templateUrl: 'templates/news/index.html',
                        controller: 'NewsIndexCtrl'
                    }
                },
	            params: {
		            keywordtype: news_category.index
	            }
            })
            // 关键字搜索
			.state('index_searchkeyword', {
				url: '/index/searchkeyword/:gotourl/:iscoh',
				params: { gotourl: '', iscoh: '' },
				templateUrl: 'templates/searchkeyword.html',
				controller: 'searchkeywordCtrl'
			})
            // 关键字搜索
            .state('vr', {
                url: '/vr',
                params: { vrurl: '' },
                templateUrl: 'templates/vr.html',
                controller: 'vrCtrl'
            })
            ;
        function isUndefined(val) {
            return val == undefined || val === '';
        }
        // 当前是否是原生改造后的iosapp
		function isIosApp() {
			var path = getPath();
			// 原生改造后，打包app时，cordova是undefined
        	return typeof(cordova) != 'undefined' && isIos() && !isUndefined(path);
		};
		// 是否是需要显示cordova
		function isShowCordovaApp() {
			// 直接在网页上打开，或者不是在iosapp中
			return typeof(cordova) == 'undefined' || !isIosApp();
		}
		// 是否是ios环境
		function isIos() {
			var browserName = navigator.userAgent.toLowerCase();
			return /(iphone|ipod|ipad)/i.test(browserName);
		}
        function getPath() {
			var absUrl = location.href;
			var redirectUrl = /path=([^&#$]+)/.exec(absUrl);
			var path = redirectUrl && redirectUrl[1];
			if (path == undefined) {
				path = '';
			}
			// 把path转换成字符串
			return path + '';
		}
        // 防止在原生界面出现先到首页再到其他页面的bug
        if (isShowCordovaApp()) {
            $urlRouterProvider.otherwise('/tab/home');
        }
    })
;
