angular.module('tmjia.services.UDI', [])
	.factory('UDI', function ($resource, $rootScope) {
		var data = {};
		var broadcast = 'broadcast.default';
		// 拼接分页数据
		function _concatList(r, page, bc) {
			if (data[bc] && data[bc].list) {
				var newList = data[bc].list;
				if (page == 1 || angular.isUndefined(page)) {
					newList = [];
				}
				data[bc] = r;
				data[bc].list = newList.concat(r.list);
			} else {
				data[bc] = r;
			}
		}
		return {
			loadlist: function (url, params, bc) {
				$resource(url, params, {query: {timeout: 20000, isArray: true}}).query({
					uuid: localStorage.uuid,
					openid: localStorage.openid
				}, function (r) {
					data[bc] = r;
					if(params.page) {
						params.page++;
					}
					$rootScope.$broadcast(bc);
				});
			},
			loadlistfunc: function (url, params, bc, func, err) {
				$resource(url, params, {query: {timeout: 20000, isArray: true}}).query({
					uuid: localStorage.uuid,
					openid: localStorage.openid
				}, function (r) {
					data[bc] = r;
					if(params.page) {
						params.page++;
					}
					$rootScope.$broadcast(bc);
					if (typeof(func) == 'function') {
						func(data[bc]);
					}
				}, function(e) {
					if (typeof(err) == 'function') {
						err(e);
					}
				});
			},
			loadobject: function (url, params, bc, func, err, timeout) {
				var page = params.page;
				$resource(url, params, {query: {timeout: timeout || 20000, isArray: false}}).query({
					uuid: localStorage.uuid,
					openid: localStorage.openid
				}, function (r) {
					_concatList(r, page, bc);
					if(params.page) {
						params.page++;
					}
					$rootScope.$broadcast(bc);
					if (typeof(func) == 'function') {
						func(data[bc]);
					}
				}, function (e) {
					if (typeof(err) == 'function') {
						err(e);
					}
				});
			},
			loadobjectwithnewlist: function (url, params, func) {
				$resource(url, params, {query: {timeout: 20000, isArray: false}}).query({
					uuid: localStorage.uuid,
					openid: localStorage.openid
				}, function (r) {
					if (typeof(func) == 'function') {
						func(r);
					}
				});
			},
			loadobjectwithnewlistwithoutuuid: function (url, params, func) {
				$resource(url, params, {query: {timeout: 20000, isArray: false}}).query({}, function (r) {
					if (typeof(func) == 'function') {
						func(r);
					}
				});
			},
			loadobjectwithoutuuid: function (url, params, bc, func, err, timeout) {
				var page = params.page;
				$resource(url, params, {query: {timeout: timeout || 20000, isArray: false}}).query({}, function (r) {
					_concatList(r, page, bc);
					if(params.page) {
						params.page++;
					}
					$rootScope.$broadcast(bc);
					if (typeof(func) == 'function') {
						func(data[bc]);
					}
				}, function (e) {
					if (typeof(err) == 'function') {
						err(e);
					}
				});
			},
			loaddtobjectwithoutuuid: function (url, params, bc, func) {
				var page = params.page;
				$resource(url, params, {query: {timeout: 20000, isArray: false}}).query({}, function (r) {
					_concatList(r, page, bc);
					if(params.page) {
						params.page++;
					}
					$rootScope.$broadcast(bc);
					if (typeof(func) == 'function') {
						func(data[bc]);
					}
				});
			},
			saveobject: function (url, params, bc, func, err) {
				$resource(url, {}, {
					save: {
						method: 'post',
						cache: true,
						timeout: 20000
					}
				}).save({
					uuid: localStorage.uuid,
					openid: localStorage.openid
				}, params, function (r) {
					data[bc] = r;
					$rootScope.$broadcast(bc);
					if (typeof(func) == 'function') {
						func(data[bc]);
					}
				}, function (r) {
					if (typeof r == 'object') {
						// alert(JSON.stringify(r));
					} else {
						// alert(r);
					}
					if (typeof(err) == 'function') {
						err(r);
					}
				});
			},
			removeresult: function (bc) {
				data[bc] = null;
			},
			getresult: function (bc) {
				return data[bc];
			},
			post: function (url, params, bc, func) {
				var xhr = new XMLHttpRequest();
				xhr.open("post", url);
				var savedata = JSON.stringify(params);
				xhr.send(savedata);
				xhr.onreadystatechange = function () {
					if (xhr.readyState == 4 && xhr.status == 200) {
						console.log("returned:" + xhr.responseText);
						if (typeof xhr.responseText == 'object') {
							data[bc] = xhr.responseText;
						} else {
							data[bc] = JSON.parse(xhr.responseText);
						}
						$rootScope.$broadcast(bc);
						if (typeof(func) == 'function') {
							func(data[bc]);
						}
					}
				};
			}
		}
	})
	/**
	 * UDI的扩展，每个函数的接收参数和UDI基本一样，区别是不需要传入成功回调函数。
	 * UDIP返回的是一个promise对象，方法调用者可以直接使用该对象进行后续的逻辑处理。
	 * 该promise支持两张方法，分别为then()：成功回调、catch()：失败回调。
	 * 调用方式如下：
	 * 1、单个请求的调用
	 * var promise = UDIP.loadobject(url, params, bc);
	 * promise.then(function(result) {}).catch(function(e) {});
	 * 2、多个请求的同时调用，场景为：当结果需要同时多个请求全部成功后显示时
	 * var promise1 = UDIP.loadobject(url, params, bc);
	 * var promise2 = UDIP.loadobject(url, params, bc);
	 * $q.all([ promise1, promise2 ]).then(function(results) {}).catch(function() {})
	 * 多个请求使用$q.all这个方式调用，当两个请求全部成功后，进入成功回调then里面。
	 * then的入参results为数组，分别表示promise1和promise2的返回结果。
	 * 使用$q.all时，如果其中一个请求失败，则直接进入catch方法
	 * 3、多个嵌套请求的调用，解决回调地狱。
	 * UDIP.loadobject(url, params, bc).then(function(result1) {
	 * 	  doSomething();
	 *	  return UDIP.loadobject(url, params, bc);
	 * }).then(function(result2) {
	 * 	  doSomething();
	 *	  return UDIP.loadobject(url, params, bc);
	 * }).then(function(result3) { doSomething(); })
	 */
	.factory('UDIP', function ($q, $resource, UDI) {
		var TIMEOUT = 15000;
		return {
			loadobject: function(url, params, bc, timeout) {
				var defer = $q.defer();
				UDI.loadobject(url, params, bc, defer.resolve, defer.reject, timeout);
				return defer.promise;
			},
			loadlistfunc: function(url, params, bc) {
				var defer = $q.defer();
				UDI.loadlistfunc(url, params, bc, defer.resolve, defer.reject);
				return defer.promise;
			},
			saveobject: function(url, params, bc) {
				var defer = $q.defer();
				UDI.saveobject(url, params, bc, defer.resolve, defer.reject);
				return defer.promise;
			},
			loadjson: function(url, params, bc) {
				var defer = $q.defer();
				$resource(url, params, { query: { timeout: TIMEOUT, cache: true } }).query({ json: true }, function (r) {
					bc && $rootScope.$broadcast(bc);
					defer.resolve(r);
				}, function(e) {
					defer.reject(e);
				});
				return defer.promise;
			},
			loadjsonobject: function(url, params, bc) {
				var defer = $q.defer();
				$resource(url, params, { query: { cache: true } }).query({ json: true }, function(r) {
					bc && $rootScope.$broadcast(bc);
					defer.resolve(r);
	            }, function(e) {
	            	defer.reject(e);
	            });
				return defer.promise;
			},
			loadobjectwithoutuuid: function(url, params, bc, timeout) {
				var defer = $q.defer();
				UDI.loadobjectwithoutuuid(url, params, bc, defer.resolve, defer.reject, timeout);
				return defer.promise;
			},
			removeresult: function(bc) {
				UDI.removeresult(bc);
			}
		}
	})
;
