/**
 * Created by cb on 2016/8/10.
 */
angular.module('tmjia.services.ask', [])

    .factory('AskIndexFactory', function ($resource,$timeout,Utile, $rootScope, url,ModalFactory) {
        //搜索地址
        var searchurl = url.ask.list;

        //搜索数据结构
        var searchobject = {
            data : [],
            hasNextPage : true
        };

        //搜索参数
        var params = {
            page : 1,
            catetype : 0,
            hotflag : 1,
            isback : 1
        }
        
        var jlgwlist = [];

        //搜索实体
        var serachresource = $resource(searchurl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        //搜索方法
        function query($scope){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            
            serachresource.query(params, function (r) {
                for(var i in r.list){
                    if(r.list[i].isback == 1){
                        r.list[i].isback = true;
                    }else{
                        r.list[i].isback = false;
                    }
                }
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
                $rootScope.$broadcast('asklist.updated');
           	}, function (e) {
				$rootScope.alert('加载失败!');
            });
            
        }

        //读取解决问题数
        var counturl = url.ask.count;
        var countresource = $resource(counturl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        var count;

        function loadCount() {
            countresource.query({}, function(r) {
                count = r.count;
                $rootScope.$broadcast('count.updated');
            })
        }

        return{
            //读取列表
            loadList : function($scope) {
                query($scope);
               
            },

            //获得列表数据
            getList : function() {
                return searchobject.data;
            },

            //刷新列表
            reloadList : function(param) {
                searchobject = {
                    data : [],
                    hasNextPage : true
                };

                params.catetype = param.catetype;

                params.page = 1;

                if(param.keywords){
                    params.keywords = param.keywords;
                }else{
                    params.keywords = '';
                }

                query();

            },

            //翻页确认
            hasNextPage : function() {
                return searchobject.hasNextPage;
            },

            loadCount : loadCount,
            getCount : function() {
                return count;
            },
            loadJlgwList: function() {
            	$resource(url.ask.jlgwlist,{},{
                    query: {
                        method: 'get',
                        cache: true,
                        timeout: 20000
                    }
                }).query(params, function (r) {
                    jlgwlist = r.gwlist;
                    $rootScope.$broadcast('ask.jlgwlist.updated');
                });
            },
            getJlgwList: function() {
            	return jlgwlist;
            }
        }

    })
    .factory('AskListFactory', function (UDIP, url) {
    	return {
    		getList: function(params, bc) {
    			return UDIP.loadobject(url.ask.list, params, bc);
    		}
    	};
    })
    .factory('AskDetailFactory', function ($resource, $rootScope, url) {
        var infourl = url.ask.info;

        var content = '';

        var inforesource = $resource(infourl, {}, {
            query:{
                method : 'get',
                cache : true,
                timeout : 20000
            }
        });

        function query(cateid) {
            inforesource.query({cateid : cateid},function(r) {
                content = r.cate;
                $rootScope.$broadcast('askdetail.updated');
            });
        }

        return{
            loadInfo : function(cateid){
                query(cateid);
            },

            getInfo : function(){
                return content;
            }
        }
    })
    .factory('MyAskListFactory', function (UDIP, url) {
        return {
            getList : function(params) {
                params.uuid = localStorage.uuid;
                params.openid = localStorage.openid;
                return UDIP.loadobject(url.ask.list, params, 'ask.mylist.list');
            }
        };
    })
    .factory('SubAskFactory', function ($resource, $rootScope, url) {
        var askurl = url.ask.ask;
        var msg;
        var askresource = $resource(askurl,{},{
            save: {
                method: 'post',
                cache: true,
                timeout: 20000
            }
        });
        return{
            submit : function(info) {
                askresource.save({
                    uuid : localStorage.uuid,
                    openid : localStorage.openid
                }, info,function(r) {
                    msg = r;
                    $rootScope.$broadcast('AskInfo.submitted');
                });
            },
            getMsg : function() {
                return msg;
            }
        }
    })
    .factory('AskKeywordFactory', function($rootScope, $state, $sce, UDIP, url, ModalFactory) {
    	return {
    		searchList: function(params) {
    			if (angular.isString(params)) {
    				params = {
	    				page: 1,
	    				titlekeywords: params
	    			}
    			}
    			params.hotflag = true;
				return UDIP.loadobject(url.ask.list, params, 'ask.keywordlist.list');
    		},
    		handleSearchList: function(result, keyword) {
    			for (var i in result.list) {
					result.list[i].htmlcontent = result.list[i].catetitle.replace(keyword, '<span class="blue01">' + keyword + '</span>');
					result.list[i].htmlcontent = $sce.trustAsHtml(result.list[i].htmlcontent);
				}
    			return result;
    		},
    		// 广告位加载
    		getAdvs: function() {
    			var apiUrl = url.tmj.indexad + url.hourcache;
    			return UDIP.loadlistfunc(apiUrl, {
    				adtypeid: 1166984817,
    				a: 33,
    				json: true
    			}, 'ask.search.ad.list');
    		},
    		getHistory: function() {
    			var history_string = localStorage.ask_keyword_history;
    			return history_string ? JSON.parse(history_string) : [];
    		},
    		setHistory: function(historylist) {
    			// 如果为空就不添加
    			if ($rootScope.ask_keyword == '') {
    				return;
    			}
    			// 如果有相同就不添加
    			for (i in historylist) {
    				if (historylist[i] == $rootScope.ask_keyword) {
    					return;
    				}
    			}
    			historylist.push($rootScope.ask_keyword);
    			localStorage.ask_keyword_history = JSON.stringify(historylist);
    		},
    		clearHistory: function() {
    			localStorage.ask_keyword_history = '';
    		},
    		goToAsk: function (scope) {
    			if ($rootScope.meminfo) {
    				$state.go('ask_ask');
    			} else {
    				// 登录
    				scope.openLoginModal();
    			}
    		},
    		// 关联会员登陆弹出层
    		addLoginModal: function(scope) {
    			ModalFactory.loadLoginModal(scope);
    		}
    	};
    })
;