angular.module('tmjia.services.decoration', [])

    // 家装
    .factory('dcrCaseFactory', function ($resource, $rootScope, $timeout, url, Utile) {
        var dcrcase_list_url = url.decoration.dcrcase.list;//案例列表接口地址
        var dcrcase_detail_url = url.decoration.dcrcase.detail;//案例详情接口地址
        var dcrcase_visit_url = url.decoration.dcrcase.visit;//案例访问量接口地址
        var dcrcase_collect_url = url.decoration.dcrcase.collect;//案例关注接口新增地址
        var dcrcase_collectlist_url = url.decoration.dcrcase.collectlist;//获得案例关注列表地址
	    var dcrcase_record_url = url.decoration.dcrcase.record;//获得记录用户装修情况地址
    	var list;
    	
		var detailobject = {//数据返回
    		data : []
    	};
        //获得案例列表的接口配置
        var listresource = $resource(dcrcase_list_url,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
    	//获得案例详情的接口配置
		var detailresource = $resource(dcrcase_detail_url,{},{
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});
		//获得关注列表的接口配置
		var collectlistresource = $resource(dcrcase_collectlist_url,{},{
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});
		//获得访问量新增的接口配置
		var visitresource = $resource(dcrcase_visit_url,{},{
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});
		//获得关注新增的接口配置
		var collectresource = $resource(dcrcase_collect_url,{},{
			query: {
				method: 'get',
				cache: true,
				timeout: 5000
			}
		});
        return {
            loadlist: function (params) {
                
                listresource.query(params, function(r) {//获得数据
                        list = r;
                        $rootScope.$broadcast('dcrCaseListCtrl.loadlist');//触发监听
                 }, function (e) {
					$rootScope.alert('加载失败!');
				});
            },
            loaddetail: function (caseid) {//获得案例详情
            	detailresource.query({caseid:caseid, _r: parseInt(Math.random() * 10000)}, function(r) {//获得数据
            		detailobject.data = r;
					$rootScope.$broadcast('dcrCaseDetailCtrl.showdcrdetail');//触发监听
				});
            },
            loadcollectlist: function () {
            	collectlistresource.query({_r: parseInt(Math.random() * 10000)},function(r) {//获得数据
                    list = r;
                    $rootScope.$broadcast('dcrCaseListCtrl.loadcollectlist');//触发监听
                 });
            },
            getlist: function () {
            	return list;
            },
            getdetail: function () {
            	return detailobject.data;
            },
            getphoto: function () {

            },
            getcollectlist: function () {
            	return list;
            },
            getcollect: function () {
            	return detailobject.data;
            },
            visit: function (caseid) { //每次打开一个案例时执行 添加一次访问量
            	visitresource.query({caseid:caseid}, function(r) {
            	});
            },
            collect: function (caseid) {  // 收藏一个案例
            	collectresource.query({uuid: localStorage.uuid, caseid:caseid, _r: parseInt(Math.random() * 10000)}, function(r) {
            		detailobject.data = r;
            		$rootScope.$broadcast('dcrCaseDetailCtrl.showcollect');
            	});
            },
	        record: function (record) {
		        $resource(dcrcase_record_url, {}, {save: {method: 'post', timeout: 20000}}).save({
			        uuid: localStorage.uuid,
			        record: record
			        }, function (r) {
			        var returnMsg = r;
			        console.log(returnMsg);
		        });
	        }
        }
    })
    // 家装公司(门店)
    .factory('dcrCompanyFactory', function ($resource, $timeout, $rootScope, url, Utile) {
        var company_list_url = url.decoration.company.list;//案例接口地址
    	var companydetailUrl = url.decoration.company.detail;
    	var companycollectUrl = url.decoration.company.collect;
    	var companyvisitUrl = url.decoration.company.visit;
    	var companycollectlistUrl = url.decoration.company.collectlist;
        var list, collectlist;
        var companydetail;
        var returnMsg;
        //获得案例详情的接口配置
        var listresource = $resource(company_list_url,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        return {
            loadlist: function (params) {
                listresource.query(params, function(r) {//获得数据
                    list = r;
                    $rootScope.$broadcast('dcrCompanyListCtrl.loadlist');//触发监听
                });
            },
            loaddetail: function(storeid) {
            	$resource(companydetailUrl, {}, {query: {method: 'get', timeout: 20000}}).query({storeid: storeid}, function (r) {
            		companydetail = r;
            		$rootScope.$broadcast('dcrCompany.detail.success');
            	});
            },
            loadcollectlist: function () {
            	$resource(companycollectlistUrl, {}, {query: {method: 'get', timeout: 20000}}).query({_r: parseInt(Math.random() * 10000)},function(r) {//获得数据
                    collectlist = r;
                    $rootScope.$broadcast('dcrCompanydetailCtrl.loadcollectlist');//触发监听
                });
            },
            getlist: function () {
                return list;
            },
            getcollectlist: function () {
            	return collectlist;
            },
            getdetail: function () {
            	return companydetail;
            },
            // 每次打开一个公司(门店)时执行
            visit: function (storeid) {
            	$resource(companyvisitUrl, {}, {query: {method: 'get', timeout: 20000}}).query({storeid: storeid}, function (r) {
            		
            	});
            },
            // 收藏一个公司(门店)
            collect: function (storeid) {
            	$resource(companycollectUrl, {}, {query: {method: 'get', timeout: 20000}}).query({uuid: localStorage.uuid, storeid: storeid, _r: parseInt(Math.random() * 10000)}, function (r) {
            		returnMsg = r;
            		$rootScope.$broadcast('dcrCompanyDetailCtrl.showcollect');
            	});
            },
            getMsg: function () {
            	return returnMsg;
            }
        }
    })
    // 家装 预约
    .factory('dcrAppointFactory', function ($resource, $rootScope, url) {
    	var appointsaveUrl = url.decoration.appoint.save;
    	var returnMsg;
        return {
            save: function (params) {
            	$resource(appointsaveUrl, {}, {save: {method: 'post', timeout: 20000}}).save({}, params, function (r) {
            		returnMsg = r;
            		$rootScope.$broadcast('appointsave.completed');
            	});
            },
            getMsg: function () {
            	return returnMsg;
            }
        }
    })
    // 家装 报名 包含验房和设计
	.factory('dcrSignupFactory', function ($resource, $rootScope, url) {
		var accepthouseUrl = url.decoration.signup.accepthouse;
		var designUrl = url.decoration.signup.design;
		var phonenumberUrl = url.decoration.signup.phonenumber;
		var returnMsg, phonenumberMsg;
		return {
			design: function (params) {
				$resource(designUrl, {}, {save: {method: 'post', timeout: 20000}}).save(params, function (r) {
					returnMsg = r;
					$rootScope.$broadcast('dcr.signup.completed');
				});
			},
			accepthouse: function (params) {
				$resource(accepthouseUrl, {}, {save: {method: 'post', timeout: 20000}}).save(params, function (r) {
					returnMsg = r;
					$rootScope.$broadcast('dcr.signup.completed');
				});
			},
			getMsg: function () {
				return returnMsg;
			},
			phonenumber: function () {
				$resource(phonenumberUrl, {}, {query: {method: 'get', timeout: 20000}}).query({}, function(r) {//获得数据
					phonenumberMsg = r;
					$rootScope.$broadcast('dcr.phonenumber.loaded');//触发监听
				});
			},
			getPhonenumberMsg: function () {
				return phonenumberMsg;
			}
		}
	})
    // 家装 关键字搜索
    .factory('dcrKeywordFactory', function () {
        var _whatkeyword = 1;
        var keywordtyle_case = ['全部', '装修公司名称', '小区名称', '风格名称', '案例位置'];
        var keywordtyle_company = ['全部', '装修公司名称', '装修公司位置'];
	    function getHistorylist() {
		    var str = '';
		    if (_whatkeyword == 1) {
			    str = localStorage.dcrhistory_case;
		    } else {
			    str = localStorage.dcrhistory_company;
		    }
		    var list = [];
		    if(str) {
			    list = JSON.parse(str);
		    }
		    return list;
	    }
	    function saveHistory(list) {
		    if (_whatkeyword == 1) {
			    localStorage.dcrhistory_case = JSON.stringify(list);
		    } else {
			    localStorage.dcrhistory_company = JSON.stringify(list);
		    }
	    }
        return {
            init: function (whatkeyword) {
                _whatkeyword = whatkeyword;
            },
            loadKeywordtype: function () {
                if (_whatkeyword == 1) {
                    return keywordtyle_case;
                } else {
                    return keywordtyle_company;
                }
            },
            loadHistory: function () {
	            var list = getHistorylist();
	            if (list.length == 0) {
		            return '';
	            } else {
		            return list.reverse();
	            }
            },
            saveHistory: function (obj) {
	            var list = getHistorylist();
	            var newlist = [];
	            for (var i in list) {
		            if (obj.keyword == list[i].keyword && obj.keywordtype == list[i].keywordtype) {

		            } else {
			            newlist.push(list[i]);
		            }
	            }
	            newlist.push(obj);
	            saveHistory(newlist);
            },
	        removeHistory: function (index) {
		        var list = getHistorylist();
		        var newlist = [];
		        for (i in list) {
			        if (i != list.length - 1 - index) {
				        newlist.push(list[i]);
			        }
		        }
		        saveHistory(newlist);
		        return newlist.reverse();
	        },
            clearHistory: function () {
                if (_whatkeyword == 1) {
                    localStorage.dcrhistory_case = '';
                } else {
                    localStorage.dcrhistory_company = '';
                }
            }
        }
    })
    // 家装 搜索列表的配置项
    .factory('dcrSettingsFactory', function () {
        var settings = new Object();
        //装修风格
        settings.stylelist = [
            {value: '', name: '风格不限'},
            {value: '现代简约', name: '现代简约'},
            {value: '美式', name: '美式'},
            {value: '新古典', name: '新古典'},
            {value: '欧式', name: '欧式'},
            {value: '港式', name: '港式'},
            {value: '法式', name: '法式'},
            {value: '日韩', name: '日韩'},
            {value: '田园', name: '田园'},
            {value: '后现代', name: '后现代'},
            {value: '地中海', name: '地中海'},
            {value: '英伦', name: '英伦'},
            {value: '混搭', name: '混搭'},
            {value: '中式', name: '中式'},
	        {value: '东南亚', name: '东南亚'},
	        {value: '北欧风格', name: '北欧风格'},
	        {value: '新中式风格', name: '新中式风格'},
            {value: '其他', name: '其他'}
        ];
        //户型
        settings.roomlist = [
            {value: 0, name: '不限'},
            {value: 1, name: '一室'},
            {value: 2, name: '二室'},
            {value: 3, name: '三室'},
            {value: 4, name: '四室'},
            {value: 5, name: '五室'},
            {value: 6, name: '六室及以上'}
        ];
        //区域
        settings.arealist = [
            {value: 33, name: '不限'},
            {value: 99, name: '附近'},
            {value: '320506', name: '吴中区'},
            {value: '320507', name: '相城区'},
            {value: '320508', name: '姑苏区'},
            {value: '320509', name: '吴江区'},
            {value: '320571', name: '工业园区'},
            {value: '320591', name: '高新区'},
            {value: '320581', name: '常熟市'},
            {value: '320582', name: '张家港市'},
            {value: '320583', name: '昆山市'},
            {value: '320585', name: '太仓市'}
        ];
        //更多筛选,空间类型
        settings.classidlist = [
            {value: 0, name: '不限'},
            {value: 1, name: '客厅'},
            {value: 5, name: '卧室'},
            {value: 7, name: '书房'},
            {value: 8, name: '卫生间'},
            {value: 4, name: '厨房'},
            {value: 3, name: '餐厅'},
            {value: 9, name: '衣帽间'},
            {value: 6, name: '儿童房'},
            {value: 2, name: '玄关'},
            {value: 10, name: '阳台'},
            {value: 12, name: '软装摆件'},
            {value: 11, name: '其他区域'}
        ];
        //更多筛选,面积
        settings.builtuparealist = [
            {value: '', name: '不限'},
            {value: '0_50', name: '50㎡以下'},
            {value: '50_70', name: '50-70㎡'},
            {value: '70_90', name: '70-90㎡'},
            {value: '90_110', name: '90-110㎡'},
            {value: '110_140', name: '110-140㎡'},
            {value: '140_200', name: '140-200㎡'},
            {value: '200_300', name: '200-300㎡'},
            {value: '300_999', name: '300㎡以上'}
        ];
        //更多筛选,装修类型
        settings.pricetypelist = [
            {value: 0, name: '不限'},
            {value: 3, name: '清包'},
            {value: 2, name: '半包'},
            {value: 1, name: '全包'}
        ];
        //更多筛选,装修总价
        settings.pricelist = [
            {value: '', name: '不限'},
            {value: '0.01_3', name: '3万以下'},
            {value: '3_5', name: '3-5万'},
            {value: '5_8', name: '5-8万'},
            {value: '8_10', name: '8-10万'},
            {value: '10_15', name: '10-15万'},
            {value: '15_20', name: '15-20万'},
            {value: '20_30', name: '20-30万'},
            {value: '30_999', name: '30万以上'}
        ];
        //更多筛选,排序方式
        settings.orderbylist = [
            {value: '', name: '默认排序'},
            {value: '1', name: '关注人数'},
            {value: '2', name: '距我最近'},
            {value: '3', name: '发布时间'}
        ];
        //更多筛选,房屋类型
        settings.managetypelist = [
            {value: 0, name: '不限'},
            {value: 10101, name: '住宅'},
            {value: 10902, name: '公寓'},
            {value: 10102, name: '商住'},
            {value: 10103, name: '写字楼'},
            {value: 102, name: '别墅'},
            {value: 10901, name: '营业房'},
	        {value: 124, name: '库房'},
	        {value: 123, name: '厂房'},
            {value: 109, name: '其他'}
        ];
        settings.orderbylist_company = [
            {value: 0, name: '默认排序'},
            {value: 1, name: '距我最近'},
            {value: 2, name: '案例数量'},
            {value: 3, name: '关注人数'}
        ];
        return {
            settings: function () {
                return settings;
            }
        }
    })
;