angular.module('tmjia.services.directive', [])
	.factory('directiveTemplate', function ($rootScope, $state) {
		return {
			template: function (templateurl) {
				return {
					restrict: 'E',
					transclude: true,
					scope: true,
					templateUrl: templateurl,
					link: function ($scope, element, attrs) {
						$scope.isfrom = attrs.isfrom;
						$scope.hatchlist = $scope[attrs.hatchlist];
						$scope.$watch(attrs.hatchlist, function (n, o) {
							$scope.hatchlist = $scope[attrs.hatchlist];
							$scope._INIT_JJHYGL_IMG_YUMING = _INIT_JJHYGL_IMG_YUMING;
							$scope._INIT_IMG_YUMING = _INIT_IMG_YUMING;
							$scope._INIT_ZL_IMG_YUMING = _INIT_ZL_IMG_YUMING;
						})

						$scope.gotojlgwdetail = function(b) {
							$state.go('adviser_mian', {
								brokerid: b
							});
						}
					}
				}
			}

		}
	})
	.factory('directiveChartsTemplate', function ($timeout) {
		return {
			template: function (templateurl) {
				return {
					restrict: 'E',
					transclude: true,
					scope: true,
					templateUrl: templateurl,
					link: function ($scope, element, attrs) {
						$scope.echarslist = $scope[attrs.echarslist];
						$scope.$watch(attrs.echarslist, function (n, o) {
							$scope.showEchars = true;
							$scope.echarslist = $scope[attrs.echarslist];
							if ($scope.echarslist) {
								$scope.legend = $scope.echarslist.legend;
								$scope.ylist = $scope.echarslist.ylist;
								$scope.xlist = $scope.echarslist.xlist;
								if ($scope.legend.length > 0 && $scope.ylist.length > 0 && $scope.xlist.length > 0) {
									$scope.showEchars = true;
									creatOption();
								} else {
									$scope.showEchars = false;//没数据时显示默认图片
								}
							}
						})
						function creatOption() {
							$timeout(function () {//延时处理，防止切换是div未生成
								var chart =  element.find('div')[0];
								var myChart = echarts.init(chart);
								var colors = $scope.echarslist.colors;
								var series = [];
								for (var i = 0; i < $scope.xlist.length; i++) {
									series.push({
							            name: $scope.legend[i],
							            type:'line',
							            smooth: true,
							            symbol:'circle',
							            data: $scope.xlist[i].list
									});
								}
								var option = {
								    color: colors,
								    tooltip: {
								    	show:true
								    },
								    legend: {
								    	textStyle:{
						                    fontSize: '12'
						                },
						                itemWidth: 15,
						                itemHeight: 15,
						                left : 'right',
								        data:$scope.legend
								    },
								    grid: {
								        top: '20%',
								        bottom: '10%',
								        left: '15%'
								    },
								    xAxis: {
								    	type: 'category',
								        boundaryGap: false,
								        axisLabel: {
			                                show: true,
			                                textStyle: {
			                                    fontSize: '12'
			                                },
			                                interval:0
			                            },
			                            splitLine:{show: false},//去除网格线
							            data: $scope.ylist
							        },
								    yAxis: [
								        {
								            type: 'value',
							            	axisLabel: {
				                                show: true,
				                                textStyle: {
				                                    fontSize: '12'
				                                }
				                            }
								        }
								    ]
								};
								option.series = series;
								myChart.setOption(option);
								myChart.resize();
							}, 100);
						}
					}
				}
			}
		}
	})
	// 楼盘列表-竖
	.directive('propertylistStandHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/propertylistStand.html');
	})
	// 楼盘的房屋坐落列表-竖
	.directive('fwzllistStandHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/fwzllistStand.html');
	})
	// 出售房源列表-竖
	.directive('gpfylistStandHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/gpfylistStand.html');
	})
	// 出售房源列表-横
	.directive('gpfylistLieHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/gpfylistLie.html');
	})
	// 出租房源列表-竖
	.directive('rentlistStandHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/rentlistStand.html');
	})
	// 出租房源列表-横
	.directive('rentlistLieHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/rentlistLie.html');
	})
	// 小区金领顾问列表-竖
	.directive('jlgwlistStandHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/jlgwlistStand.html');
	})
	// 周边小区-横
	.directive('zbxqlistLieHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/zbxqlistLie.html');
	})
	// 周边新房-横
	.directive('zbxflistLieHatch', function ($rootScope, directiveTemplate) {
		return directiveTemplate.template('templates/directive/zbxflistLie.html');
	})
	// 走势图
	.directive('echartsHatch', function ($rootScope, directiveChartsTemplate) {
		return directiveChartsTemplate.template('templates/directive/fjzsCharts.html');
	})
	;
