/**
 * Created by franklin on 2016/8/21.
 */
angular.module('tmjia.services.evalu', [])

    .factory('EvaluFactory', function ($resource, $rootScope, url) {
    	
    	var selectbuildingUrl =  url.evalu.selectbuilding;
    	var selectbuilding = $resource(selectbuildingUrl, {},{
            save: {
                method: 'post',
                cache: true,
                timeout: 20000
            }
        });
    	
    	var buildinglist;
    	var communityid;
    	return {
    		loadBuildingList: function (name){
    			selectbuilding.save({
                    uuid : localStorage.uuid,
                    openid : localStorage.openid                    
                }, {communityname:name}, function(r){
                	if(r.flag){
                		buildinglist = r.list;
                		communityid = r.communityid;
                		$rootScope.$broadcast('buildingList.complete');
                	}
                	else {
                		$rootScope.alert("该小区暂不支持估价");
                	}
                });
    		},
    		getBuildingList :  function (){
    			return buildinglist;
    		},
    		getCommunityId:function (){
    			return communityid;
    		}
    		
    	}
    })
	
    .factory('EvaluDetailFactory', function ($resource, $rootScope, url) {
    	//取详情
    	var detailUrl = url.property.detail;
    	var detailinfo;
    	function loadEvaluDetail(search){
    		$resource(detailUrl, {}, {query: {timeout: 20000}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                linktype:2,
                communityid:search.communityid,
                json:"true"
            }, {}, function (r) {
            	detailinfo = r;
            	loadEvaluPrice(search);
            });
    	}
    	
    	//取估价
    	var assessValue = 0;
    	var assessValueUrl = url.mem.myhouseAssessValue;
    	function loadEvaluPrice(search){
    		$resource(assessValueUrl, {}, {query: {timeout: 20000}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                zrzid:search.zrzid,
                communityid:search.communityid,
                allfloor:search.allfloor,
                floor:search.floor,
                fwyt:10,
                builtarea:search.area
            }, {}, function (r) {
            	assessValue = r.accessvalue;
            	loadEvaluPriceInfo(search);
            });
    	}
    	
    	//取案例情况
    	var priceInfo;
    	var priceUrl= url.property.price;
    	function loadEvaluPriceInfo(search){
    		$resource(priceUrl, {}, {query: {timeout: 20000}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                communityid:search.communityid,
                json:"true"
            }, {}, function (r) {
            	priceInfo = r;
        		$rootScope.$broadcast('evaludetail.updated');
            });
    	}
    	
    	return {
    		loadEvaluDetail: loadEvaluDetail,
    		getEvaluDetail:function (){
    			return detailinfo;
    		},
    		getAssessValue:function (){
    			return assessValue;
    		},
    		getPriceInfo:function (){
    			return priceInfo;
    		}
    	}
    })
;