/**
 * Created by cb on 2016/8/15.
 */
angular.module('tmjia.services.focus', [])

    .factory('FocusIndexFactory', function ($resource, $rootScope, url) {
        //新房搜索
        var newhouseurl = url.search.focus;
        var newhouseobject = {
            data:[]
        };
        var newhouseresource = $resource(newhouseurl, {}, {
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });
        function newhousequery(){
            var portalsData = newhouseobject.data;
            newhouseresource.query({
                linktype : 1,
                uuid : localStorage.uuid,
                openid : localStorage.openid
            }, function (r) {
                portalsData = r.list;
                newhouseobject = {
                    'data': portalsData
                };
                $rootScope.$broadcast('newhouselist.updated');
                $rootScope.$broadcast('all.updated');
            });
        };

        //二手房搜索
        var esfurl = url.search.focus;
        var esfobject = {
            data:[]
        };
        var esfresoruce = $resource(esfurl, {}, {
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });
        function esfquery(){
            var portalsData = esfobject.data;
            esfresoruce.query({
                linktype : 2,
                uuid : localStorage.uuid,
                openid : localStorage.openid
            }, function (r) {
                portalsData = r.list;
                esfobject = {
                    'data': portalsData
                };
                $rootScope.$broadcast('esflist.updated');
                $rootScope.$broadcast('all.updated');
            });
        };
        
      //租房搜索
        var renthouseurl = url.search.focus;
        var renthouseobject = {
            data:[]
        };
        var renthouseresource = $resource(renthouseurl, {}, {
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });
        function renthousequery(){
            var portalsData = renthouseobject.data;
            renthouseresource.query({
                linktype : 3,
                uuid : localStorage.uuid,
                openid : localStorage.openid
            }, function (r) {
                portalsData = r.list;
                renthouseobject = {
                    'data': portalsData
                };
                $rootScope.$broadcast('renthouselist.updated');
                $rootScope.$broadcast('all.updated');
            });
        };

        //资讯搜索
        var newsurl = url.news.list;
        var newsobject = {
            data : [],
            hasNextPage : true
        };
        var newsresource = $resource(newsurl, {}, {
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });
        var params = {
            page : 1,
            uuid : localStorage.uuid,
            openid : localStorage.openid,
            isfocus: 'true'
        };
        function newsquery(){
            var hasNextPage = newsobject.hasNextPage;
            var portalsData = newsobject.data;
            newsresource.query(params, function (r) {

                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                newsobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };

                $rootScope.$broadcast('newslist.updated');
                if(params.page == 2){
                    $rootScope.$broadcast('all.updated');
                }
                $rootScope.$broadcast('scroll.infiniteScrollComplete');

            });
        };
        
        //资讯关注栏目读取
        var newsfocusurl = url.mem.newsfocus;
        var newsfocuslist = [];
        var newsfocusresource = $resource(newsfocusurl, {}, {
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        function newsfocusquery() {
            newsfocusresource.query({
                uuid : localStorage.uuid,
                openid : localStorage.openid
            },function(r) {
                newsfocuslist = r.list;
                $rootScope.$broadcast('newfocus.updated');
            });
        };
        
        //资讯关注提交
        var newssubmiturl= url.mem.doorder;
        var submitmsg = [];
        var newssubmitresrouce = $resource(newssubmiturl,{
            save : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        })
        function newssubmit(list,linktype){
            var params = {
                uuid : localStorage.uuid,
                openid : localStorage.openid
            };
            if(list.length > 1){
                params.linkids = list.toString();
                params.linktypes = linktype.toString();
            }else{
                params.linkid = list.toString();
                params.linktype = linktype.toString();
            }

            newssubmitresrouce.save(params,function(r) {
                submitmsg = r;
                $rootScope.$broadcast('newsubmit.updated');
            })
        }

        var deleteurl = url.mem.undoorder;
        var deleteresource = $resource(deleteurl,{},{
            query : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        
        function deleteFocus(list,linktype){
            deleteresource.query({
                uuid : localStorage.uuid,
                openid : localStorage.openid,
                linktype : linktype,
                linkids : list.toString(),
                _d : parseInt(Math.random() * 10086)
            },function(r) {
                submitmsg = r;
                $rootScope.$broadcast('delete.updated');
            });
        }
        
        return{
            //读取列表
            loadAll : function() {
                newhousequery();
                esfquery();
                newsquery();
                newsfocusquery();
            },
            //刷新列表
            loadMoreNews : function() {
                newsquery()
            },
            //获得新房数据
            getNewhouseList : function() {
                return newhouseobject.data;
            },
            //获得二手房数据
            getEsfList : function() {
                return esfobject.data;
            },
            //获得租房数据
            getRenthouseList : function() {
                return renthouseobject.data;
            },
            //获得资讯数据
            getNewsList : function() {
                return newsobject.data;
            },
            //资讯是否存在下一页
            hasNextPage : function() {
                return newsobject.hasNextPage;
            },
            getNewsFocus : function() {
                return newsfocuslist;
            },
            //提交资讯关注
            submitNews : function(list,linktype) {
                newssubmit(list,linktype)
            },
            getReturnMsg : function() {
                return submitmsg;
            },
            //重读资讯列表
            reloadNews : function() {
                newsobject = {
                    data : [],
                    hasNextPage : true
                };
                params = {
                    page : 1,
                    uuid : localStorage.uuid,
                    isfocus: true,
                    openid : localStorage.openid
                };
                newsquery();
            },
            //小区/楼盘取消关注
            deleteFocus : function(list,linktype){
                deleteFocus(list,linktype);
            },
            //重读楼盘小区列表
            reloadProperty : function(){
                newhousequery();
                esfquery();
                $rootScope.$broadcast('reload.rentlist');
                $rootScope.$broadcast('reload.gpfylist');
            }
        }

    })
    .factory('FocusChoiceFactory', function ($resource, $rootScope,$timeout,Utile, url) {
        //搜索地址
        var propertyurl = url.search.property;
        var communityurl = url.search.community;
        var gpfyurl = url.gpfy.gpxxlist;
        var renturl = url.search.cz
        
        //搜索实体
        var propertyresource = $resource(propertyurl, {},{
            query : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        var communityresource = $resource(communityurl, {},{
            query : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        var gpfyresource = $resource(gpfyurl, {},{
        	query : {
        		method: 'get',
        		cache: true,
        		timeout: 20000
        	}
        });
        var rentresource = $resource(renturl, {},{
            query : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        
        var params = {
            page : 1
        };
        
        var searchobject = {
            'hasNextPage': true,
            'data': []
        };
    
        function propertyquery(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            propertyresource.query(params, function (r) {

                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };

                $rootScope.$broadcast('focuspropertylist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
                $timeout(function () {
                    Utile.loadOrldSuccess();
                }, 500);
            });
        }
        function communityquery(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            communityresource.query(params, function (r) {
    
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
    
                $rootScope.$broadcast('focuspropertylist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
                $timeout(function () {
                    Utile.loadOrldSuccess();
                }, 500);
            });
        }
        function gpfyquery(){
        	var hasNextPage = searchobject.hasNextPage;
        	var portalsData = searchobject.data;
        	gpfyresource.query(params, function (r) {
        		
        		portalsData = portalsData.concat(r.list);
        		params.page++;
        		hasNextPage = !r.isover;
        		searchobject = {
        				'hasNextPage': hasNextPage,
        				'data': portalsData
        		};
        		
        		$rootScope.$broadcast('focuspropertylist.updated');
        		$rootScope.$broadcast('scroll.infiniteScrollComplete');
        		$timeout(function () {
        			Utile.loadOrldSuccess();
        		}, 500);
        	});
        }
        function rentquery(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            rentresource.query(params, function (r) {
    
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
    
                $rootScope.$broadcast('focuspropertylist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
                $timeout(function () {
                    Utile.loadOrldSuccess();
                }, 500);
            });
        }

        //资讯关注提交
        var submiturl= url.mem.doorder;
        var submitmsg = []; 
        var submitresource = $resource(submiturl,{
            save : {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        })
        function submit(list,linktype){
            var params = {
                uuid : localStorage.uuid,
                openid : localStorage.openid
            };
            if(list.length > 1){
                params.linkids = list.toString();
                params.linktypes = linktype.toString();
            }else{
                params.linkid = list.toString();
                params.linktype = linktype.toString();
            }

            submitresource.save(params,function(r) {
                submitmsg = r;
                $rootScope.$broadcast('submit.updated');
            })
        }

        return{
            //搜索
            search : function(info){
                if(info.page == 1){
                    params = info;
                    params.page = 1
                    searchobject.data = [];
                    searchobject.hasNextPage = true;
                }
                if(info.linktype == 1){
                    propertyquery();
                }else if(info.linktype == 2){
                    communityquery();
                }else if (info.linktype == 4) {
                	gpfyquery();
                }else {
                	rentquery()
                }
            },
            getList : function() {
                return searchobject.data;
            },
            hasNextPage : function() {
                return searchobject.hasNextPage;
            },
            submit : function(list,linktype){
                submit(list,linktype);
            },
            getReturnMsg : function() {
                return submitmsg;
            }
        }
    })
    .factory('MemAddFocusFactory', function ($resource, $rootScope, url) {
    	var memorderUrl =  url.mem.doOrder;
    	 var submiAddfocus = $resource(memorderUrl,{
             save : {
                 method: 'post',
                 cache: true,
                 timeout: 20000
             }
         });
    	 
    	var returnMsg;
    	return {
    		saveMemOrder:function (linkid, linktype){
    			var params = {
	                uuid : localStorage.uuid,
	                openid : localStorage.openid,
	                linkid:linkid,
	                linktype:linktype
	            };
    			submiAddfocus.save(params,function(r) {
    				returnMsg = r;
                    $rootScope.$broadcast('addFocusSubmit.complete');
                });
    		},
    		getAddFocusReturnMsg:function (){
    			return returnMsg;
    		}
    	}
    })
 ;
