angular.module('tmjia.services.gpfy', [])
	.factory('gpfySettingsFactory', function ($resource, $rootScope) {
		var gpxxlistsettings = new Object();
		// 距离列表
		var distancelist = [
			{value: 0, name: '不限'},
			{value: 0.5, name: '500米以内'},
			{value: 1, name: '1000米以内'},
			{value: 2, name: '2000米以内'},
			{value: 3, name: '3000米以内'}
		];
		// 城区列表
		var arealist = [
			{value: 33, name: '不限'},
	        {value: '320506', name: '吴中区'},
	        {value: '320507', name: '相城区'},
	        {value: '320508', name: '姑苏区'},
	        {value: '320509', name: '吴江区'},
	        {value: '320571', name: '工业园区'},
	        {value: '320591', name: '高新区'},
	        {value: '320581', name: '常熟市'},
	        {value: '320582', name: '张家港市'},
	        {value: '320583', name: '昆山市'},
	        {value: '320585', name: '太仓市'}
		];
		gpxxlistsettings.area = {
			distancelist: distancelist,
			arealist: arealist
		};
		// 价格列表
		gpxxlistsettings.pricelist = [
			{value: '', name: '不限'},
			{value: '0_50', name: '50万以下'},
			{value: '50_80', name: '50-80万'},
			{value: '80_100', name: '80-100万'},
			{value: '100_120', name: '100-120万'},
			{value: '120_150', name: '120-150万'},
			{value: '150_200', name: '150-200万'},
			{value: '200_250', name: '200-250万'},
			{value: '250_300', name: '250-300万'},
			{value: '300_99999', name: '300万以上'}
		];
		// 户型
		gpxxlistsettings.hxslist = [
			{value: '', name: '不限'},
			{value: 1, name: '一室'},
			{value: 2, name: '二室'},
			{value: 3, name: '三室'},
			{value: 4, name: '四室'},
			{value: 5, name: '五室'},
			{value: 6, name: '五室以上'}
		];
		//更多筛选,面积
		var jzmjlist = [
			{value: '', name: '不限'},
			{value: '0_50', name: '50以下'},
			{value: '50_70', name: '50-70'},
			{value: '70_90', name: '70-90'},
			{value: '90_110', name: '90-110'},
			{value: '110_130', name: '110-130'},
			{value: '130_150', name: '130-150'},
			{value: '150_200', name: '150-200'},
			{value: '200_999', name: '200以上'}
		];
		// 更多 类型
		var fwytlist = [
			{value: '', name: '不限'},
			{value: '10', name: '住宅'},
			{value: '11', name: '非住宅'}
		];
		// 更多 装修程度
		var zxbzlist = [
			{value: '', name: '不限'},
			{value: '4', name: '豪华装修'},
			{value: '3', name: '精装修'},
			{value: '2', name: '普通装修'},
			{value: '3200', name: '简单装修'},
			{value: '1', name: '毛坯'}
		];
		// 更多 楼层
		var szlclist = [
			{value: '', name: '不限'},
			{value: '3', name: '高层'},
			{value: '2', name: '中层'},
			{value: '1', name: '低层'}
		];
		// 更多 房龄
		var fanglinglist = [
			{value: '', name: '不限'},
			{value: '0_2', name: '2年内'},
			{value: '2_5', name: '2-5年'},
			{value: '5_10', name: '5-10年'},
			{value: '10_999', name: '10年以上'}
		];
		var teselist = [
			{value: '', name: '不限'},
			{value: '1', name: '地铁房'},
			{value: '2', name: '学区房'},
			{value: '3', name: '推荐房'},
			{value: '4', name: '免税房'}
		];
		gpxxlistsettings.more = {
			jzmjlist: jzmjlist,
			fwytlist: fwytlist,
			zxbzlist: zxbzlist,
			szlclist: szlclist,
			fanglinglist: fanglinglist,
			teselist: teselist
		};
		gpxxlistsettings.orderbylist = [
			{value: '1', name: '新上房源'},
			{value: '2', name: '涨价房源'},
			{value: '3', name: '降价房源'},
			{value: '4', name: '总价由高到低'},
			{value: '5', name: '总价由低到高'},
			{value: '6', name: '单价由高到低'},
			{value: '7', name: '单价由低到高'},
			{value: '8', name: '面积由大到小'},
			{value: '9', name: '面积由小到大'}
		];
		return {
			gpxxlistsettings: function () {
				return gpxxlistsettings;
			},
			xqgpxxlistsettings: function () {
				return {
					pricelist: gpxxlistsettings.pricelist,
					hxslist: gpxxlistsettings.hxslist,
					jzmjlist: gpxxlistsettings.more.jzmjlist,
					orderbylist: gpxxlistsettings.orderbylist
				}
			},
			isnewgpfy: function (hysj) {
				if (typeof (hysj) == 'undefined') {
					return false;
				}
				//计算天数差的函数，通用
				var  oDate1, oDate2, iDays;
				if (hysj.split(' ').length > 1) {
					oDate1  =  new  Date(hysj.split(' ')[0]);
				} else {
					oDate1  =  new  Date(hysj);
				}
				oDate2  =  new  Date();
				iDays  =  parseInt(Math.abs(oDate1  -  oDate2)  /  1000  /  60  /  60  /24);    //把相差的毫秒数转换为天数
				return  iDays <= 7;
			}
		}
	})
;
