angular.module('tmjia.services', [])
	.factory('AppUpdateFactory', function ($resource, $rootScope, url) {
		var appversionUrl = url.versionurl + url.hourcache;
		var appversionlistUrl = url.versionlisturl + url.hourcache;
		var resource = $resource(appversionUrl, {}, {
			query: {
				method: 'get',
				cache: true,
				timeout: 10000
			}
		});
		var listresource = $resource(appversionlistUrl, {}, {
			query: {
				method: 'get',
				cache: true,
				timeout: 10000,
				isArray: true
			}
		});

		var appversion;
		var appversionlist;
		return {
			loadVersionInfo:function (){
				resource.query({json: 'true'},
					function (r) {
						appversion = r;
						$rootScope.$broadcast('loadVersionInfo.complete');
					},
					function (){
						$rootScope.alert('网络有点慢，请稍后再试！');
					}
				);
			},
			getVersionInfo:function(){
				return appversion;
			},
			loadVersionList:function (){
				listresource.query({json: 'true'},
					function (r) {
						appversionlist = r;
						$rootScope.$broadcast('loadVersionlist.complete');
					}
				);
			},
			getVersionList:function(){
				return appversionlist;
			}
		}
	})

	.factory('HandlelogFactory', function ($resource, $rootScope, $timeout, url) {
		var handlelogurl = url.tmj.handlelog;
		var logfile;
		function log () {
			if ($rootScope.Bposition) {
				$resource(handlelogurl, {}, {
					save: {
						method: 'post',
						cache: true,
						timeout: 20000
					}
				}).save({
					handlelog_handlelogid: sessionStorage.handlelogid || '',
					handlelog_lng: $rootScope.Bposition.x,
					handlelog_lat: $rootScope.Bposition.y,
					handlelog_uuid: localStorage.uuid
				}, function (r) {
					logfile = r;
					if (r.flag) {
						sessionStorage.handlelogid = r.handlelogid;
					}
					$rootScope.$broadcast('handlelog.complete');
				});
			}
		}
		function delaylog() {
			if((typeof(sessionStorage.handlelogid) == 'undefined' || sessionStorage.handlelogid == '') && typeof($rootScope.Bposition) != 'undefined') {
				log();
			} else {
				$timeout(delaylog, 1000);
			}
		}
		return {
			log: log,
			delaylog: delaylog,
			loadlog: function () {
				return logfile;
			}
		}
	})
	//广告位
	.factory('AdFactory', function ($resource, $rootScope,$timeout, url) {
		var welcomeurl = url.tmj.welcome;
		var indexadurl = url.tmj.indexad + url.hourcache;
		var ad, topad, dayad;
		var url = '';
		return {
			welcome: function () {
				$resource(welcomeurl, {}, {
					query: {
						method: 'get',
						cache: true,
						timeout: 10000
					}
				}).query({json: 'true'},
					function (r) {
						url = r;
						$rootScope.$broadcast('welcome.complete');
					},
					function (){
						$rootScope.$broadcast('welcome.complete');
					}
				);
			},
			loadAd: function (id) {

				$resource(indexadurl, {}, {query: {cache: true, isArray: true}}).query({
					adtypeid: id,
					a: 33,
					json: true
				}, function (r) {
						ad = r;
						$rootScope.$broadcast('ad.updated');
				}, function (e) {
					$rootScope.alert('加载失败!');
				});
			},
			loadTopAd: function (id) {
				$resource(indexadurl, {}, {query: {cache: true, isArray: true}}).query({
					adtypeid: id,
					a: 33,
					json: true
				}, function (r) {
					topad = r;
					$rootScope.$broadcast('topad.updated');
				});
			},
			//新房改版后顶部广告
			loadPropertyTopAd: function (id) {
				$resource(indexadurl, {}, {query: {cache: true, isArray: true}}).query({
					adtypeid: id,
					a: 33,
					json: true
				}, function (r) {
					propertytopad = r;
					$rootScope.$broadcast('property.topad.updated');
				});
			},
			loadDayAd: function () {
				$resource(indexadurl, {}, {query: {cache: true, isArray: true}}).query({
					adtypeid: 99907,
					a: 33,
					json: true
				}, function (r) {
					dayad = r;
					$rootScope.$broadcast('dayad.updated');
				});
			},
			getAd: function() {
				return ad;
			},
			getDayAd: function() {
				return dayad;
			},
			getTopAd: function() {
				return topad;
			},
			//新房改版后顶部广告
			getPropertyTopAd: function() {
				return propertytopad;
			},
			welcomeurl: function () {
				return url;
			}
		}
	})

	.factory('HomeFactory', function ($resource, $rootScope, url) {
		var dayhoturl = url.tmj.dayhot + url.hourcache;
		var tagurl = url.tmj.tagproperty + url.daycache;
		var versionurl = url.versionurl;
		var dayhot, hotproperty,websitechange;

		var resource = $resource(tagurl, {}, {
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});
		var websitechangeResource = $resource(versionurl, {}, {
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});
		return {
			loadDayhot: function () {
				$resource(dayhoturl, {}, {query: {cache: true, isArray: true}}).query({ver: 416, json: 'true'}, function (r) {
					dayhot = r;
					$rootScope.$broadcast('homedayhot.updated');
				});
			},
			loadTagproperty: function () {
				resource.query({json: 'true'}, function (r) {

					hotproperty = r.hotproperty;
					$rootScope.$broadcast('hometag.updated');
				});
			},
			loadWebsitechange: function () {
				websitechangeResource.query({},function (r) {
					websitechange = r;
					$rootScope.$broadcast('websitechange.updated');
				});
			},
			getWebsitechange: function() {
				return websitechange;
			},
			getDayhot: function () {
				return dayhot;
			},
			getTagproperty: function () {
				return hotproperty;
			}
		};
	})

	.factory('MapFactory', function ($rootScope, $timeout) {
		var map;

		var arealist;
		var is_show_marker = false;
		var recordproperty = false;
		var isareaclick = false;

		// 定义自定义覆盖物的构造函数
		function PropertyOverlay(center, title, linktype, linkid, sid, cscount, stateid, price) {
			this._center = center;
			this._height = 30;
			this._width = 90;
			this._title = title;
			this._linktype = linktype;
			this._linkid = linkid;
			this._sid = sid;
			this._cscount = cscount;
			this._stateid = stateid;
			this._state = '';
			this._price = price;
			if (this._stateid == 1) {
				this._state = '在售'; // 打折
			} else if (this._stateid == 2) {
				this._state = '在售';
			} else if (this._stateid == 3) {
				this._state = '尾盘';
			} else if (this._stateid == 4) {
				this._state = '售完';
			} else if (this._stateid == 5) {
				this._state = '待售';
			}
		}

		// 继承API的BMap.Overlay
		PropertyOverlay.prototype = new BMap.Overlay();
		//实现初始化方法
		PropertyOverlay.prototype.initialize = function (map) {
			// 保存map对象实例
			this._map = map;
			// 创建div元素，作为自定义覆盖物的容器
			var div = document.createElement("div");
			var css = '';
			var html = '';
			if (this._linktype == 1) {
				if (recordproperty) {
					css = 'tm-mapcode-lp3';
				} else if (this._stateid == 1 || this._stateid == 2) {
					css = 'tm-mapcode-lp5';
				} else if (this._stateid == 3 || this._stateid == 4) {
					css = 'tm-mapcode-lp7';
				} else if (this._stateid == 5) {
					css = 'tm-mapcode-lp6';
				} else {
					css = 'tm-mapcode-lp3';
				}
				html = '<div class="light text-left">' + this._title + '   ' + this._state + '</div>';
			} else {
				css = 'tm-mapcode-lp3';
				var price = '';
				if (this._price > 0) {
					if (this._price > 10000) {
						price = ' ' + parseInt(this._price / 1000) / 10 + '万';
					} else {
						price = ' ' + parseInt(this._price);
					}
				}
				html = '<div class="light text-left">' + this._title + price + (this._cscount ? ' | ' + this._cscount + '套</div>' : '</div>');
			}
			angular.element(div).addClass(css).html(html);
			div.style.position = "absolute";
			// 可以根据参数设置元素外观
			//div.style.height = this._height + "px";
			// 将div添加到覆盖物容器中
			map.getPanes().markerPane.appendChild(div);
			// 绑定点击事件
			var map_property = {
				linktype: this._linktype,
				linkid: this._linkid,
				sid: this._sid
			};
			div['ontouchstart'] = function () {
				//window.location.href = href;
				$rootScope.map_property = map_property;
				$rootScope.$broadcast('map.property.showproperty');
			};
			// 保存div实例
			this._div = div;
			// 需要将div元素作为方法的返回值，当调用该覆盖物的show、
			// hide方法，或者对覆盖物进行移除时，API都将操作此元素。
			return div;
		};

		//实现绘制方法
		PropertyOverlay.prototype.draw = function () {
			// 根据地理坐标转换为像素坐标，并设置给容器
			var position = this._map.pointToOverlayPixel(this._center);
			this._div.style.left = position.x - this._width / 2 + "px";
			this._div.style.top = position.y - this._height / 2 + "px";
		};
		//实现显示方法
		PropertyOverlay.prototype.show = function () {
			if (this._div) {
				this._div.style.display = "";
			}
		};
		// 实现隐藏方法
		PropertyOverlay.prototype.hide = function () {
			if (this._div) {
				this._div.style.display = "none";
			}
		};
		//定义自定义覆盖物的构造函数
		function AreaOverlay(center, title, count, linktype){
			this._center = center;
			this._height = 66;
			this._width = 66;
			this._title = title;
			this._count = count;
			this._linktype = linktype || 1;
		}

		//继承API的BMap.Overlay
		AreaOverlay.prototype = new BMap.Overlay();
		//实现初始化方法
		AreaOverlay.prototype.initialize = function (map) {
			// 保存map对象实例
			this._map = map;
			// 创建div元素，作为自定义覆盖物的容器
			var div = document.createElement("div");
			var divcontent = '';
			var linktypename = '';
			if (this._linktype == 1) {
				linktypename = '楼盘';
			} else {
				linktypename = '小区';
			}
			divcontent = '<div class="tm-mapcode-con" newcode="" projname="' + this._title + '">'
				+ '<div class="tm-mapcode-district4">'
				+ '<div class="tm-f10">' + (this._title || 0) + '</div>'
				+ '<div class="tm-f8">' + this._count+ '个' + linktypename + '</div>'
				+ '</div>'
				+ '</div>';
			angular.element(div).addClass('tm-mapcode-con').html(divcontent);
			div.style.position = "absolute";
			// 可以根据参数设置元素外观
			div.style.width = this._width + "px";
			div.style.height = this._height + "px";
			div.setAttribute("class", "tm-mapcode-con");
			// 将div添加到覆盖物容器中
			map.getPanes().markerPane.appendChild(div);

			var point = this._center;
			div['ontouchstart'] = function () {
				$timeout(function () {
					if (isareaclick) {
						var zoom = map.getZoom();
						if (zoom <= 12) {
							map.centerAndZoom(point, 14);
						} else if (zoom <= 14) {
							map.centerAndZoom(point, 16);
						}
					}
				}, 100);
			};
			// 保存div实例
			this._div = div;
			// 需要将div元素作为方法的返回值，当调用该覆盖物的show、
			// hide方法，或者对覆盖物进行移除时，API都将操作此元素。
			return div;
		};

		//实现绘制方法
		AreaOverlay.prototype.draw = function () {
			// 根据地理坐标转换为像素坐标，并设置给容器
			var position = this._map.pointToOverlayPixel(this._center);
			this._div.style.left = position.x - this._width / 2 + "px";
			this._div.style.top = position.y - this._height / 2 + "px";
		};
		//实现显示方法
		AreaOverlay.prototype.show = function () {
			if (this._div) {
				this._div.style.display = "";
			}
		};
		// 实现隐藏方法
		AreaOverlay.prototype.hide = function () {
			if (this._div) {
				this._div.style.display = "none";
			}
		};
		//定义自定义覆盖物的构造函数
		function PropertyDetailOverlay(center, title, linkurl){
			this._center = center;
			this._height = 22;
			this._width = 66;
			this._title = title;
			this._linkurl = linkurl;
		}

		//继承API的BMap.Overlay
		PropertyDetailOverlay.prototype = new BMap.Overlay();
		//实现初始化方法
		PropertyDetailOverlay.prototype.initialize = function (map) {
			// 保存map对象实例
			this._map = map;
			// 创建div元素，作为自定义覆盖物的容器
			var div = document.createElement("div");
			divcontent = '<a href="' + this._linkurl + '">'
							+ '<div class="tm-lh20 tm-border-radius2" style="background: rgba(0,0,0,0.6);white-space: nowrap;padding: 1px 8px;color: #e1e5e0;">'
							+ this._title
							+ '</div></a>';
			angular.element(div).addClass('tm-mapcode-con').html(divcontent);
			div.style.position = "absolute";
			// 可以根据参数设置元素外观
			//div.style.width = this._width + "px";
			div.style.height = this._height + "px";
			div.setAttribute("class", "tm-mapcode-con");
			// 将div添加到覆盖物容器中
			map.getPanes().markerPane.appendChild(div);

			var point = this._center;
			// 保存div实例
			this._div = div;
			// 需要将div元素作为方法的返回值，当调用该覆盖物的show、
			// hide方法，或者对覆盖物进行移除时，API都将操作此元素。
			return div;
		};

		//实现绘制方法
		PropertyDetailOverlay.prototype.draw = function () {
			// 根据地理坐标转换为像素坐标，并设置给容器
			var position = this._map.pointToOverlayPixel(this._center);
			this._div.style.left = position.x - (this._title.length + 1) * 12 / 2 + "px";
			this._div.style.top = position.y - this._height / 2 - 25 + "px";
		};
		//实现显示方法
		PropertyDetailOverlay.prototype.show = function () {
			if (this._div) {
				this._div.style.display = "";
			}
		};
		// 实现隐藏方法
		PropertyDetailOverlay.prototype.hide = function () {
			if (this._div) {
				this._div.style.display = "none";
			}
		};
		function mapsearch(point, key, searchkeywordindex, mapsearchindex, success) {
			var circle = new BMap.Circle(point, 1000, {
				fillColor: "blue",
				strokeWeight: 1,
				fillOpacity: 0.3,
				strokeOpacity: 0.3
			});
			//map.clearOverlays();
			//map.addOverlay(circle);
			// 定义搜索关键词 (多关键词搜索)
			var myKeys = [key];
			//检索结束后的回调函数
			var options = {
				pageCapacity: 9,
				renderOptions: {
					map: map
				},
				onSearchComplete: function (results) {
					var a = results[0].getNumPois();
					if (a > 3) {
						a = 3;
					}
					var str = '';
					for (var i = 0; i < a; i++) {
						var title1 = results[0].getPoi(i).title;
						var title = title1;
						if (title.length > 17) {
							title = title.substr(0, 17);
						}
						var point1 = results[0].getPoi(i).point;
						var dis = map.getDistance(point, point1) / 1000;
						//str += '<li class="am-text-center"><span class="tm-askbtn">' + title + '</span><span class="tm-askbtn tm-text-muted">距离：' + dis.toFixed(2) + 'km</span></li>';
						if (str != '') {
							str += ',';
						}
						str += title;
					}
					if (typeof (success) == 'function') {
						success(searchkeywordindex, mapsearchindex, str);
					}
				}
			};
			// renderOptions: 搜索结果, 地图于map实例显示，列表在 r-result显示

			var local = new BMap.LocalSearch(map, options);
			local.disableFirstResultSelection();
			var bounds = getSquareBounds(circle.getCenter(), circle.getRadius());
			local.searchInBounds(myKeys, bounds);

		};
		function mapsearchonly(key) {
			map.clearOverlays();
			// 定义搜索关键词 (多关键词搜索)
			var myKeys = [ key ];
			//检索结束后的回调函数
			var options = {
				pageCapacity : 9,
				renderOptions : {
					map : map
				},
				onSearchComplete : function(results) {
					var a = results[0].getNumPois();
					if (a == 0){
						$rootScope.alert('该范围内没有此类配套设施，请缩小地图后再次进行搜索！');
					}
					if (a > 3) {
						a = 3;
					}
					var str = '';
					for (var i = 0; i < a; i++) {
						var title1 = results[0].getPoi(i).title;
						var title = title1;
						if (title.length > 17) {
							title = title.substr(0, 17);
						}
						var point1 = results[0].getPoi(i).point;
						var marker = new BMap.Marker(point1); // 创建标注
						map.addOverlay(marker);
						//var dis = map.getDistance(point, point1) / 1000;
					}

				}
				// renderOptions: 搜索结果, 地图于map实例显示，列表在 r-result显示
			};
			var local = new BMap.LocalSearch(map, options);
			local.disableFirstResultSelection();
			local.searchInBounds(myKeys, map.getBounds());
		}

		function mapsearchNearby(keyword) {
			map.clearOverlays();
			var local = new BMap.LocalSearch(map, {renderOptions: {map: map}});
			local.searchNearby(keyword.split(','), map.getCenter());
			defaultPoint();
		}
		function loadmap(area_list, linktype) {
			if (typeof (map) != 'undefined') {
				if (area_list) {
					arealist = area_list;
				}
				map.clearOverlays();
				var obj;
				var areaOverlay;
				for (i in arealist) {
					obj = arealist[i];
					if (obj.gisx && obj.gisy) {
						point = new BMap.Point(obj.gisx, obj.gisy); // 创建点坐标
						var areaOverlay = new AreaOverlay(point, obj.title || obj.areaname, obj.number_, linktype);
						map.addOverlay(areaOverlay);
					}
				}
				defaultPoint();
			}
		}

		function loadmapProperty(propertylist, linktype) {
			if (typeof (map) != 'undefined') {
				var obj;
				var propertyOverlay;
				var overlays = map.getOverlays();
				for (i in overlays) {
					if (overlays[i]._linkid) {
						var isnothere = true;
						for (j in propertylist.list) {
							if (overlays[i]._linkid == propertylist.list[j].propertyid && overlays[i]._siteid == propertylist.list[j].siteid) {
								isnothere = false;
								break;
							}
							if (overlays[i]._linkid == propertylist.list[j].communityid && overlays[i]._linktype == linktype) {
								isnothere = false;
								break;
							}
						}
						if (isnothere) {
							map.removeOverlay(overlays[i--]);
						}
					} else if(overlays[i]._title) {
						map.removeOverlay(overlays[i--]);
					}
				}
				for (i in propertylist.list) {
					obj = propertylist.list[i];
					var overlays = map.getOverlays();
					var isnothere = true;
					for (j in overlays) {
						var overlay = overlays[j];
						if (overlay._linkid) {
							if (overlay._linkid == obj.propertyid && overlay._siteid == obj.siteid) {
								isnothere = false;
								break;
							}
							if (overlay._linkid == obj.communityid && overlays[i]._linktype == linktype) {
								isnothere = false;
								break;
							}
						}
					}
					if (isnothere && obj.prjx && obj.prjy) {
						point = new BMap.Point(obj.prjx, obj.prjy); // 创建点坐标
						// PropertyOverlay(center, title, linktype, linkid, sid, cscount, stateid, price)
						if (linktype == 1) {
							propertyOverlay = new PropertyOverlay(point, obj.propertyname, linktype, obj.propertyid, obj.siteid || 33, 0, obj.propertystateid || 2);
						} else {
							propertyOverlay = new PropertyOverlay(point, obj.communityname, linktype, obj.communityid, 33, (linktype == 2 ? obj.cscount : obj.czcount) || 0, 2, obj.syprice);
						}
						map.addOverlay(propertyOverlay);
					}
				}
				//defaultPoint();
			}
		}

		function defaultPoint() {
	        var p = new BMap.Point($rootScope.Bposition.x || 120.714393, $rootScope.Bposition.y || 31.351191); // 创建点坐标
			// 显示当前点  所以不进行定位操作
			//map.panTo(p); // 初始化地图，设置中心点坐标和地图级别
			if (is_show_marker) {
				var positionIcon = new BMap.Icon("http://webmap2.map.bdstatic.com/wolfman/static/common/images/ipLocation/ipLocation_ac75181.png", new BMap.Size(14,14));
				var marker = new BMap.Marker(p, {icon:positionIcon}); // 创建标注
				map.addOverlay(marker); // 将标注添加到地图中
			}
		}
		/**
		 * 得到圆的内接正方形bounds
		 *
		 * @param {Point}
		 *			centerPoi 圆形范围的圆心
		 * @param {Number}
		 *			r 圆形范围的半径
		 * @return 无返回值
		 */
		function getSquareBounds(centerPoi, r) {
			var a = Math.sqrt(2) * r; // 正方形边长

			mPoi = getMecator(centerPoi);
			var x0 = mPoi.x, y0 = mPoi.y;

			var x1 = x0 + a / 2, y1 = y0 + a / 2;// 东北点
			var x2 = x0 - a / 2, y2 = y0 - a / 2;// 西南点

			var ne = getPoi(new BMap.Pixel(x1, y1)), sw = getPoi(new BMap.Pixel(x2, y2));
			return new BMap.Bounds(sw, ne);

		}

		// 根据球面坐标获得平面坐标。
		function getMecator(poi) {
			return map.getMapType().getProjection().lngLatToPoint(poi);
		}

		// 根据平面坐标获得球面坐标。
		function getPoi(mecator) {
			return map.getMapType().getProjection().pointToLngLat(mecator);
		}

		function init(can, ismove) {
			map = new BMap.Map(can || 'container',{vectorMapLevel:99});
			var mapStyle={style:"googlelite"};
			map.setMapStyle(mapStyle);
			if (ismove == false) {
				map.disableDragging();
	        	map.disablePinchToZoom();
			}
			if (typeof (map) != 'undefined') {
				var p = defaultposition();
				map.centerAndZoom(new BMap.Point(p.x, p.y), 12); // 杭州中心点位置
			} else {
				//console.log('map is undefined');
			}
		}

		function zoomControl(can, ismove) {
			// map = new BMap.Map(can || 'container');
			init(can, ismove);
			map.addControl(new BMap.NavigationControl());
		}
		function defaultposition() {
			if (localStorage.position) {
				return JSON.parse(localStorage.position);
			} else {
				return {x: 120.5916941890,y: 31.3053856841};
			}
		}
		function centerAndZoom(point) {
			var mappoint = new BMap.Point(point.prjx, point.prjy); // 创建点坐标
			map.centerAndZoom(mappoint, 15); // 初始化地图，设置中心点坐标和地图级别
		}
		function centerAndZoomAndMarker(point) {
			var mappoint = new BMap.Point(point.prjx, point.prjy); // 创建点坐标
			map.centerAndZoom(mappoint, 15); // 初始化地图，设置中心点坐标和地图级别
			var myIcon = new BMap.Icon("images/tm-weizhi0514.png", new BMap.Size(20, 24));
			var marker = new BMap.Marker(mappoint, {icon:myIcon});
			map.addOverlay(marker);
			console.log(myIcon);
			if (typeof point.propertyid != 'undefined') {
				var linkurl = '#/property/propertymap/' + point.propertyid + '/' + point.siteid;
				var propertydetailOverlay = new PropertyDetailOverlay(mappoint, point.propertyname, linkurl);
				map.addOverlay(propertydetailOverlay);
			} else if (typeof point.communityid != 'undefined') {
				var linkurl = '#/property/communitymap/2/' + point.communityid;
				var propertydetailOverlay = new PropertyDetailOverlay(mappoint, point.communityname, linkurl);
				map.addOverlay(propertydetailOverlay);
			}
		}
		return {
			observer: function ($scope) {
				$scope.$watch('arealist', function (newValue, oldValue) {
					arealist = newValue;
					loadmap();
				});
			},
			getmap: function () {
				return map;
			},
			setmap: function (scrollmap) {
			  map = scrollmap;
			},
			setIsShowMarker: function (flag) {
				is_show_marker = flag;
			},
			panToPoint: function () {
		        var p = new BMap.Point($rootScope.Bposition.x || 120.714393, $rootScope.Bposition.y || 31.351191); // 创建点坐标
				map.panTo(p);
			},
			setRecordproperty: function (r) {
				recordproperty = r;
			},
			setIsareaclick: function (c) {
				isareaclick = c;
			},
			init: init,
			zoomControl: zoomControl,
			loadmap: loadmap,
			loadmapProperty: loadmapProperty,
			centerAndZoomAndMarker: centerAndZoomAndMarker,
			centerAndZoom: centerAndZoom,
			mapsearch: mapsearch,
			mapsearchonly: mapsearchonly,
			mapsearchNearby: mapsearchNearby
		}
	})
	.factory('mediaFactory', function () {
		var _player = '';
		function init(url, elementname) {
			var mediaDataSource = {
				type: 'mp4',
				url : url
			};
			var element = document.getElementsByName(elementname || 'videoElement')[0];
			if (typeof _player !== "undefined") {
				if (_player != '') {
					_player.unload();
					_player.detachMediaElement();
					_player.destroy();
					_player = '';
				}
			}
			_player = flvjs.createPlayer(mediaDataSource, {
				enableWorker: false,
				lazyLoadMaxDuration: 3 * 60,
				seekType: 'range',
				deferLoadAfterSourceOpen: false
			});
			_player.attachMediaElement(element);
			_player.load();
		}
		return {
			player: function (url, elementname) {
				init(url, elementname);
				return _player;
//				return {
//					paused : _player,
//					duration : _player.duration,
//					currentTime : _player.currentTime,
//					play : function () {
//						_player.play();
//					},
//					pause : function () {
//						_player.pause();
//					},
//					destory: function () {
//						_player.pause();
//						_player.unload();
//						_player.detachMediaElement();
//						_player.destroy();
//						_player = null;
//					}
//				};
			}
		}
	})
	.factory('ContactFactory', function ($resource, $rootScope, $ionicPlatform) {
		var contactlist = new Array();
		return {
			loadContact: function () {
				$ionicPlatform.ready(function () {
					if (navigator.contactsPhoneNumbers) {
						contactlist = new Array();
						navigator.contactsPhoneNumbers.list(function(contacts) {
							for(var i = 0; i < contacts.length; i++) {
								//console.log(contacts[i].id + " - " + contacts[i].displayName);
								var displayName = contacts[i].displayName;
								if (typeof(cordova) != 'undefined' && device.platform == 'iOS') {
									displayName = contacts[i].lastName + contacts[i].middleName + contacts[i].firstName;
								}
								for(var j = 0; j < contacts[i].phoneNumbers.length; j++) {
									var phone = contacts[i].phoneNumbers[j];
									//console.log("===> " + phone.type + "  " + phone.number + " (" + phone.normalizedNumber+ ")");
									contactlist.push({
										name: displayName,
										usermobile: phone.number
									})
								}
							}
							$rootScope.$broadcast('contact.loaded');
						}, function(error) {
							if ('User has denied permission' == error || 'unauthorized' == error) {
								$rootScope.alert('您尚未授权访问通讯录，请授权后再操作或自行录入。');
							} else {
								alert(error);
							}
						});
					}
				});
			},
			getContact: function () {
				return contactlist;
			}
		}
	})
	.factory('CommonFactory', function($ionicLoading, $rootScope, $timeout, $q) {
		return {
			// 判断当天是否加载过
			isTodayLoaded: function(key) {
				if (!key) return false;
				var lastDate = localStorage.getItem(key);
				var now = new Date();
				var nowY = now.getFullYear(), nowM = now.getMonth(), nowD = now.getDate();
				localStorage.setItem(key, nowY + '-' + nowM + '-' + nowD);
				if (lastDate) {
					var dates = lastDate.split('-');
					return dates[0] == nowY && dates[1] == nowM && dates[2] == nowD;
				}
				return false;
			},
			// 安装下载app
			uploadAppAndroid: function(url) {
				$ionicLoading.show({
					template: "已经下载：0%"
				});
				var path = cordova.file.documentsDirectory || cordova.file.externalDataDirectory || cordova.file.externalRootDirectory || cordova.dataDirectory;
				var targetPath = path + "tmjia.apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
				var trustHosts = true;
				var options = {};
				var fileTransfer = new FileTransfer();
				$cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
					// 打开下载下来的APP
					$cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function () {
						// 成功
					}, function (err) {
						// 错误
					});
					$ionicLoading.hide();
				}, function (err) {
					$rootScope.alert('下载失败');
					$ionicLoading.hide();
				}, function (progress) {
					//进度，这里使用文字显示下载百分比
					$timeout(function () {
						var downloadProgress = (progress.loaded / progress.total) * 100;
						$ionicLoading.show({
							template: "已经下载：" + Math.floor(downloadProgress) + "%"
						});
						if (downloadProgress > 99) {
							$ionicLoading.hide();
						}
					})
				});
			},
			// 创建标签
			createTagList: function(list) {
        		for (var i = 0; i < list.length; i++) {
					list[i].metrolist = [];
					if (list[i].metro) {
						var metrolist = list[i].metro.split(',');
						for (var x = 0; x < metrolist.length; x++) {
							var metro = metrolist[x].split(' ')[0];
							var iscf = false;
							for (var j = 0; j < list[i].metrolist.length; j++) {
								if (metro == list[i].metrolist[j]) {
									iscf = true;
									break;
								}
							}
							!iscf && list[i].metrolist.push(metro);
						}
					}
				}
        	},
			/**
			 * 搜索页通过关键字生成string
			 * @param info 需要判断的那条数据
			 * @param kw 关键字
			 * @param key 根据info里的key去和kw对比
			 */
			buildStr: function(info, kw, key) {
				var str = '', py = '', py2 = '';
				var temp = info[key].split(kw);
				py = info.py.split(kw);
				py2 = info.py2.split(kw);
				// 汉字匹配
				if (temp.length > 1) {
					for (var j = 0; j < temp.length; j++) {
						str += (j != 0 ? '<span class="blue01">' + kw + '</span>' : '') + temp[j];
					}
				// 拼音匹配
				} else if (py.length > 1 || py2.length > 1) {
					str = info[key];
				}
				return str;
			},
        	showLoading: function(text) {
        		$ionicLoading.show({
			      	template: '<div>' +
	                    '<div class="h20"></div>' +
	                    '<ion-spinner class="f_white" icon="ios"></ion-spinner>' +
	                    '<div>' + (text || '正在加载') + '</div>' +
	                '</div>'
			    });
        	},
        	hideLoading: function() {
        		$ionicLoading.hide();
        	},
			getEmptyPromise: function() {
				var defer = $q.defer();
                $timeout(defer.resolve, 0);
                return defer.promise;
			}
		};
	})
	/**
	 * 页面超时service
	 * 调用步骤:
	 * 1、调用init方法，创建一个超时的实例，并为scope._timeoutInstance赋值该实例
	 * TimeoutFactory.init($scope);
	 * 2、把需要在页面上显示超时的方法传入TimeoutFactory.currying中，如下方的loadSearchAdvInfo。
	 *   注意这个方法必须返回promise
	 * $scope.loadSearchAdvInfo = TimeoutFactory.currying(function() {
	 *    return IndexFactory.getAdvs(1166984818, 'hzf.jlgwsearch.ad.list').then(function(result) {
	 *		 $scope.adList = result;
	 *    });
	 * }, $scope);
	 * 3、在页面html中加入hzf-timeout标签
	 * <ion-view>...<ion-content></ion-content>...<hzf-timeout></hzf-timeout>...</ion-view>
	 */
	.factory('TimeoutFactory', function($rootScope, $timeout, CommonFactory, webswitch) {
		var TIMEOUT = 'hzf.timeout';
		var TIMEOUT_RELOAD = 'hzf.timeout.reload';

		function _hzfTimeout(scope) {
			this.list = [];
			this.scope = scope;
		}
		// 添加超时reload事件监听
		_hzfTimeout.prototype.addReloadListener = function() {
			var that = this;
			_addTimeoutReloadListener(this.scope, function() {
				while(that.list.length) {
					var item = that.list.pop();
					item.func.apply(that.scope, item.args);
				}
			});
		};
		// 添加超时函数
		_hzfTimeout.prototype.addTimeoutFunc = function(func, args) {
			this.list.push({
				func: func,
				args: args
			});
		};
		// func需要为promise
		_hzfTimeout.prototype.currying = function(func) {
			var that = this;
			return function inner() {
				var args = arguments;
				return func.apply(that.scope, args).catch(function(e) {
					console.log(e.status);
					// 500为服务器内部报错, 不应该给用户重新加载的提示
					// 403为服务器拒绝请求, 被拉小黑屋的提示, 所以也不给重新加载提示
					// 在网上设置开关, 开关开启时才打开提示, 否则不能加载就不能加载吧
					if (e.status != 500 && e.status != 403 && webswitch.timeoutlayer) {
						that.addTimeoutFunc(inner, args);
						CommonFactory.hideLoading();
						_broadcastTimeout();
					}
				});
			}
		};
		// 当前是否超时
		_hzfTimeout.prototype.isTimeout = function() {
			return !!this.list.length;
		}
		// 发送超时广播
		function _broadcastTimeout() {
			// 防止hzfTimeout标签还没加载好，就发送了广播
			$timeout(function() {
				$rootScope.$broadcast(TIMEOUT);
			}, 0)
		}
		// 监听超时重新加载广播
		function _addTimeoutReloadListener(scope, handler) {
			scope.$on(TIMEOUT_RELOAD, handler);
		}
		return {
			// 获取超时实例，并添加reload事件
			init: function(scope) {
				var _timeout = new _hzfTimeout(scope);
				_timeout.addReloadListener();
				scope._timeoutInstance = _timeout;
			},
			// 为ajax请求添加超时处理
			currying: function(func, scope) {
				return scope._timeoutInstance.currying(func);
			},
			// 监听超时广播
			addTimeoutListener: function(scope, func) {
				scope.$on(TIMEOUT, func);
			},
			// 发送超时广播
			broadcastTimeout: _broadcastTimeout,
			// 监听超时重新加载广播
			addTimeoutReloadListener: _addTimeoutReloadListener,
			// 发送超时后重新加载的事件
			broadcastTimeoutReload: function() {
				$rootScope.$broadcast(TIMEOUT_RELOAD);
			},
			// 发送超时广播，并把重载函数加入到list中
			// (handler: function, args: Array, scope)
			broadcastTimeoutAndAddHandler: function(handler, args, scope) {
				scope._timeoutInstance.addTimeoutFunc(handler, args);
				_broadcastTimeout();
			}
		};
	})
;
