/**
 * Created by cb on 2016/8/15.
 */
angular.module('tmjia.services.market', [])

    .factory('MarketIndexFactory', function ($resource, $rootScope, url) {
        //搜索地址
        var searchurl = url.marketing.index;
        var rewardurl = url.marketing.reward;

        //搜索数据结构
        var searchobject = {
            data : [],
            hasNextPage : true
        };
        var rewardlist;

        //搜索参数
        var params = {
            page : 1
        }

        //搜索实体
        var serachresource = $resource(searchurl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        //搜索实体
        var rewardresource = $resource(rewardurl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        //搜索方法
        function query(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            serachresource.query(params, function (r) {
                for(i in r.list){
                    if(r.list[i].rewardmoney > 0){
                        r.list[i].rewardcent = '元/套';
                    }else{
                        r.list[i].rewardmoney = (r.list[i].rewardcent*10).toFixed(2)
                        r.list[i].rewardcent = '‰/套';
                    }
                    if(r.list[i].bereward > 0){
                        r.list[i].berewardcent = '元/套';
                    }else{
                        r.list[i].bereward =  (r.list[i].berewardcent*10).toFixed(2)
                        r.list[i].berewardcent = '‰/套';
                    }
                }
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };

                $rootScope.$broadcast('marketrencommendlist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');

            });
        }

        return{
            //读取滑动奖励展示
            loadReward : function() {
                rewardresource.query(params,function(r) {
                    rewardlist = r;
                    $rootScope.$broadcast('reward.updated');
                })
            },
            getReward : function() {
                return rewardlist;
            },
            //读取列表
            loadList : function() {
                query();
            },

            //获得列表数据
            getList : function() {
                return searchobject.data;
            },
            //是否有下一页
            hasNextPage: function () {
                return searchobject.hasNextPage;
            },
            //刷新列表
            reloadList : function() {
                searchobject = {
                    data : '',
                    hasNextPage : true
                };

                params = {
                    page : 1
                };

                query();

            }
        }

    })
    .factory('MarketAddFactory', function ($resource, $rootScope, url) {
        //提交地址
        var submiturl = url.marketing.recommendsubmit;
        var ruleurl = url.marketing.rule;
        var msg;
        var rule;
        //提交数据结构
        var submitobject = {
            data : []
        };
        var ruleresource = $resource(ruleurl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        //提交实体
        var submitresource = $resource(submiturl,{},{
            save: {
                method: 'post',
                cache: true,
                timeout: 20000
            }
        });

        return{
            //读取规则
            loadRule : function() {
                ruleresource.query({},function(r) {
                    rule = r;
                    $rootScope.$broadcast('rule.updated');
                })
            },
            //获取规则
            getRule : function() {
                return rule;
            },
            //提交
            submit : function(info) {
                submitresource.save({
                    uuid : localStorage.uuid,
                    openid : localStorage.openid
                }, info,function(r) {
                    msg = r;
                    $rootScope.$broadcast('recommend.submitted');
                });
            },
            getMsg : function() {
                return msg;
            }
        }

    })
    .factory('MarketPropertyListFactory', function ($resource, $rootScope, url) {
        //搜索地址
        var searchurl = url.marketing.propertylist;

        //搜索数据结构
        var searchobject = {
            data : [],
            hasNextPage : false
        };

        //搜索参数
        var params = {
            json : true
        }

        //搜索实体
        var serachresource = $resource(searchurl,{},{
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        //搜索方法
        function query(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            serachresource.query(params, function (r) {
                
                portalsData = r;
                searchobject = {
                    'data': portalsData
                };

                $rootScope.$broadcast('MarketPropertyList.updated');

            });
        }

        return{
            //读取列表
            loadList : function() {
                query();
            },

            //获得列表数据
            getList : function() {
                return searchobject.data;
            }
        }

    })
    .factory('MarketRecommendListFactory', function ($resource, $rootScope, url) {
        //搜索地址
        var searchurl = url.marketing.recommendlist;

        //搜索数据结构
        var searchobject = {
            data: []
        };

        //搜索参数
        var params = {
            state: 20,
            uudi: localStorage.uuid,
            openid: localStorage.openid
        }

        //搜索实体
        var serachresource = $resource(searchurl, {}, {
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });

        //搜索方法
        function query() {
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            serachresource.query(params, function (r) {
                portalsData = r;
                searchobject = {
                    'data': portalsData
                };
                $rootScope.$broadcast('recommendlist.updated');

            });
        }

        return {
            //读取列表
            loadList: function () {
                query();
            },

            //获得列表数据
            getList: function () {
                return searchobject.data;
            }
        }
    })
    .factory('MarketRecommendDetailFactory', function ($resource, $rootScope, url) {
        var infourl = url.marketing.recommenddetail;

        var content = [];

        var inforesource = $resource(infourl, {}, {
            query:{
                method : 'get',
                cache : true,
                timeout : 20000
            }
        });

        function query(id) {
            inforesource.query({recordid : id},function(r) {
                content = r;
                $rootScope.$broadcast('askdetail.updated');
            });
        }

        return{
            loadInfo : function(id){
                query(id);
            },

            getInfo : function(){
                return content;
            }
        }
    })