/**
 * Created by cb on 2016/8/10.
 */
angular.module('tmjia.services.message', [])

    .factory('MessageIndexFactory', function ($resource, $rootScope, url) {
        var messagelisturl = url.message.list;
        var message = '';
        return {
            loadMessagelist: function () {
                $resource(messagelisturl, {}, {query: {method: 'get', timeout: 20000}}).query({
                    uuid: localStorage.uuid,
                    openid: localStorage.openid,
                    json: true
                }, function (response) {
                    message = response;
                    $rootScope.$broadcast('message.updated');
                });
            },
            getMessagelist: function () {
                return message;
            }
        }
    })
    .factory('MessageSystemFactory', function ($resource, $rootScope, url) {
        var readurl = url.message.readMyChat;
        var message;
        return {
            loadMessagelist: function () {
                $resource(readurl, {}, {query: {method: 'get', timeout: 20000}}).query({
                    uuid: localStorage.uuid,
                    openid: localStorage.openid,
                    followtype: 1,
                    json: true
                }, function (response) {
                    console.log(response);
                    if (response.flag) {
                        message = response.list.reverse();
                    } else {
                        message = [];
                    }
                    $rootScope.$broadcast('message.system.updated');
                });
            },
            getMessagelist: function () {
                return message;
            }
        }
    })
    .factory('MessageGuessFactory', function ($resource, $rootScope, url) {
        var guesspropertyurl = url.guess.property + url.daycache;
        var guesscommunityurl = url.guess.community + url.daycache;
        var guesshouseurl = url.guess.house + url.daycache;
        var guesspropertylist, guesscommunitylist, guesshouselist;
        function guessproperty() {
            $resource(guesspropertyurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesspropertylist = response.list;
                guesscommunity();
            });
        }
        function guesscommunity() {
            $resource(guesscommunityurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesscommunitylist = response.list;
                guesshouse();
            });
        }
        function guesshouse() {
            $resource(guesshouseurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesshouselist = response.list;
                $rootScope.$broadcast('guess.updated');
            });
        }
        return {
            loadGuess: function () {
                guessproperty();
            },
            getGuessProperty: function () {
                return guesspropertylist;
            },
            getGuessCommunity: function () {
                return guesscommunitylist;
            },
            getGuessHouse: function () {
                return guesshouselist;
            }
        }
    })
    .factory('MessageGuessPropertyFactory', function ($resource, $rootScope, url) {
        var guesspropertyurl = url.guess.property + url.daycache;
        var guesspropertylist;
        function guessproperty() {
            $resource(guesspropertyurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesspropertylist = response.list;
                $rootScope.$broadcast('guess.updated');
            });
        }
        return {
            loadGuess: function () {
                guessproperty();
            },
            getGuessProperty: function () {
                return guesspropertylist;
            }
        }
    })
    .factory('MessageGuessCommunityFactory', function ($resource, $rootScope, url) {
        var guesscommunityurl = url.guess.community + url.daycache;
        var guesscommunitylist;
        function guesscommunity() {
            $resource(guesscommunityurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesscommunitylist = response.list;
                $rootScope.$broadcast('guess.updated');
            });
        }
        return {
            loadGuess: function () {
                guesscommunity();
            },
            getGuessCommunity: function () {
                return guesscommunitylist;
            }
        }
    })
    .factory('MessageGuessHouseFactory', function ($resource, $rootScope, url) {
        var guesshouseurl = url.guess.house + url.daycache;
        var guesshouselist;
        function guesshouse() {
            $resource(guesshouseurl, {}, {query: {method: 'get', timeout: 20000, cache:true}}).query({
                uuid: localStorage.uuid,
                openid: localStorage.openid,
                log: $rootScope.position.x,
                lat: $rootScope.position.y,
                json: true
            }, function (response) {
                guesshouselist = response.list;
                $rootScope.$broadcast('guess.updated');
            });
        }
        return {
            loadGuess: function () {
                guesshouse();
            },
            getGuessHouse: function () {
                return guesshouselist;
            }
        }
    })


;