
angular.module('tmjia.services.mmgj', [])

	//买卖管家首页
	.factory('MmgjIndexFactory', function ($resource, $rootScope, url) {
		var cyqylistUrl = url.mmgj.cyqylist;
		var cyrylistUrl = url.mmgj.cyrylist;
		var cyqyxxdetailUrl = url.mmgj.cyqyxxdetail + url.hourcache;
		var cyryxxdetailUrl = url.mmgj.cyryxxdetail + url.hourcache;
		var cyqylist, cyrylist, cyqyxxdetail, cyryxxdetail;
		return {
			loadCyqylist: function (params, action_scope) {
				$resource(cyqylistUrl, {}, {query: {cache: true}}).query(params, function (r) {
					cyqylist = r;
					if(action_scope) {
						$rootScope.$broadcast('mmgj.' + action_scope + '.cyqylist.updated');
					} else {
						$rootScope.$broadcast('mmgj.cyqylist.updated');
					}
					$rootScope.$broadcast('scroll.infiniteScrollComplete');
				});
			},
			loadCyrylist: function (params, action_scope) {
				$resource(cyrylistUrl, {}, {query: {cache: true}}).query(params, function (r) {
					cyrylist = r;
					if (action_scope) {
						$rootScope.$broadcast('mmgj.' + action_scope + '.cyrylist.updated');
					} else {
						$rootScope.$broadcast('mmgj.cyrylist.updated');
					}
					$rootScope.$broadcast('scroll.infiniteScrollComplete');
				});
			},
			loadCyqydetail: function (qycode) {
				$resource(cyqyxxdetailUrl, {}, {query: {cache: true}}).query({
					qycode: qycode
				}, function (r) {
					cyqyxxdetail = r;
					$rootScope.$broadcast('mmgj.cyqyxxdetail.updated');
				});
			},
			loadCyrydetail: function (rycode, qycode) {
				$resource(cyryxxdetailUrl, {}, {query: {cache: true}}).query({
					rycode: rycode,
					qycode: qycode
				}, function (r) {
					cyryxxdetail = r;
					$rootScope.$broadcast('mmgj.cyryxxdetail.updated');
				});
			},
			getCyqylist: function () {
				return cyqylist;
			},
			getCyrylist: function () {
				return cyrylist;
			},
			getCyqydetail: function () {
				return cyqyxxdetail;
			},
			getCyrydetail: function () {
				return cyryxxdetail;
			},
			//时间格式转化
			restCjsj: function (cjsj) {
				if (cjsj.split('-').length > 1 && cjsj.split('-')[1].split('月').length == 2) {
					var list = cjsj.split('-');
					cjsj = '20' + list[2] + '-' + list[1].substring(0, list[1].length-1) + '-' + list[0];
				} else if (cjsj.split('/').length > 2) {
					var newcjsj = '';
					var list = cjsj.split('/');
					for (i in list) {
						if (i != 0) {
							newcjsj += '-';
						}
						newcjsj += list[i];
					}
					cjsj = newcjsj;
				}
				//时间写死
				return '2016-11-01';
			}
		}
	})
	.factory('MmgjCallFactory', function ($resource, $rootScope, url) {
		var callurl = url.mmgj.call;
		return {
			call: function (calltype, callid) {

				$resource(callurl,{},{
					save: {
						method: 'post',
						cache: true,
						timeout: 20000
					}
				}).save({
					calltype: calltype,
					callid: callid,
					uuid : localStorage.uuid,
					openid : localStorage.openid
				}, function(r) {
					console.log(r);
				});
			}
		}
	})
	.factory('MmgjLogsFactory', function ($resource, $rootScope, url) {
		//搜索地址
		var searchurl = url.mmgj.loglist;
		var saveurl = url.mmgj.savelog;
		var submitmsg;
		//搜索数据结构
		var searchobject = {
			data : [],
			hasNextPage : false
		};

		//搜索实体
		var serachresource = $resource(searchurl,{},{
			query: {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});

		//搜索方法
		function query(){
			var hasNextPage = searchobject.hasNextPage;
			var portalsData = searchobject.data;
			serachresource.query({
				json : true,
				uuid : localStorage.uuid,
				openid : localStorage.openid,
				_d : parseInt(Math.random() * 10086)
			}, function (r) {

				portalsData = r;
				searchobject = {
					'data': portalsData
				};
				$rootScope.$broadcast('mmgjloglist.updated');

			});
		}

		var deleteurl = url.mmgj.deletelog;
		var deleteresource = $resource(deleteurl,{},{
			query : {
				method: 'get',
				cache: true,
				timeout: 20000
			}
		});

		function deleteFocus(logid){
			deleteresource.query({
				'mmgjlog.logid' : logid,
				_d : parseInt(Math.random() * 10086)
			},function(r) {
				submitmsg = r;
				$rootScope.$broadcast('mmgjlogdelete.updated');
			});
		}

		return {
			savelog: function (log) {
				$resource(saveurl,{},{
					save: {
						method: 'post',
						cache: true,
						timeout: 20000
					}
				}).save({
					uuid : localStorage.uuid,
					openid : localStorage.openid
				}, log,function(r) {
					$rootScope.$broadcast('mmgjlog.submitted');
				});
			},
			removelog: function (logid) {
				deleteFocus(logid);
			},
			loadLoglist: function () {
				query();
			},
			getLoglist: function () {
				return searchobject.data;
			}
		}
	})
	.factory('MmgjEntrustFactory', function ($resource, $rootScope, url) {
		//提交地址
		var submiturl = url.mmgj.entrustsubmit;
		var msg;
		
		//提交实体
		var submitresource = $resource(submiturl,{},{
			save: {
				method: 'post',
				cache: true,
				timeout: 20000
			}
		});

		return {
			//提交
			save : function(info) {
				submitresource.save({
					uuid : localStorage.uuid,
					openid : localStorage.openid
				}, info,function(r) {
					msg = r;
					$rootScope.$broadcast('entrust.submitted');
				});
			},
			//获取返回信息
			getMsg : function() {
				return msg;
			}
		}
	})
	.factory('MmgjBuyintentionFactory', function ($resource, $rootScope, url) {
		//提交地址
		var submiturl = url.mmgj.buyintentionsubmit;
		var msg;

		//提交实体
		var submitresource = $resource(submiturl,{},{
			save: {
				method: 'post',
				cache: true,
				timeout: 20000
			}
		});

		return {
			//提交
			save : function(info) {
				submitresource.save({
					uuid : localStorage.uuid,
					openid : localStorage.openid
				}, info,function(r) {
					msg = r;
					$rootScope.$broadcast('buyintention.submitted');
				});
			},
			//获取返回信息
			getMsg : function() {
				return msg;
			}
		}
	})
	//买卖管家地图
	.factory('MmgjMapFactory', function ($rootScope, $timeout) {
		var map;
		var marker;
		var companylist;
		var markers = [];
		
        function init(can, defaultpoint) {
            map = new BMap.Map(can || 'container');
            //map.disableDragging();
        	//map.disablePinchToZoom();
			//var ctrl = new BMap.NavigationControl({anchor: BMAP_ANCHOR_TOP_LEFT});
			//map.addControl(ctrl);
			//map.setMinZoom(17);
            if (typeof (map) != 'undefined') {
				if (defaultpoint) {
					map.centerAndZoom(defaultpoint, 17); // 杭州中心点位置
				} else {
					map.centerAndZoom(new BMap.Point($rootScope.Bposition.x, $rootScope.Bposition.y), 17); // 杭州中心点位置
				}
            } else {
                //console.log('map is undefined');
            }

        }
        
        //设置企业头像
        function setCyqyheadimg(obj) {
        	var positionIcon;
    		if(obj.qymc.split('我爱我家').length > 1) {
	    		positionIcon = new BMap.Icon("images/wawj.png", new BMap.Size(24,24));
	    	} else if(obj.qymc.split('链家').length > 1) {
	    		positionIcon = new BMap.Icon("images/lj.png", new BMap.Size(24,24));
	    	} else if(obj.qymc.split('华邦房地产').length > 1) {
	    		positionIcon = new BMap.Icon("images/hshb.png", new BMap.Size(24,24));
	    	} else if(obj.qymc.split('云房源').length > 1) {
	    		positionIcon = new BMap.Icon("images/qfang.png", new BMap.Size(24,24));
	    	} else {
	    		positionIcon = new BMap.Icon("images/ty.png", new BMap.Size(24,24));
	    	}
	    	positionIcon.setImageSize(new BMap.Size(24,24));
	    	return positionIcon;
        }
        
        //从业企业列表
        function showCyqylist(list) {
        	if (typeof(cordova) != 'undefined' && device.platform == 'iOS') {
    			var top_height = 43;
    		} else {
    			var top_height = 63;
    		}
        	//加个延迟，以防map=undefined
        	$timeout(function () {
        		if (typeof (map) != 'undefined' && map.getContainer().id == 'mmgjindex_container') {
            		if(list) {
            			companylist = list;
            		}
            		var obj;
            		var positionIcon;
        			for(var i in companylist) {
        				obj = companylist[i];
        				if (obj.gisx && obj.gisy) {
        					point = new BMap.Point(obj.gisx, obj.gisy); // 创建点坐标
					        var need_create_marker = true;
					        for (var j in markers) {
						        if (markers[j] == point) {
							        need_create_marker = false;
							        break;
						        }
					        }
					        if (need_create_marker) {
						        markers.push(point);
						        // 根据地理坐标转换为像素坐标
						        var position = map.pointToOverlayPixel(point);
						        // 绑定点击事件
						        var map_showcyqyInfomodal = {
							        point: point,
							        qymc: obj.qymc,
							        qycode: obj.qycode,
							        distance: obj.distance,
							        top: position.y,
							        left: position.x - 50
						        };
						        //设置企业头像
						        positionIcon = setCyqyheadimg(obj);
						        var companyMarker = new BMap.Marker(point, {icon: positionIcon});
						        companyMarker.clickmodal = map_showcyqyInfomodal;
						        companyMarker.addEventListener("click", function($event){
							        $rootScope._$event = $event;
							        $rootScope.map_showcyqyInfomodal = this.clickmodal;
							        this.clickmodal.top = map.pointToPixel(this.point).y - top_height;
							        this.clickmodal.left = map.pointToPixel(this.point).x - 100;
							        $rootScope.$broadcast('mmgj.showcyqyInfomodal.updated');
						        });
						        map.addOverlay(companyMarker);
					        }
        				}
        			}
        			//显示自己的定位
        			defaultPoint();
        		}
        	}, 100);
        }
        
        //买卖管家列表跳转页地图显示列表
        function showMmgjmaplist(list) {
        	if (typeof(cordova) != 'undefined' && device.platform == 'iOS') {
    			var top_height = 43;
    		} else {
    			var top_height = 63;
    		}
        	//加个延迟，以防map=undefined
        	$timeout(function () {
        		if (typeof (map) != 'undefined') {
            		if(list) {
            			companylist = list;
            		}
            		var obj;
            		var positionIcon;
        			for(var i in companylist) {
        				obj = companylist[i];
        				if (obj.gisx && obj.gisy) {
        					point = new BMap.Point(obj.gisx, obj.gisy); // 创建点坐标
					        var need_create_marker = true;
					        for (var j in markers) {
						        if (markers[j] == point) {
							        need_create_marker = false;
							        break;
						        }
					        }
					        if (need_create_marker) {
						        markers.push(point);
						        var showmap_params = {
							        point: point,
							        qymc: obj.qymc,
							        qycode: obj.qycode,
							        distance: obj.distance,
							        top: '',
							        left: ''
						        };
						        //设置企业头像
						        positionIcon = setCyqyheadimg(obj);
						        var companyMarker = new BMap.Marker(point, {icon: positionIcon});
						        companyMarker.clickparams = showmap_params;
						        companyMarker.clickpoint = point;
						        companyMarker.addEventListener("click", function () {
							        $rootScope.showmap_params = this.clickparams;
							        this.clickparams.top = map.pointToPixel(this.point).y - top_height;
							        this.clickparams.left = map.pointToPixel(this.point).x - 100;
							        if ($rootScope.mmgj_maplistClick) {
								        $rootScope.mmgj_maplistClick = false;
								        $rootScope.$broadcast('mmgj.showMmgjmaplist.updated');
							        }
						        });
						        map.addOverlay(companyMarker);
					        }
        				}
        			}
        			//显示自己的定位
        			defaultPoint();
        		} else {
					$timeout(function () {
						showMmgjmaplist(list, map);
					}, 500);
				}
        	}, 100);
        }
        
        //买卖管家地图详情
        function showMmgjmapdetail(obj) {
        	if (typeof(cordova) != 'undefined' && device.platform == 'iOS') {
    			var top_height = 43;
    		} else {
    			var top_height = 63;
    		}
        	//加个延迟，以防map=undefined
        	$timeout(function () {
        		if (typeof (map) != 'undefined') {
            		var positionIcon;
            		if (obj.prjx && obj.prjy) {
    					point = new BMap.Point(obj.prjx, obj.prjy); // 创建点坐标
    					// 根据地理坐标转换为像素坐标
    					var position = map.pointToOverlayPixel(point);
    					// 绑定点击事件
    			    	var map_showmapdetail = {
    			    		point: point,
    			    		qymc: obj.qymc,
    			    		distance: obj.distance,
    			    		top: position.y,
    			    		left: position.x - 50
    			        };
    			    	//设置企业头像
    			    	positionIcon = setCyqyheadimg(obj);
    			    	var mapdetailMarker = new BMap.Marker(point, {icon: positionIcon});
    					map.addOverlay(mapdetailMarker);
						map_showmapdetail.top = map.pointToPixel(point).y - top_height;
						map_showmapdetail.left = map.pointToPixel(point).x - 100;
						$rootScope.map_showmapdetail = map_showmapdetail;
    					mapdetailMarker.addEventListener("click", function(){
							map_showmapdetail.top = map.pointToPixel(point).y - top_height;
							map_showmapdetail.left = map.pointToPixel(point).x - 100;
							$rootScope.map_showmapdetail = map_showmapdetail;
    						$rootScope.$broadcast('mmgj.showmapdetail.updated');
    					});
						$rootScope.$broadcast('mmgj.showmapdetail.info.loaded');
    				}
        		}
        	}, 100);
        }
        
        //地图查找附近管家
        var local;
        function mapsearchButler(key, resultid) {
        	//检索结束后的回调函数
        	$timeout(function () {
        		var options = {
                    pageCapacity : 9,
                    renderOptions : {
                        map : map,
                        panel: resultid
                    },
                    onSearchComplete : function(results) {
                    	// 判断状态是否正确
            			if (local.getStatus() == BMAP_STATUS_SUCCESS){
            				var nearbylist = [];
            				for (var i = 0; i < results.getCurrentNumPois(); i++){
	            				var tags = results.getPoi(i).tags;
	            	            var isshow = false;
	            	            for (var j = 0; tags && j < tags.length; j++) {
	            	            	if (tags[j] == '小区/楼盘' || tags[j] == '地产小区') {
	            	            		isshow = true;
	            	            		break;
		        	                }
		        	            }
		        	            if(isshow) {
		        	            	nearbylist.push({title: results.getPoi(i).title,
		        	            		address: results.getPoi(i).address,
		        	            		point: results.getPoi(i).point,
		        	            		distance: 0});
		        	            }
								$rootScope.nearbylist = nearbylist;
								$rootScope.$broadcast('mmgj.mapsearchButler.updated');
            				}
            			}
                    },
                    onMarkersSet : function (results) {
                    	for(var i = 0; i < results.length; i ++) {
                    		var isshow = false;
                    		var tags = results[i].tags || '';
                    		for (var j = 0; tags && j < tags.length; j++) {
            	            	if (tags[j] == '小区/楼盘' || tags[j] == '地产小区') {
            	            		isshow = true;
            	            		break;
	        	                }
	        	            }
                    		if(!isshow) {
								map.removeOverlay(results[i].marker);
							}
                    	}
                    }
                    // renderOptions: 搜索结果, 地图于map实例显示，列表在 r-result显示
                };
        		//清除最近一次检索的结果，防止标记 
        		if(local) {
        			local.clearResults();
        		}
        		local = new BMap.LocalSearch(map, options);
                local.disableFirstResultSelection();
                local.searchInBounds(key, map.getBounds());
//                map.clearOverlays();
        	}, 100);
        }
        
        
        function defaultposition() {
    		if (localStorage.position) {
    			return JSON.parse(localStorage.position);
    		} else {
    			return {x: 120.5916941890,y: 31.3053856841};
    		}
    	}
        
        function defaultPoint() {
			var p = new BMap.Point($rootScope.Bposition.x, $rootScope.Bposition.y);
			if (!marker) {
				var positionIcon = new BMap.Icon("http://webmap2.map.bdstatic.com/wolfman/static/common/images/ipLocation/ipLocation_ac75181.png", new BMap.Size(14,14));
				marker = new BMap.Marker(p, {icon: positionIcon});
				marker.disableMassClear();
				map.addOverlay(marker); // 将标注添加到地图中
			} else {
				marker.setPosition(p);
			}
		}
		var EARTH_RADIUS = 6378137.0; //单位M
		var PI = Math.PI;
		function getRad(d){
			return d * PI/180.0;
		}
		/**
		 * 计算两个坐标点之间的距离
		 * @param {Object} lat1
		 * @param {Object} lng1
		 * @param {Object} lat2
		 * @param {Object} lng2
		 */
		function getFlatternDistance(lat1,lng1,lat2,lng2){
			var f = getRad((parseFloat(lat1) + parseFloat(lat2))/2);
			var g = getRad((parseFloat(lat1) - parseFloat(lat2))/2);
			var l = getRad((parseFloat(lng1) - parseFloat(lng2))/2);
			var sg = Math.sin(g);
			var sl = Math.sin(l);
			var sf = Math.sin(f);
			
			var s,c,w,r,d,h1,h2;
			var a = EARTH_RADIUS;
			var fl = 1/298.257;
			
			sg = sg*sg;
			sl = sl*sl;
			sf = sf*sf;
			
			s = sg*(1-sl) + (1-sf)*sl;
			c = (1-sg)*(1-sl) + sf*sl;
			
			w = Math.atan(Math.sqrt(s/c));
			r = Math.sqrt(s*c)/w;
			d = 2*w*a;
			h1 = (3*r -1)/2/c;
			h2 = (3*r +1)/2/s;
			
			return d*(1 + fl*(h1*sf*(1-sg) - h2*(1-sf)*sg))/1000;
		}
		return {
			init: init,
			getmap: function () {
				return map;
			},
			setmap: function (scrollmap) {
				map = scrollmap;
			},
			showCyqylist: showCyqylist,
			clear: function () {
				
			},
			clearOverlays: function () {
				map.clearOverlays();
				markers = [];
			},
			showKeywordlist: function () {
				
			},
			getFlatternDistance: getFlatternDistance,
			mapsearchButler: mapsearchButler,
			showMmgjmaplist: showMmgjmaplist,
			showMmgjmapdetail: showMmgjmapdetail
		}
	})
;