
angular.module('tmjia.services.modal', [])

	.factory('ModalFactory', function ($rootScope, $ionicModal, $ionicPopover) {
		function init(modallist, $scope) {
			function createModal(name) {
				var uppername = name[0].toUpperCase() + name.substring(1);
				var url = name + '.html';
				$ionicModal.fromTemplateUrl(url, {
					scope: $scope,
					animation: 'none'
				}).then(function(modal) {
					$scope[name] = modal;
				});
				$scope['open' + uppername] = function() {
					if (uppername == 'priceModal' || uppername == 'areaModal' || uppername == 'hxsModal' || uppername == 'moreModal') {
						$scope.istop = true;//这里控制好找房小区筛选弹出层时有用
					}
					for(i in modallist) {
						if (modallist[i] != name) {
							$scope[modallist[i]].hide();
						}
					}
					$scope[name].show();
				};
				$scope['close' + uppername] = function() {
					$scope[name].hide();
				};
				$scope.$on('$destroy', function() {
					$scope[name].remove();
				});
			}
			for (i in modallist) {
				createModal(modallist[i]);
			}
			function closeAllModal() {
			}
		}
		return {
			init: init,
			closeAllModal: function (modallist, $scope, func) {
    		    for (i in modallist) {
    			    var uppername = modallist[i][0].toUpperCase() + modallist[i].substring(1);
    			    $scope['close' + uppername]();
    		    }
	    	},
			loadLoginModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/loginModal.html', {
					scope: scope,
					animation: 'slide-in-up',
					controller: 'loginCtrl'
				}).then(function(modal) {
					scope.loginmodal = modal;
				});
				scope.openLoginModal = function() {
					scope.loginmodal.show();
					$rootScope.$broadcast("loginmodal.enter");
				};
				scope.closeLoginModal = function() {
					scope.loginmodal.hide();
					$rootScope.$broadcast("loginmodal.close.enter");
				};
			},
			/**
			 * 这个是刷新成功控件提示
			 * 用法：1.引入 controller里引入 ModalFactory
			 * 2.页面 加载时显示model
			 * $scope.$on('$ionicView.afterEnter', function (event, viewData) {
					$scope.openJzModal();
				});
			 * ModalFactory.loadSxModal($scope);
			 * 3.离开时 关闭model
			 * $scope.$on('$ionicView.beforeLeave', function (event, viewData) {
        			$scope.closeSxModal();
         		});
         		4.ModalFactory.loadSxModal($scope);
			 */
			loadSxModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/sxModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.sxModal = modal;
				});
				scope.openSxModal = function() {
					scope.sxModal.show();
				};
				scope.closeSxModal = function() {
					scope.sxModal.hide();
				};
			},
			/**
			 * 这个是加载中提示空间 用法同上刷新控件
			 */
			loadJzModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/jzModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.jzModal = modal;
				});
				scope.openJzModal = function() {
					scope.jzModal.show();
				};
				scope.closeJzModal = function() {
					scope.jzModal.hide();
				};
			},
			loadMmgjCallModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/mmgjCallModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.mmgjcallmodal = modal;
				});
				scope.openMmgjCallModal = function() {
					scope.mmgjcallmodal.show();
				};
				scope.closeMmgjCallModal = function() {
					scope.mmgjcallmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.mmgjcallmodal.remove();
				});
			},
			loadMmgjCallSuccessModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/mmgjCallSuccessModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.mmgjcallsuccessmodal = modal;
				});
				scope.openMmgjCallSuccessModal = function() {
					scope.mmgjcallsuccessmodal.show();
				};
				scope.closeMmgjCallSuccessModal = function() {
					scope.mmgjcallsuccessmodal.hide();
				};
			},
			loadMmgjHelperModal: function (scope) {
				scope.$on('$stateChangeStart', function () {
					scope.closeMmgjHelperModal();
				});
				$ionicModal.fromTemplateUrl('templates/modal/mmgjHelperModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.mmgjhelpermodal = modal;
				});
				scope.openMmgjHelperModal = function() {
					scope.mmgjhelpermodal.show();
				};
				scope.closeMmgjHelperModal = function() {
					scope.mmgjhelpermodal.hide();
				};
			},
			loadMmgjNearbyPopover: function (scope) {
				scope.$on('$stateChangeStart', function () {
					scope.closeMmgjnearbyPopover();
				});
				$ionicPopover.fromTemplateUrl('templates/modal/mmgjNearbyPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.mmgjnearby = popover;
				});
				scope.openMmgjnearbyPopover = function() {
					scope.mmgjnearby.show();
				};
				scope.closeMmgjnearbyPopover = function() {
					scope.mmgjnearby.hide();
				};
			},
			loadMmgjCyqyInfoPopover: function (scope) {
				//$ionicPopover弹出方式不一样，用于直接弹出，而非从下面弹出
				$ionicPopover.fromTemplateUrl('templates/modal/mmgjCyqyinfoPopover.html', {
		            scope: scope,
		            animation: 'slide-in-up'
		        }).then(function (popover) {
		        	scope.cyqyInfoPopover = popover;
		        });
		        
				scope.openMmgjcyqyInfoPopover = function ($event) {
					scope.cyqyInfoPopover.show($event);
		        };
		        scope.closeMmgjcyqyInfoPopover = function () {
		        	scope.cyqyInfoPopover.hide();
		        };
			},
			loadMmgjMaplistInfoPopover: function (scope) {
				scope.$on('$stateChangeStart', function () {
					scope.closeMmgjMaplistInfoPopover();
				});
				//$ionicPopover弹出方式不一样，用于直接弹出，而非从下面弹出
				$ionicPopover.fromTemplateUrl('templates/modal/mmgjMaplistinfoPopover.html', {
		            scope: scope,
		            animation: 'slide-in-up'
		        }).then(function (popover) {
		        	scope.maplistInfoPopover = popover;
		        });
		        
				scope.openMmgjMaplistInfoPopover = function () {
					scope.maplistInfoPopover.show();
		        };
		        scope.closeMmgjMaplistInfoPopover = function () {
		        	scope.maplistInfoPopover.hide();
		        };
			},
			//地图详情页弹出层
			loadMmgjMapdetailPopover: function (scope) {
				//$ionicPopover弹出方式不一样，用于直接弹出，而非从下面弹出
				$ionicPopover.fromTemplateUrl('templates/modal/mmgjMapdetailPopover.html', {
		            scope: scope,
		            animation: 'slide-in-up'
		        }).then(function (popover) {
		        	scope.mapdetailpopover = popover;
		        });
		        
				scope.openMapdetailPopover = function () {
					scope.mapdetailpopover.show();
		        };
		        scope.closeMapdetailPopover = function () {
		        	scope.mapdetailpopover.hide();
		        };
			},
			loadMmgjshowmaplistPopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/mmgjShowmaplistPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.mmgjshowmaplist = popover;
				});
				scope.openMmgjshowmaplistPopover = function() {
					scope.mmgjshowmaplist.show();
				};
				scope.closeMmgjshowmaplistPopover = function() {
					scope.mmgjshowmaplist.hide();
					if(typeof(scope.closeMmgjMaplistInfoPopover) == 'function') {
						scope.closeMmgjMaplistInfoPopover();
					}
				};
			},
			loadDecorationCompanyOrderbyPopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationCompanyOrderbyPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationCompanyOrderby = popover;
				});
				scope.openDecorationCompanyOrderbyPopover = function() {
					scope.decorationCompanyOrderby.show();
				};
				scope.closeDecorationCompanyOrderbyPopover = function() {
					scope.decorationCompanyOrderby.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationCompanyOrderby.remove();
				});
			},
			loadDecorationCompanyDistrictPopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationCompanyDistrictPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationCompanyDistrict = popover;
				});
				scope.openDecorationCompanyDistrictPopover = function() {
					scope.decorationCompanyDistrict.show();
				};
				scope.closeDecorationCompanyDistrictPopover = function() {
					scope.decorationCompanyDistrict.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationCompanyDistrict.remove();
				});
			},
			loadDecorationDistrictPopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationDistrictPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationDistrict = popover;
				});
				scope.openDecorationDistrictPopover = function() {
					scope.decorationDistrict.show();
				};
				scope.closeDecorationDistrictPopover = function() {
					scope.decorationDistrict.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationDistrict.remove();
				});
			},
			loadDecorationRoomPopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationRoomPopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationRoom = popover;
				});
				scope.openDecorationRoomPopover = function() {
					scope.decorationRoom.show();
				};
				scope.closeDecorationRoomPopover = function() {
					scope.decorationRoom.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationRoom.remove();
				});
			},
			loadDecorationMorePopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationMorePopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationMore = popover;
				});
				scope.openDecorationMorePopover = function() {
					scope.decorationMore.show();
				};
				scope.closeDecorationMorePopover = function() {
					scope.decorationMore.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationMore.remove();
				});
			},
			loadDecorationStylePopover: function (scope) {
				$ionicPopover.fromTemplateUrl('templates/modal/decorationStylePopover.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(popover) {
					scope.decorationStyle = popover;
				});
				scope.openDecorationStylePopover = function() {
					scope.decorationStyle.show();
				};
				scope.closeDecorationStylePopover = function() {
					scope.decorationStyle.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationStyle.remove();
				});
			},
			loadDecorationCallModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/decorationCallModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.decorationcallmodal = modal;
				});
				scope.openDecorationCallModal = function() {
					scope.decorationcallmodal.show();
				};
				scope.closeDecorationCallModal = function() {
					scope.decorationcallmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationcallmodal.remove();
				});
			},
			loadDecorationAppointModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/decorationAppointModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.decorationappointmodal = modal;
				});
				scope.openDecorationAppointModal = function() {
		            scope.decorationappointmodal.show();
				};
				scope.closeDecorationAppointModal = function() {
					scope.decorationappointmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationappointmodal.remove();
				});
			},
			loadDecorationCompanySearchkeywordModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/searchcommunityModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.decorationCompanySearchkeywordmodal = modal;
				});
				scope.openDecorationCompanySearchkeywordModal = function() {
					scope.decorationCompanySearchkeywordmodal.show();
				};
				scope.closeDecorationCompanySearchkeywordModal = function() {
					scope.decorationCompanySearchkeywordmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.decorationCompanySearchkeywordmodal.remove();
				});
			},
			loadChangePasswordByTelModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/changePasswordByTelModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.changePasswordByTelmodal = modal;
				});
				scope.openchangePasswordByTelModal = function() {
					scope.changePasswordByTelmodal.show();
				};
				scope.closechangePasswordByTelModal = function() {
					scope.changePasswordByTelmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.changePasswordByTelmodal.remove();
				});
			},
			loadChangePasswordSuccessModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/changePasswordSuccessModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.changePasswordSuccessmodal = modal;
				});
				scope.openchangePasswordSuccessModal = function() {
					scope.changePasswordSuccessmodal.show();
				};
				scope.closechangePasswordSuccessModal = function() {
					scope.changePasswordSuccessmodal.hide();
				};
				scope.$on('$destroy', function() {
					scope.changePasswordSuccessmodal.remove();
				});
			},
			loadfocusCancelDecorationCaseModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/focusCancelDecorationCaseModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.focusCancelDecorationCaseModal = modal;
				});
				scope.openfocusCancelDecorationCaseModal = function() {
					scope.focusCancelDecorationCaseModal.show();
				};
				scope.closefocusCancelDecorationCaseModal = function() {
					scope.focusCancelDecorationCaseModal.hide();
				};
				scope.$on('$destroy', function() {
					scope.focusCancelDecorationCaseModal.remove();
				});
			},
			loadCommunityCommentModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/communityCommentModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.communityCommentModal = modal;
				});
				scope.openCommunityCommentModal = function() {
					scope.communityCommentModal.show();
				};
				scope.closeCommunityCommentModal = function() {
					scope.communityCommentModal.hide();
				};
				scope.$on('$destroy', function() {
					scope.communityCommentModal.remove();
				});
			},
			loadCheckCheckCodeModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/checkCheckCodeModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.checkCheckCodeModal = modal;
				});
				scope.openCheckCheckCodeModal = function() {
					$rootScope.refleshcode();
					scope.checkCheckCodeModal.show();
				};
				scope.closeCheckCheckCodeModal = function() {
					scope.checkCheckCodeModal.hide();
				};
				scope.submitCheckCheckCodeModal = function () {
					if ($rootScope.checkcheckcode.code == '') {
						$rootScope.alert('请输入验证码');
						return;
					}
					scope.sendCheckCodeReal();
					scope.checkCheckCodeModal.hide();
				};
				scope.$on('$destroy', function() {
					scope.checkCheckCodeModal.remove();
				});
				if (typeof(scope.sendCheckCode) == 'function') {
					scope.sendCheckCodeReal = scope.sendCheckCode;
					scope.sendCheckCode = scope.openCheckCheckCodeModal;
				}
			},
			/**
			 * 分享公共封装方法
			 */
			loadShareModal: function (scope) {
				$ionicModal.fromTemplateUrl('templates/modal/shareModal.html', {
					scope: scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					scope.sharemodal = modal;
				});
				scope.openShareModal = function() {
					scope.sharemodal.show();
					$rootScope.$broadcast("sharemodal.enter");
				};
				scope.closeShareModal = function() {
					scope.sharemodal.hide();
				};
			},
			loadClientContactModal: function (scope) {
				scope.$on('$stateChangeStart', function () {
					//scope.closeMmgjHelperModal();
				});
				$ionicModal.fromTemplateUrl('templates/modal/clientContactModal.html', {
					scope: scope,
					animation: 'slide-in-right'
				}).then(function(modal) {
					scope.clientcontactmodal = modal;
				});
				scope.openClientContactModal = function() {
					scope.clientcontactmodal.show();
				};
				scope.closeClientContactModal = function() {
					scope.clientcontactmodal.hide();
				};
				scope.$on('$ionicView.leave', function () {
					scope.clientcontactmodal.remove();
				});
			}
		}
	})
;