/**
 * Created by cb on 2016/8/5.
 */
angular.module('tmjia.services.news', [])

    .factory('NewsListFactory', function ($resource, $rootScope, url) {
        var indexurl = url.news.index;
        var listurl = url.news.list;
        var videolisturl = url.news.videolist;
        var list;

        //缓存列表读取
        var indexresource = $resource(indexurl, {version: '412'}, {
            query: {
                method: 'get',
                cache: true,
                isArray: true,
                timeout: 20000
            }
        });

        //实时列表查询
        var listresource = $resource(listurl, {}, {
            query: {
                method: 'get',
                //cache: true,
                timeout: 20000
            }
        });
        var videolistresource = $resource(videolisturl, {}, {
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        //翻页列表数据格式
        var content = {
            'hasNextPage': true,
            'data': []
        };

        //查询参数设置
        var params = {
            cateid: '',
            page: 1
        };

        //翻页查询
        function query(p) {
            var hasNextPage = content.hasNextPage;
            var portalsData = content.data;
	        if (p) {
		        params = p;
	        }
            listresource.query(params, function (r) {
                if (portalsData.length > 0 && p.page != 1) {
                    portalsData = portalsData.concat(r.list);
                } else {
                    portalsData = r.list;
                }
                params.page++;
                hasNextPage = !r.isover;
                content = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData,
	                count: r.count || 0
                };

                $rootScope.$broadcast('newsinfolist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
            });
        }
        function queryVideo(p) {
            var hasNextPage = content.hasNextPage;
            var portalsData = content.data;
            if (p) {
                params = p;
            }
            videolistresource.query(params, function (r) {
                if (portalsData.length > 0 && p.page != 1) {
                    portalsData = portalsData.concat(r.list);
                } else {
                    portalsData = r.list;
                }
                params.page++;
                hasNextPage = !r.isover;
                content = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData,
                    count: r.count || 0
                };

                $rootScope.$broadcast('newsinfolist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        return{
            loadIndex: function(){
                indexresource.query({version: '412', json: 'true'}, function (r) {
                    list = r;
                    $rootScope.$broadcast('list.indexupdated');
                });
            },
	        clearlist: function () {
		        content.data = [];
	        },
            //资讯列表后续读取
            loadList: function (p) {
                if (p.isvideo) {
                    queryVideo(p);
                } else {
                    query(p);
                }
            },
	        getContent: function () {
		        return {
			        data : content.data,
			        hasNextPage : content.hasNextPage
		        };
	        },
            getList: function () {
                return content.data;
            },
	        getCount: function () {
		        return content.count;
	        },
            hasNextPage: function () {
                if (content === undefined) {
                    return false;
                }
                return content.hasNextPage;
            },
            setHasNextPage: function (hasNextPage) {
                content.hasNextPage = hasNextPage;
            },

            //获取缓存的前两页资讯
            getIndex: function(cateid) {
                params.cateid = cateid;
                params.page = 3;
                for (i in list[list.length - 1]) {
                    if (cateid == list[list.length - 1][i]) {
                        content.data = list[i];
	                    break;
                    }
                }
                return content.data;
            }

        }
    })

    .factory('NewsInfoFactory', function ($resource, $rootScope, url) {
        var newsurl = url.news.info;
        var news;
        //实时列表查询
        var newsresource = $resource(newsurl, {}, {

            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        return{
            loadInfo: function(contentid){
                newsresource.query({
                    _contentid: contentid,
                    json: true
                },function(r){
                    // r.replaceAll('/upload', _INIT_IMG_YUMING + '/upload');
                    news = r;
                    $rootScope.$broadcast('NewsInfo.updated');
                })
            },

            getInfo: function(){
                return news;
            }
        }
    })
    
    .factory('NewsVideoFactory', function ($resource, $rootScope, url) {
        var newsurl = url.news.video;
        var news;
        //实时列表查询
        var newsresource = $resource(newsurl, {}, {
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });

        return{
            loadInfo: function(contentid){
                newsresource.query({
                    contentid: contentid,
                    json: true
                },function(r){
                    // r.replaceAll('/upload', _INIT_IMG_YUMING + '/upload');
                    news = r;
                    $rootScope.$broadcast('NewsVideo.updated');
                })
            },
            getInfo: function(){
                return news;
            }
        }
    })

    .factory('NewsCommentFactory', function ($resource, $rootScope, url) {
        var commenturl = url.news.comment;
        var commcounturl = url.news.commcount;
        var saveurl = url.news.commentsave;
        var savecommzanUrl = url.news.savecommzan;
        var commentlist;
        var msg;
        var commcount;
        var commentresource = $resource(commenturl, {}, {

            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }

        });

        var saveresource = $resource(saveurl, {},{
            save: {
                method: 'post',
                cache: true,
                timeout: 20000
            }
        });

        var userparams = {
            uuid : '',
            openid : ''
        };
        userparams.uuid = localStorage.uuid;
        userparams.openid = localStorage.openid;
        
        return{
            saveComment: function(comment){

                saveresource.save({
                    uuid : localStorage.uuid,
                    openid : localStorage.openid
                }, comment, function(r){
                    msg = r;
                    $rootScope.$broadcast('NewsComment.submitted');
                });


            },

            savecommzan: function (commentid) {
                var can_zan = true;
                var zanliststr = localStorage.news_comment_zan_list;
                var zanlist = new Array();
                if (zanliststr) {
                    var zanlist = JSON.parse(zanliststr);
                    for (var i in zanlist) {
                        if (zanlist[i] == commentid) {
                            can_zan = false;
                            break;
                        }
                    }
                }
                if (can_zan) {
                    $resource(savecommzanUrl, {}, {
                        save: {
                            method: 'post',
                            cache: true,
                            timeout: 20000
                        }
                    }).save({
                        uuid : localStorage.uuid,
                        commentid: commentid
                    }, function (r) {
                        if (r.flag) {
                            zanlist.push(commentid);
                            localStorage.news_comment_zan_list = JSON.stringify(zanlist);
                            $rootScope.$broadcast('NewsComment.zan', commentid);
                        }
                    });
                } else {
                    $rootScope.alert('你已经点评过这条评论了');
                }
            },
            getMsg: function() {
                return msg;
            },

            loadComment: function(conntentid, ishot) {
                commentresource.query({
                    contentid: conntentid,
                    ishot: ishot
                },function(r){
                    commentlist = r;
                    if (r.ishot) {
                    	$rootScope.$broadcast('HotNewsComment.updated');
                    } else {
                    	$rootScope.$broadcast('NewsComment.updated');
                    }
                })
            },
            
            getComment: function() {
                return commentlist;
            },
            
            
            loadCommcount: function (contentid) {
            	$resource(commcounturl, {}, {query: {cache: false}}).query({
            			contentid : contentid,
                        uuid: localStorage.uuid,
                        openid: localStorage.openid
            		}, function (r) {
            		commcount = r;
            		$rootScope.$broadcast('NewsCommentCount.success');
            	});
            },
            getCommcount: function () {
            	return commcount;
            }
        }
        
    })

    .factory('DiscoverFactory', function ($resource, $rootScope, url) {
    	
    	//搜索地址
        var searchurl = url.news.foundlist;
        
        //搜索数据结构
        var searchobject = {
            data : [],
            hasNextPage : true
        };

        //搜索参数
        var params = {
            page : 1
        };
        
        //提交点赞信息
        var upRe;
        var foundthumbsupUrl = url.news.foundthumbsup;
    	var foundthumbsupPost = $resource(foundthumbsupUrl, {},{
            save: {
                method: 'post',
                cache: false,
                timeout: 20000
            }
        });
        

        //搜索实体
        var serachresource = $resource(searchurl,
        	{
	        	uuid : localStorage.uuid,
	            openid : localStorage.openid
        	},{
            query: {
                method: 'get',
                cache: false,
                timeout: 20000
            }
        });

        //搜索方法
        function query(){
            var hasNextPage = searchobject.hasNextPage;
            var portalsData = searchobject.data;
            serachresource.query(params, function (r) {
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                searchobject = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
                $rootScope.$broadcast('discoverlist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');

            });
        }
    	
    	return {
    		doFoundthumbsup:function (linkid){
    			foundthumbsupPost.save({
                    uuid : localStorage.uuid,
                    openid : localStorage.openid                    
                }, {linkid:linkid}, function(r){
                	upRe = r;
                	$rootScope.$broadcast('doFoundthumbsup.submited');
                });
    		},
    		getFoundthumbsup:function (){
    			return upRe;
    		},
    		//读取列表
            loadDiscoverList : function() {
                query();
            },

            //获得列表数据
            getDiscoverList : function() {
                return searchobject.data;
            },

            //刷新列表
            reloadDiscoverList : function() {
                searchobject = {
                    data : [],
                    hasNextPage : true
                };

                params.page = 1;
                query();

            },

            //翻页确认
            hasNextPage : function() {
                return searchobject.hasNextPage;
            }
    	}
    })
