angular.module('tmjia.services.property', [])

//楼盘首页
    .factory('PropertyIndexFactory', function ($resource,$timeout, $rootScope, url) {
        var comprolabelurl = url.search.comprolabel + url.hourcache;
        var adpropertyurl = url.property.adproperty + url.hourcache;
        var comprolabels,adproperty;
        var comprolabelscomm;
        var resource = $resource(comprolabelurl, {}, {
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        var adresource = $resource(adpropertyurl, {}, {
            query: {
                method: 'get',
                cache: true,
                timeout: 20000
            }
        });
        return {
            loadComprolabel: function () {
                resource.query({json: 'true'}, function (r) {
                        comprolabels = r.propertylist;
                        comprolabelscomm = r.communitylist;
                        $rootScope.$broadcast('label.updated');
                });
            },
            loadAdproperty: function () {
            	adresource.query({json: 'true'}, function (r) {
                        adproperty = r.list;
                        $rootScope.$broadcast('adproperty.updated');
                   }, function (e) {
						$rootScope.alert('加载失败!');
				});
            },
            getAdproperty: function () {
            	return adproperty;
            },
            getComprolabel: function () {
                return comprolabels;
            },
            getComprolabelcomm: function () {
                return comprolabelscomm;
            }
        };
    })
    //楼盘查房价首页
    .factory('PropertyPriceFactory', function ($resource, $rootScope,$timeout, url) {
        var cityareaurl = url.tmj.cityarea + url.hourcache;
        var hotsearchurl = url.tmj.hotsearch + url.daycache;
        var propertyranklisturl = url.tmj.propertyranklist + url.daycache;
        var hotcityareaurl = url.tmj.hotcityarea + url.daycache;
        var districtlisturl = url.tmj.districtlist + url.daycache;
        var cityarea_property, cityarea_community, hotsearch, propertyranklist, hotcityarea, districtlist;

        function loadCityarea() {
            $resource(cityareaurl, {}, {query: {cache: true}}).query({
                linktype: 1,
                prjx: 120.678923,
                prjy: 31.324308,
                json: true
            }, function (r) {
                    cityarea_property = r;
                    checkLoaded();
            }, function (e) {
					$rootScope.alert('加载失败!');
			});
            $resource(cityareaurl, {}, {query: {cache: true}}).query({
                linktype: 2,
                prjx: 120.678923,
                prjy: 31.324308,
                json: true
            }, function (r) {
                cityarea_community = r;
                checkLoaded();
            });
        }

        function loadHotsearch() {
            $resource(hotsearchurl, {}, {query: {cache: true}}).query({json: true}, function (r) {
                hotsearch = r;
                checkLoaded();
            });
        }

        function loadPropertyranklist() {
            $resource(propertyranklisturl, {}, {query: {cache: true}}).query({json: true}, function (r) {
                propertyranklist = r;
                checkLoaded();
            });
        }

        function loadHotcityarea() {
            $resource(hotcityareaurl, {}, {query: {cache: true}}).query({json: true}, function (r) {
                hotcityarea = r;
                checkLoaded();
            });
        }

        function loadDistrictlist() {
            $resource(districtlisturl, {}, {query: {cache: true}}).query({json: true}, function (r) {
                districtlist = r;
                checkLoaded();
            });
        }

        function checkLoaded() {
            if (cityarea_property && cityarea_community && hotsearch && propertyranklist && hotcityarea && districtlist) {
                $rootScope.$broadcast('info.updated');
            }
        }

        return {
            loadInfo: function () {
                loadCityarea();
                loadDistrictlist();
               // loadHotcityarea();
               // loadHotsearch();
                loadPropertyranklist();
            },
            getPropertyCityarea: function () {
                return cityarea_property;
            },
            getCommunityCityarea: function () {
                return cityarea_community;
            },
            getDistrictlist: function () {
                return districtlist;
            },
            getHotcityarea: function () {
                return hotcityarea;
            },
            getHotsearch: function () {
                return hotsearch;
            },
            getPropertyranklist: function () {
                return propertyranklist;
            }
        };
    })

    //地图找房
    .factory('PropertyMapFactory', function ($resource, $rootScope, url) {
        var url_property = url.search.property;
        var url_community = url.search.community;
        var url_hotcityarea = url.tmj.hotcityarea;
        var url_districtlist = url.tmj.districtlist;
        var url_show_property = url.property.detail;

        var hotcityarea, districtlist, propertylist, showproperty;

        return {
            loadArea: function () {
                $resource(url_hotcityarea, {}, {query: {cache: true}}).query({json: true}, function (r) {
                    hotcityarea = r;
                    $resource(url_districtlist, {}, {query: {cache: true}}).query({json: true}, function (r) {
                        districtlist = r;
                        $rootScope.$broadcast('map.hotcityarea.updated');
                    });
                });
            },
        	loadProperty: function (bp, recordproperty) {
                $resource(url_property, {}, {query: {cache: true}}).query({
					neLat: bp.getNorthEast().lat,
					neLng: bp.getNorthEast().lng,
					swLat: bp.getSouthWest().lat,
					swLng: bp.getSouthWest().lng,
                    recordproperty: recordproperty || '',
                    json: true
                }, function (r) {
                    propertylist = r;
                    $rootScope.$broadcast('map.property.updated');
                });
        	},
        	loadCommunity: function (bp) {
                $resource(url_community, {}, {query: {cache: true}}).query({
                    neLat: bp.getNorthEast().lat,
                    neLng: bp.getNorthEast().lng,
                    swLat: bp.getSouthWest().lat,
                    swLng: bp.getSouthWest().lng,
                    json: true
                }, function (r) {
                    propertylist = r;
                    $rootScope.$broadcast('map.community.updated');
                });
        	},
            loadShowProperty: function (property) {
                //resource.post.params.propertyid = proeprtyid;
                var queryobj;
                if (property.linktype == 1) {
                    queryobj = {
                        propertyid: property.linkid,
                        siteid: property.sid,
                        linktype: property.linktype,
                        json: true
                    }
                } else {
                    queryobj = {
                        communityid: property.linkid,
                        linktype: property.linktype,
                        json: true
                    }
                }
                $resource(url_show_property, {}, {query: {cache: true}}).query(queryobj, function (response) {
                    showproperty = response;
                    $rootScope.$broadcast('map.property.showproperty.updated');
                });
            },
            getHotcityarea: function () {
                return hotcityarea;
            },
            getDistrictlist: function () {
              return districtlist;
            },
            getPropertylist: function () {
                return propertylist;
            },
            getShowProperty: function () {
                return showproperty;
            }
        }
    })

    // 地图找房1
    .factory('PropertyMapFactory1', function ($rootScope, $state, url, UDIP) {
    	return {
    		// 获取新房商圈房源{propertylist: []}
    		getPropertySqList: function() {
		        return UDIP.loadjsonobject(url.tmj.hotcityarea, {});
    		},
    		// 获取新房城区房源{propertylist: []}
    		getPropertyDistrictList: function() {
    			return UDIP.loadjsonobject(url.tmj.districtlist, {});
    		},
    		// 获取二手房、租房的城区、商圈房源
    		getCommunityAreaList: function() {
    			return UDIP.loadobject(url.map.arealist, {}, 'map.arealist');
    		},
    		// 获取地铁站点信息
    		getSubways: function() {
    			return UDIP.loadobject(url.map.subway, {}, 'sfw.map.subway.loaded');
    		},
    		// 处理地铁站点的信息
    		handleSubways: function(result) {
    			var subwayInfo = {};
		        for (var i = 0; i < result.list.length; i++) {
		        	var r = result.list[i];
		        	subwayInfo[r.psubid] = subwayInfo[r.psubid] || [];
		        	subwayInfo[r.psubid].push(r);
		        }
		        var subwayTmp = [];
		        for (var k in subwayInfo) {
		        	subwayTmp = subwayTmp.concat(subwayInfo[k]);
		        }
		        return {
		        	subway: subwayTmp,
		        	subwayInfo: subwayInfo
		        };
    		},
    		// 获取小区详情
    		getFyDetail: function(communityid) {
    		    return UDIP.loadobject(url.map.communitydetail, { communityid: communityid }, 'esf.map.fy.detail.load');
    		},
    		// 获取公寓详情
    		getGyDetail: function(apid) {
    			return UDIP.loadobject(url.map.projectdetail, { apid: apid }, 'esf.map.fy.detail.load');
    		},
    		// 获取金领顾问列表
    		getJlgwList: function(communityid) {
    			return UDIP.loadobject(url.map.jlgwlist, { communityid: communityid }, 'map.xqjlgwlist.load');
    		},
    		// 加载二手房出售的小区房源列表
    		getCsfyList: function(params) {
    			return UDIP.loadobject(url.map.gpfylist, params, 'map.communitydetail.gpfylist.load').then(function(result) {
    				$rootScope.$broadcast('scroll.infiniteScrollComplete');
    				$rootScope.$broadcast('scroll.refreshComplete');
    				return result;
    			});
    		},
    		// 加载出租的小区房源列表
    	    getCzfyList: function(params) {
    	        return UDIP.loadobject(url.map.rentlist, params, 'map.communitydetail.rentlist.load').then(function(result) {
    				$rootScope.$broadcast('scroll.infiniteScrollComplete');
    				$rootScope.$broadcast('scroll.refreshComplete');
    				return result;
    			});
    	    },
    	    // 加载二手房、租房小区
    	    getCommunityList: function(params, timeout) {
				return UDIP.loadobject(url.map.communitylist, params, 'map.communitylist', timeout);
    	    },
    	    // 加载公寓列表
    	    getGyList: function(params) {
    	    	return UDIP.loadobject(url.map.gylist, params, 'map.gylist');
    	    },
    	    // 加载顾问列表
    	    getGwList: function(params) {
    	    	return UDIP.loadobject(url.map.jlgwlist, params, 'map.gwlist');
    	    },
    	    // 加载新房楼盘列表
    	    getPropertyList: function(params) {
    	    	return UDIP.loadobjectwithoutuuid(url.search.property, params, 'map.propertylist');
    	    },
    	    // 加载新房楼盘详情
    	    getPropertyDetail: function(propertyid, siteid) {
    	    	return UDIP.loadjsonobject(url.property.detail, { propertyid: propertyid, siteid: siteid });
    	    },
    	    // 进入聊天页面
    	    gotochat: function(scope, webaccountid, brokerid) {
    	        // 跳转前要先判断用户是否已经登录
    	        if ($rootScope.islogin) {
    	            if (webaccountid == 'adminbbt') {
    	                $state.go('message_aiquestion');
    	            } else {
    	                $state.go('message_chat', { webaccountid: webaccountid, brokerid: brokerid });
    	            }
    	        } else {
    	            scope.openLoginModal();
    	        }
    	    },
    	    // 关注小区
    	    doFollow: function(communityid) {
    	    	return UDIP.saveobject(url.map.doOrder, { linkid: communityid, linktype: 1 }, 'map.communitydetail.dofocus');
    	    },
    	    // 取消关注
    	    deleteFollow: function(communityid) {
    	        return UDIP.saveobject(url.map.undoOrder, { linkids: communityid, linktype: 1 }, 'map.communitydetail.detelefocus');
    	    },
    		// 去除逗号
    		clearComma: function(arr) {
    			return arr.join(',').replace(/,,+/g, ',').replace(/^,+|,+$/g, '');
    		},
    		// 加载地图搜索二手房、租房的城区、商圈、小区、公寓、地铁的信息
    		getKeywordList: function() {
    			return UDIP.loadobject(url.map.keywordlist, {}, 'searchkeyword.keywordlist.loaded');
    		},
    		// 加载地图搜索新房楼盘
    		getXfKeywordList: function() {
    			var keywordurl = url.search.compronamelist + url.daycache;
    			return UDIP.loadjsonobject(keywordurl, {});
    		}
    	};
    })

    //楼盘列表
    .factory('PropertyListFactory', function ($resource, $rootScope, url) {
        var searchurl_property = url.search.property;
        var searchurl_community = url.search.community;
        var linktype = 1;
        // 用来存储话题类别的数据结构，包含了下一页、是否有下一页等属性
        var property = {
            'hasNextPage': true,
            'data': []
        }, comprolabel;
        var params = {
            keyword: '',
            areaid: '',
            price: '',
            room: '',
            labelid: '',
            propertytype: '',
            log: '',
            lat: '',
            page: 1
        };
        var resource = $resource(searchurl_property, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        function loadComprolabel() {
            var comprourl = url.search.comprolabelonly + url.hourcache;
            $resource(comprourl, {}, {query: {cache: true}}).query({}, function (r) {
                comprolabel = [{title: '全部', labelid: -1}];
                comprolabel = comprolabel.concat(linktype == 1 ? r.propertylabel : r.communitylabel);
                $rootScope.$broadcast('comprolabel.updated');
            }, function (e) {
				$rootScope.alert('加载失败!');
			});
        }

        function query() {
            var hasNextPage = property.hasNextPage;
            var portalsData = property.data;
            if (params.page == 1) {
                portalsData = [];
            }
            resource.query(params, function (r) {
                if (params.page == 1) {
                    portalsData = r.list;
                } else {
                    portalsData = portalsData.concat(r.list);
                }
                params.page++;
                hasNextPage = !r.isover;
                property = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };

                $rootScope.$broadcast('propertylist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');

            });
        }

        return {
            params: params,
            initParams: function (t,p) {
                params.areaid = p.areaid;
                params.propertytype = p.propertytype;
                params.price = p.price;
                params.labelid = p.labelid;
                params.lat = p.lat;
                params.log = p.log;
                params.page = 1;
                params.json = true;
                property.hasNextPage = true;
                if (t == 2) {
                    linktype = 2;
                    resource = $resource(searchurl_community, {}, {
                        query: {
                            method: 'get',
                            timeout: 20000
                        }
                    });
                } else if(t == 1) {
                    linktype = 1;
                    resource = $resource(searchurl_property, {}, {
                        query: {
                            method: 'get',
                            timeout: 20000
                        }
                    });
                }
            },
            loadPropertyList: function () {
                var hasNextPage = true;   //是否有下一页
                query();
            },
            loadComprolabel: loadComprolabel,
            getPropertyList: function () {
                if (property === undefined) {
                    return false;
                }
                return property.data;
            },
            getComprolabel: function () {
                return comprolabel;
            },
            hasNextPage: function () {
                if (property === undefined) {
                    return false;
                }
                return property.hasNextPage;
            }
        };
    })

    //楼盘详情
    .factory('PropertyDetailFactory', function ($resource, $rootScope,$timeout, url) {
        var APIUrl = url.property.detail,
            priceAPIUrl = url.property.price,
            niaokanUrl = url.property.niaokan,
            footprintUrl = url.property.footprint,
            savekftUrl = url.mem.savekft,
            countkftUrl = url.mem.countkft,
            visitUrl = url.property.visitproperty,
            detail, price, niaokan, kftcount,returnMsg;
        var resource = $resource(APIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var niaokanResource = $resource(niaokanUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var priceResource = $resource(priceAPIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var countkftResource = $resource(countkftUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var savekftResource = $resource(savekftUrl, {}, {
            save: {
                method: 'post',
                timeout: 20000
            }
        });
        var visitResource = $resource(visitUrl, {}, {
            query: {
                method: 'post',
                timeout: 20000
            }
        });
        function visit(propertyid) {
            visitResource.query({
                linkid: propertyid,
                linktype: 1,
                operation: 1
            });
        }
        return {
            saveKft: function(info){
                savekftResource.save({}, info,function(r){
                    returnMsg = r;
                    $rootScope.$broadcast('saveKft.completed');
                });
            },
            getMsg: function() {
                return returnMsg;
            },
            loadKftCount: function(){
                countkftResource.query({}, function(r){
                    kftcount = r.count;
                    $rootScope.$broadcast('KftCount.updated');
                });
            },
            get: function (propertyid, siteid, success) {
                //resource.post.params.propertyid = proeprtyid;
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (response) {
                    detail = response;
                    priceResource.query({
                        propertyid: propertyid,
                        siteid: siteid,
                        json: true
                    }, function (response) {
                        price = response;
                        niaokanResource.query({
                            propertyid: propertyid,
                            siteid: siteid,
                            json: true
                        },function (r) {
                                niaokan = r;
                                if (success) {
                                    success();
                                } else {
                                    $rootScope.$broadcast('PropertyDetail.updated' + propertyid);
                                }
                                visit(propertyid);
                                }, function (e) {
							$rootScope.alert('加载失败!');
						});
                    });
                });
            },
            getKftCount: function() {
                return kftcount;
            },
            getPrice: function () {
                return price;
            },
            getDetail: function () {
                return detail;
            },
            getNiaokan: function () {
                return niaokan;
            },
            saveFootprint: function (linkid, linktype, siteid) {
                $resource(footprintUrl, {}, {
                    query: {
                        method: 'get',
                        timeout: 20000
                    }
                }).query({
                    linkid: linkid,
                    linktype: linktype,
                    siteid: siteid,
                    uuid: localStorage.uuid,
                    openid: localStorage.openid
                }, function (response) {
                  //  console.log('footprint saved');
                });
            }
        };

    })

    //楼盘鸟瞰
    .factory('PropertyNiaokanFactory', function ($resource, $rootScope, url) {
        var APIUrl = url.property.detail,
            niaokanUrl = url.property.niaokan,
            detail,niaokan;
        var resource = $resource(APIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var niaokanResource = $resource(niaokanUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (propertyid, siteid) {
                //resource.post.params.propertyid = proeprtyid;
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (response) {
                    detail = response;
                    niaokanResource.query({
                        propertyid: propertyid,
                        siteid: siteid,
                        json: true
                    },function (r) {
                        niaokan = r;
                        $rootScope.$broadcast('PropertyNiaokan.updated');
                    }, function (e) {
                        $rootScope.alert('加载失败!');
                    });
                });
            },
            getDetail: function () {
                return detail;
            },
            getNiaokan: function () {
                return niaokan;
            }
        };

    })

    //楼盘房价详情
    .factory('PropertyPropertyPriceFactory', function ($resource, $rootScope, url) {
        var APIUrl = url.property.detail,
            priceAPIUrl = url.property.price,
            detail, price;
        var resource = $resource(APIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var priceResource = $resource(priceAPIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (propertyid, siteid) {
                //resource.post.params.propertyid = proeprtyid;
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (response) {
                    detail = response;
                    priceResource.query({
                        propertyid: propertyid,
                        siteid: siteid,
                        json: true
                    }, function (response) {
                        price = response;
                        $rootScope.$broadcast('PropertyPrice.updated');
                    });
                });
            },
            getPrice: function () {
                return price;
            },
            getDetail: function () {
                return detail;
            }
        };

    })

    //楼盘动态详情
    .factory('PropertyNewsFactory', function ($resource, $rootScope, url) {
        var newsUrl = url.property.news;
        var detailUrl = url.property.detail;
        var detail;
        var property = {
            'hasNextPage': true,
            'data': []
        }

        var params = {
        }

        var resource = $resource(newsUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        function query() {
            var hasNextPage = property.hasNextPage;
            var portalsData = property.data;
            if (params.page == 1) {
                portalsData = [];
            }
            resource.query(params, function (r) {
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                property = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
                $rootScope.$broadcast('PropertyNews.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        return {
            initParams: function (propertyid, siteid) {
                params.propertyid = propertyid;
                params.siteid = siteid;
                params.page=1;
                params.json = true;
                property.hasNextPage = true;
            },
            loadNews: function () {
                query();
            },
            getNews: function () {
                if (property === undefined) {
                    return false;
                }
                return property.data;
            },
            hasNextPage: function () {
                if (property === undefined) {
                    return false;
                }
                return property.hasNextPage;
            },
            loadDetail: function (propertyid, siteid) {
                detailResource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    detail = r;
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //楼盘户型详情
    .factory('PropertyHousetypeFactory', function ($resource, $rootScope, url) {
        var housetypeUrl = url.property.housetype;
        var housetype;
        var detailUrl = url.property.detail;
        var detail;
        var resource = $resource(housetypeUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        return {
            get: function (propertyid, siteid) {
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    housetype = r.list;
                    $rootScope.$broadcast('PropertyHousetype.updated');
                });
            },

            getHousetype: function () {
                return housetype;
            },
            loadDetail: function (propertyid, siteid) {
                detailResource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    detail = r;
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //楼盘相册详情
    .factory('PropertyPhotoFactory', function ($resource,$timeout, $rootScope, url) {
        var photoUrl = url.property.detail;
        var photo = '';
        var detail;
        var resource = $resource(photoUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (propertyid, siteid) {
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                        detail = r;
                        photo = r.albumlist;
                        $rootScope.$broadcast('PropertyPhoto.updated');
                    }, function (e) {
						$rootScope.alert('加载失败!');
					});
            },
            getPhoto: function () {
                return photo;
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //楼盘配套详情
    .factory('PropertyPropertyMapFactory', function ($resource, $rootScope, url) {
        var propertyUrl = url.property.detail;
        var mapDetail = '';
        var resource = $resource(propertyUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (propertyid, siteid) {
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    mapDetail = r.cohProperty;
                    $rootScope.$broadcast('PropertyMap.updated');
                });
            },
            getMap: function () {
                return mapDetail;
            }
        }
    })

    //楼盘可售房源列表
    .factory('PropertySellhouseFactory', function ($resource, $timeout, $rootScope, url) {
        var sellhouseUrl = url.property.sellhouse;
        var detailUrl = url.property.detail;
        var detail = '';
        var houselist = {
            'hasNextPage': true,
            'data': []
        };
        var housepropertyname;
        var params = {
            propertyid: '',
            siteid: '',
            buildingid: '',
            housetype: '',
            area: '',
            page: 1
        };
        var resource = $resource(sellhouseUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        function query() {
            var hasNextPage = houselist.hasNextPage;
            var portalsData = houselist.data;
            if (params.page == 1) {
                portalsData = [];
            }
            resource.query(params, function (r) {

            	housepropertyname = r.propertyname;
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                houselist = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };

                $rootScope.$broadcast('PropertySellhouse.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');

            });
        }

        return {
            loadFristHouseList: function (searchParms) {
            	params = {
                    propertyid: searchParms.propertyid,
                    siteid: searchParms.siteid,
                    buildingid: searchParms.buildingid,
                    housetype: searchParms.housetype,
                    area: searchParms.area,
                    page: 1
                };
                var hasNextPage = true;   //是否有下一页
                query();
            },
            loadHouseList:function (){
            	 query();
            },
            getHouseList: function () {
                if (houselist === undefined) {
                    return false;
                }
                return houselist.data;
            },
            getPropertyname: function () {
            	return housepropertyname;
            },
            hasNextPage: function () {
                if (houselist === undefined) {
                    return false;
                }
                return houselist.hasNextPage;
            },
            resetlist: function () {
                houselist = {
                    'hasNextPage': true,
                    'data': []
                };
            },
            loadDetailResource: function (parms) {
                detailResource.query({
                    propertyid: parms.propertyid,
                    siteid: parms.siteid,
                    json: true
                }, function (r) {
                        detail = r;
                    //初始化查询结束，通知页面做页面加载
                        $rootScope.$broadcast('PropertySellhouseInit.updated');
                    }, function (e) {
						$rootScope.alert('加载失败!');
					});
            },
            getDetail: function () {
                return detail;
            }
        };
    })

    //楼盘出售房源详情
    .factory('PropertySellhousedetailFactory', function ($resource, $rootScope, url) {
        var selldetailUrl = url.property.sellhousedetail;
        var info = '';
        var allmessage = '';
        var detailUrl = url.property.detail;
        var detail = '';
        var resource = $resource(selldetailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        return {
            get: function (propertyid,siteid,houseid) {
                resource.query({
                    propertyid:propertyid,
                    siteid:siteid,
                    showid: houseid,
                    json: true
                }, function (r) {
                    allmessage = r;
                    info = r.house;
                    $rootScope.$broadcast('PropertySellhousedetail.updated');
                });
            },
            getAll: function () {
                return allmessage;
            },
            getInfo: function () {
                return info;
            },
            loadDetail: function (propertyid, siteid) {
                detailResource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    detail = r;
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //楼盘评论详情
    .factory('PropertyCommentFactory', function ($resource, $rootScope, url) {
        var commUrl = url.property.comm;
        var savecommUrl = url.property.savecomm;
	    var savecommreplayUrl = url.property.savecommreplay;
        var savecommzanUrl = url.property.savecommzan;
        var message = '';
        var messageall = '';
        var detailUrl = url.property.detail;
        var detail = '';
        var resource = $resource(commUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var msg;
        var saveResource = $resource(savecommUrl, {}, {
            save: {
                method: 'post',
                cache: true,
                timeout: 20000
            }
        });

        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (propertyid, siteid) {
                resource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    message = r.list;
                    messageall = r;
                    $rootScope.$broadcast('PropertyComment.updated');
                }, function (e) {
                    $rootScope.alert('加载失败!');
                });
            },
            getMessage: function () {
                return message;
            },
            getMessageAll: function () {
                return messageall;
            },
	        saveComment: function (comment) {
		        saveResource.save({
			        uuid : localStorage.uuid,
			        openid : localStorage.openid
		        }, comment, function (r) {
			        msg = r;
			        $rootScope.$broadcast('PropertyCommentSave.submitted');
		        });
	        },
	        saveCommentreplay: function (comment) {
		        $resource(savecommreplayUrl, {}, {
			        save: {
				        method: 'post',
				        cache: true,
				        timeout: 20000
			        }
		        }).save({
			        uuid : localStorage.uuid,
			        openid : localStorage.openid
		        }, comment, function (r) {
			        msg = r;
			        $rootScope.$broadcast('PropertyCommentSave.submitted');
		        });
	        },
            savecommzan: function (commentid, gbtype) {
                var can_zan = true;
                var zanliststr = localStorage.property_comment_zan_list;
                var zanlist = new Array();
                if (zanliststr) {
                    var zanlist = JSON.parse(zanliststr);
                    for (var i in zanlist) {
                        if (zanlist[i] == commentid) {
                            can_zan = false;
                            break;
                        }
                    }
                }
                if (can_zan) {
                    $resource(savecommzanUrl, {}, {
                        save: {
                            method: 'post',
                            cache: true,
                            timeout: 20000
                        }
                    }).save({
                        uuid : localStorage.uuid,
                        commentid: commentid,
                        gbtype: gbtype
                    }, function (r) {
                        if (r.flag) {
                            zanlist.push(commentid);
                            localStorage.property_comment_zan_list = JSON.stringify(zanlist);
                            $rootScope.$broadcast('PropertyComment.zan', commentid, gbtype);
                        }
                    });
                } else {
                    $rootScope.alert('你已经点评过这条评论了');
                }
            },
            getMsg: function () {
                return msg;
            },
            loadDetail: function (propertyid, siteid) {
                detailResource.query({
                    propertyid: propertyid,
                    siteid: siteid,
                    json: true
                }, function (r) {
                    detail = r;
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //小区详情
    .factory('PropertyCommunitydetailFactory', function ($resource, $rootScope, url) {
        var detailUrl = url.property.detail;
        var priceUrl = url.property.price;
        var footprintUrl = url.property.footprint;
        var detail = '';
        var price = '';
        var resource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var priceResource = $resource(priceUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (linktype, communityid) {
                resource.query({
                    linktype: linktype,
                    communityid: communityid,
                    json: true
                }, function (r) {
                    detail = r;
                    priceResource.query({
                        linktype: linktype,
                        communityid: communityid,
                        json: true
                    }, function (r) {
                        price = r;
                        $rootScope.$broadcast('PropertyCommunitydetail.updated');
                    });
                });
            },
            getDetail: function () {
                return detail;
            },
            getPrice: function () {
                return price;
            },
            saveFootprint: function (linkid, linktype, siteid) {
                $resource(footprintUrl, {}, {
                    query: {
                        method: 'get',
                        timeout: 20000
                    }
                }).query({
                    linkid: linkid,
                    linktype: linktype,
                    siteid: siteid,
                    uuid: localStorage.uuid,
                    openid: localStorage.openid
                }, function (response) {
                //    console.log('footprint saved');
                });
            }
        }
    })

    //楼盘房价详情
    .factory('PropertyCommunityPriceFactory', function ($resource, $timeout , $rootScope, url) {
        var APIUrl = url.gpfy.communityinfo,
            priceAPIUrl = url.property.price,
            detail, price;
        var resource = $resource(APIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var priceResource = $resource(priceAPIUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (communityid) {
                //resource.post.params.propertyid = proeprtyid;
                resource.query({
                    linktype: 2,
                    xqid: communityid,
                    json: true
                }, function (response) {
                    detail = response;
                    priceResource.query({
                        linktype: 2,
                        communityid: communityid,
                        json: true
                    }, function (response) {
                            price = response;
                            $rootScope.$broadcast('CommunityPrice.updated');
                       }, function (e) {
							$rootScope.alert('加载失败!');
					});
				});
            },
            getPrice: function () {
                return price;
            },
            getDetail: function () {
                return detail;
            }
        };

    })

    //小区相册详情页
    .factory('PropertyCommunityphotoFactory', function ($resource, $timeout, $rootScope, url) {
        var photoUrl = url.property.detail;
        var photo = '';
        var typephoto = '';
        var detail;
        var resource = $resource(photoUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (communityid) {
                resource.query({
                    communityid: communityid,
                    json: true
                }, function (r) {
                        detail = r;
                        photo = r.albumlist;
                        typephoto = r.housetypelist;
                        $rootScope.$broadcast('PropertyCommunityphoto.updated');
                    }, function (e) {
					$rootScope.alert('加载失败!');
				});
            },
            getPhoto: function () {
                return photo;
            },
            getTypephoto: function () {
                return typephoto;
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //小区配套详情页
    .factory('PropertyCommunitymapFactory', function ($resource, $rootScope, url) {
        var communityUrl = url.property.detail;
        var mapDetail = '';
        var resource = $resource(communityUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (linktype, communityid) {
                resource.query({
                    linktype: 2,
                    communityid: communityid,
                    json: true
                }, function (r) {
                    mapDetail = r.community;
                    $rootScope.$broadcast('PropertyCommunityMap.updated');
                });
            },
            getMap: function () {
                return mapDetail;
            }
        }
    })

    //小区出售列表
    .factory('PropertyCommunityselllistFactory', function ($resource, $rootScope,$timeout,Utile, url) {
        var csUrl = url.property.cs;
        var detailUrl = url.property.detail;
        var detail;
        var cs = {
            'hasNextPage': true,
            'data': []
        }

        var params = {
            communityid: '',
            price: '',
            room: '',
            area: '',
            page: 1,
            json:true
        }

        var resource = $resource(csUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        function query() {
            var hasNextPage = cs.hasNextPage;
            var portalsData = cs.data;
            if (params.page == 1) {
                portalsData = [];
            }
            resource.query(params, function (r) {
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                cs = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
                $rootScope.$broadcast('PropertyCommunityselllist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
                $timeout(function () {
                    Utile.loadOrldSuccess();
                }, 500);
            });

        }
        return {
            params: params,
            loadInitCs: function (searchParms) {
                params = {
                    communityid : searchParms.communityid,
                    area : searchParms.area,
                    price : searchParms.price,
                    room : searchParms.room,
                    page: 1
                }
                cs.hasNextPage = true;   //是否有下一页
                // query();
            },
            loadCs: function () {
                query();
            },
            getCs: function () {
                if (cs === undefined) {
                    return false;
                }
                return cs.data;
            },
            hasNextPage: function () {
                if (cs === undefined) {
                    return false;
                }
                return cs.hasNextPage;
            },
            loadDetailResource: function (linktype,parms) {
                detailResource.query({
                    linktype: linktype,
                    communityid: parms.communityid,
                    json: true
                }, function (r) {
                    detail = r;
                    //初始化查询结束，通知页面做页面加载
                    $rootScope.$broadcast('PropertyCommunityselllistdetailInit.updated');
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //小区出售房源详情
    .factory('PropertyCommunityselldetailFactory', function ($resource, $rootScope, url) {
        var houseUrl = url.property.housedetail;
        var detailUrl = url.property.detail;
        var housedetail = '';
        var communitydetail = '';
        var resource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        var houseResource = $resource(houseUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (linktype, communityid, houseid) {
                resource.query({
                    linktype: linktype,
                    communityid: communityid,
                    json: true
                }, function (r) {
                    communitydetail = r;
                    houseResource.query({
                        houseid: houseid,
                        json: true
                    }, function (r) {
                        housedetail = r;
                        $rootScope.$broadcast('PropertyCommunityselldetail.updated');
                    });
                });
            },
            getDetail: function () {
                return communitydetail;
            },
            getHouse: function () {
                return housedetail;
            }
        }
    })

    //小区出租列表
    .factory('PropertyCommunityrentlistFactory', function ($resource, $rootScope, url) {
        var czUrl = url.property.cz;
        var detailUrl = url.property.detail;
        var detail;
        var cz = {
            'hasNextPage': true,
            'data': []
        }

        var detailResource = $resource(detailUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        var params = {
            communityid: '',
            pr: '',
            hire: '',
            sour: '',
            page: 1,
            json:true
        }


        var resource = $resource(czUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });
        function query() {
            var hasNextPage = cz.hasNextPage;
            var portalsData = cz.data;
            if (params.page == 1) {
                portalsData = [];
            }
            resource.query(params, function (r) {
                portalsData = portalsData.concat(r.list);
                params.page++;
                hasNextPage = !r.isover;
                cz = {
                    'hasNextPage': hasNextPage,
                    'data': portalsData
                };
                $rootScope.$broadcast('PropertyCommunityrentlist.updated');
                $rootScope.$broadcast('scroll.infiniteScrollComplete');
            });
        }
        return {
            params: params,
            loadInitCz: function (searchParms) {
                params = {
                    communityid : searchParms.communityid,
                    pr : searchParms.pr,
                    hire : searchParms.hire,
                    sour : searchParms.sour,
                    page: 1
                }
                cz.hasNextPage = true;   //是否有下一页
            },
            loadCz: function () {
                query();
            },
            getCz: function () {
                if (cz === undefined) {
                    return false;
                }
                return cz.data;
            },
            hasNextPage: function () {
                if (cz === undefined) {
                    return false;
                }
                return cz.hasNextPage;
            },
            loadDetailResource: function (linktype,parms) {
                detailResource.query({
                    linktype: linktype,
                    communityid: parms.communityid,
                    json: true
                }, function (r) {
                    detail = r;
                    //初始化查询结束，通知页面做页面加载
                    $rootScope.$broadcast('PropertyCommunityrentlistdetailInit.updated');
                });
            },
            getDetail: function () {
                return detail;
            }
        }
    })

    //小区出租房源详情
    .factory('PropertyCommunityrentdetailFactory', function ($resource, $timeout, $rootScope, url) {
        var rentalhouseUrl = url.property.rentalhousedetail;
        var rentalhousedetail = '';
        var resource = $resource(rentalhouseUrl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        return {
            get: function (houseid) {
                resource.query({
                    houseid: houseid,
                    json: true
                }, function (r) {
                        rentalhousedetail = r;
                        $rootScope.$broadcast('PropertyCommunityrentdetail.updated');
                   }, function (e) {
						$rootScope.alert('加载失败!');
				});
            },
            getRentalhouse: function () {
                return rentalhousedetail;
            }
        }
    })

    //楼盘比一比
    .factory('PropertyCompareFactory', function ($resource, $rootScope, url) {
        var detailurl = url.property.detail;
        var list = new Array();
        var cpcount = 0;
        var resource = $resource(detailurl, {}, {
            query: {
                method: 'get',
                timeout: 20000
            }
        });

        function checkloaded() {
            if (list.length == cpcount) {
                $rootScope.$broadcast('cplist.updated');
            }
        }
        return {
            loadlist: function (cplist) {
                cpcount = cplist.length;
                list = new Array();
                //resource.post.params.propertyid = proeprtyid;
                for (i in cplist) {
                    if (cplist[i].cptype == 1) {
                        resource.query({
                            json: true,
                            linktype: 1,
                            propertyid: cplist[i].cpid,
                            siteid: cplist[i].cpsid
                        }, function (response) {
                            list.push(response.cohProperty);
                            checkloaded();
                        });
                    } else {
                        resource.query({
                            json: true,
                            linktype: 2,
                            communityid: cplist[i].cpid
                        }, function (response) {
                            list.push(response.community);
                            checkloaded();
                        });
                    }
                }
            },
            getcplist: function () {
                return list;
            }
        };

    })
    //720全景
    .factory('PropertyView720Factory', function ($resource, $rootScope, url) {
    	var view720url = url.property.view720;
    	var view720list;
    	return {
    		load720list: function (p){
    			$resource(view720url, {}, {query: {method: 'get', timeout: 20000, json: true}}).query({
    				propertyid: p.propertyid,
    				siteid: p.siteid
    			}, function (r) {
    				view720list = r;
    				$rootScope.$broadcast('property.view720.success');
    			});
    		},
    		get720list: function () {
    			return view720list;
    		}
    	}
    })
;
